      SUBROUTINE DUT2(FX,FY,FZ,FZE,NX,NY,TITLE,SMAN,F,NF,C,NC)
C
C   **MEMBER** DUT2
C
      EXTERNAL FX,FY,FZ,FZE
C     LOGICAL*1 TITLE(256)
      CHARACTER*1 TITLE(256)
      REAL SMAN(14)
C
C  THIS IS A GENERAL DISPLAY UTILITY PROGRAM FOR HISTOGRAMS OF 2
C  VARIABLES HAVING RUNNING INDICES I AND J, WHERE
C
C       I RUNS FROM 1 TO NX
C       J RUNS FROM 1 TO NY
C
C   AND FX(I) GIVES THE 'X' VALUE AT BIN I
C       FY(J) GIVES THE 'Y' VALUE AT BIN J
C       FZ(I,J) GIVES THE 'HEIGHT' IN Z AT THE POINT (I,J)
C       FZE(I,J) GIVES THE ERROR IN Z AT THE POINT (I,J)
C
C  TITLE SHOULD SUPPLY AN ARRAY OF TEXT TERMINATING WITH '@' TO BE
C        PRINTED OUT BY DUT2 (80 CHAR MAX). IF '@' IS MISSING, 80
C        CHARACTERS WILL BE PRINTED FROM TITLE.
C
C  SMAN IS A REAL ARRAY WHICH HOLDS MANUAL SCALE FACTORS IF DESIRED.
C       THE ORDER IS XMIN,DX,XTICS,XSUBS,YMIN,DY,YTICS,YSUBS,ZMIN,
C       DZ,ZTICS,ZSUBS,ROT,ELV FOR A NON-SLICE CALL.  IF SLICE IS 1,
C       THEN A SLICED PROJECTION IS MADE BY CALLING DUT1, AND SMAN MUST
C       THEN HAVE THE SCALE FACTORS FOR DUT1 (IF MANUAL SCALES ARE
C       DESIRED).
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomtc.INC'
C
C
      REAL S(14)
      INTEGER DPAK
      DATA DPAK/4HDPAK/
C
C
      IF(DPAK.NE.DPNEW) CALL DPINIT(50000)
C
C       FILL IN DEFAULTS FOR MISSING ARGUMENTS
      NARG=NARGS()
      IF(NARG.LT.0) NARG=7
      DO 5 I=1,14
      IF(NARG.GE.8) S(I)=SMAN(I)
    5 IF(NARG.LT.8) S(I)=ASCALE(I,1)
      KF=0
      KC=0
      IF(NARG.LE.8) GO TO 8
      KF=NF
C..#IFDEF VAX_VMS
#     if defined(__AIX)
      JF= LOC(F)
#     else
      JF=%LOC(F)
#     endif
      IF(JF.EQ.0) KF=0
CC..#ELSE
C     IF(F.EQ.0.) KF=0
C..#ENDIF
      IF(NARG.LE.10) GO TO 8
      KC=NC
C..#IFDEF VAX_VMS
#     if defined(__AIX)
      JC= LOC(C)
#     else
      JC=%LOC(C)
#     endif
      IF(JC.EQ.0) KC=0
CC..#ELSE
C     IF(C.EQ.0.) KC=0
C..#ENDIF
    8 CONTINUE
C
      XSMTH1=XSMTH
      YSMTH1=YSMTH
C
C       SHOULD WE TAKE A SLICE OF THE PICTURE?
C
      IF (SLICE.EQ.0) GO TO 100
      CALL NARGSET(8)
C
C      WE ARE SLICING
C      FILL 1-D SCALE FACTORS FROM 2-D CASE
      DO 10 I=1,4
C      Y GOES INTO X IF SLICING ALONG Y
      IF(SLDIR.NE.0) S(I)=S(I+4)
C      Z GOES INTO Y
   10 S(I+4)=S(I+8)
      CALL DPSLCI(NX,NY)
      IF(SLDIR.NE.0) GO TO 20
      IF(NARG.LE.6) THEN
         CALL DUT1(FX,FZ,FZE,NX,TITLE,S,0.,KF)
      ELSE
         CALL DUT1(FX,FZ,FZE,NX,TITLE,S,F,KF)
      ENDIF
      GO TO 900
C      YSMTH GOES INTO XSMTH
   20 XSMTH=YSMTH
      IF(NARG.LE.6) THEN
         CALL DUT1(FY,FZ,FZE,NY,TITLE,S,0.,KF)
      ELSE
         CALL DUT1(FY,FZ,FZE,NY,TITLE,S,F,KF)
      ENDIF
      GO TO 900
C
C
C       CHECK IF STATISTICS NEEDS TO BE GENERATED
  100 IF(ISTATS.GE.2) CALL DSTAT(2,FX,FY,FZE,FZ,FZE,NX,NY)
C     CALL NARGSET(12)
C
C      MAKE A CHARACTER TITLE
      CALL DPTH2C(TITLE,CTITLE,NT)
C
C      CHECK IF SMOOTHING IS TO BE DONE
      IF(SMOOTH.EQ.0) GO TO 150
      IF(XSMTH.LE.0.) XSMTH=WSMTH*(FX(2,1)-FX(1,1))
      IF(YSMTH.LE.0.) YSMTH=WSMTH*(FY(2,1)-FY(1,1))
C
C       CHECK IF IT IS A GRAPHICS PLOT
C
  150 IF(IDEV.LE.2) GO TO 200
      CALL DPICT(0)
      CALL DPGR2(FX,FY,FZ,FZE,NX,NY,CTITLE(1:NT),S)
      CALL DPICT(1)
      GO TO 900
C
C
C       LINEPRINTER PLOT?
C
  200 IF(IDEV.NE.2) GO TO 300
      IF(NARG.LE. 8) THEN
         CALL DPLP2(FX,FY,FZ,FZE,NX,NY,CTITLE(1:NT),S,0.,KF,0.,KC)
      ELSEIF(NARG.GE.11) THEN
         CALL DPLP2(FX,FY,FZ,FZE,NX,NY,CTITLE(1:NT),S,F,KF,C,KC)
      ELSE
         CALL DPLP2(FX,FY,FZ,FZE,NX,NY,CTITLE(1:NT),S,F,KF,0.,KC)
      ENDIF
      GO TO 900
C
C
C       PUT OTHER OPTIONS IN HERE
C
  300 CONTINUE
      GO TO 900
C
  900 IF(SMOOTH.EQ.0) RETURN
      XSMTH=XSMTH1
      YSMTH=YSMTH1
      RETURN
C
      END
