      SUBROUTINE HCUM1(ID,X,W)
C
C
C  HCUM1 ACCUMMULATES THE VALUE(S) IN W INTO THE HISTOGRAM WITH
C  IDENTIFIER ID INTO A BIN WHICH IS DETERMINED FROM THE VALUE OF X.
C  (THE HISTOGRAM MUST HAVE PREVIOUSLY BEEN DEFINED BY HDEF1).
C
C   A. BOYARSKI,  1978
C
C
      REAL W(*)
      INTEGER HPAK
C
#include      "hcom.INC"
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomfp.INC'
      INCLUDE 'hretcd.INC'
C
      REAL*8 DTEMP,DTEMPX
      EQUIVALENCE (RW,IW),(RW2,IW2)
      LOGICAL LTEMP
      EQUIVALENCE (ITEMP,LTEMP)
C
      DATA HPAK/4HHPAK/
C
      IF(HPNEW.NE.HPAK) CALL HINIT(2000)
      HASHID=MOD(IABS(ID),HSHLEN)
      NH=M(HSHCNT+SHMOFS+HASHID)
      IRETCD=0
      IF(NH.GT.0) GO TO 720
C        The histogram does not exist
      IRETCD=1
      RETURN
C
  720 NODE=M(HSHLOC+SHMOFS+HASHID)+SHMOFS
      DO 740 I=1,NH
      IF(M(NODE+4).EQ.ID) GO TO 750
  740 NODE=M(NODE+1)+SHMOFS
C       IF WE LAND HERE, THERE IS AN INCONSISTANCY IN HASH POINTERS
      IRETCD=2
      RETURN
C
  750 CONTINUE
C
C
C       MAKE SURE THIS IS A 1-D NODE
      ND=M(NODE+5)
      IF(ND.NE.1) GO TO 900
      MPARM=NODE + M(NODE+10)
      MSTATS=NODE + M(NODE+11)
      IOVER=0
      DX=R(MPARM+7)
      IF(DX.LE.0.0) GO TO 105
      XMIN=R(MPARM+6)
      IF(X.LT.XMIN) GO TO 110
      IF(X.GE.R(MPARM+8)) GO TO 120
      IBIN=(X-XMIN)/DX + 1.0
      IBIN=MIN0(IBIN,M(MPARM+5))
      IF(M(NODE+11).GT.0) GO TO 290
      GO TO 500
C
  105 IF(M(MPARM+1).NE.15) GO TO 910
C      ITS A 'LPT' MODE OF STORAGE
      IF(M(NODE+12).LE.0) RETURN
      MBINS=NODE+M(NODE+12)
      IBIN=M(MBINS+1)+1
      IF(IBIN.GT.M(MPARM+5)) IBIN=1
      M(MBINS+1)=IBIN
      M(MBINS+2)=MIN0(M(MPARM+5),M(MBINS+2)+1)
      IF(M(NODE+11).GT.0) GO TO 290
      GO TO 500
C
C       X UNDERFLOW (1-D)
C
  110 IBIN=1
      IOVER=1
      IF(M(NODE+11).EQ.0) GO TO 500
      GO TO 290
C
C       X OVERFLOW (1-D)
C
  120 IBIN=M(MPARM+5)
      IOVER=2
      IF(M(NODE+11).EQ.0) GO TO 500
C
C
C
C------------------------------------------------------------------
C  (ALMOST) COMMON CODE FOR HCUM1.FOR AND HCUM2.FOR
C
C        2-D STATS, 1-D STATS ALSO ENTER HERE
  290 R(MSTATS+4)=AMIN1(R(MSTATS+4),X)
      R(MSTATS+5)=AMAX1(R(MSTATS+5),X)
      IF(M(MSTATS+1).EQ.0) GO TO 292
C       OMIT STATS OUTSIDE OF LIMITS (SET BY SLIMIT IN HOPTN)
C       TEST X
  291 IF(X.LT.R(MSTATS+2).OR.X.GT.R(MSTATS+3)) GO TO 500
  292 DTEMPX=X-R(MSTATS+6)
      MSTAT2=MSTATS/2
      RW=W(1)
      IF(IABS(IW).LT.128) RW=IW
      DTEMP=DTEMPX*RW
      D(MSTAT2+4)=D(MSTAT2+4) + 1.D0
      D(MSTAT2+5)=D(MSTAT2+5) + RW
      D(MSTAT2+6)=D(MSTAT2+6) + DTEMP
      DTEMP=DTEMP*DTEMPX
      D(MSTAT2+7)=D(MSTAT2+7) + DTEMP
C
C
C       ACCUMULATION  (1-D AND 2-D)
C
  500 IF(M(NODE+12).LE.0) RETURN
      MBINS=NODE + M(NODE+12)
C       CHECK IF OVERFLOWS OR ONLY TOTAL CALLS ARE TO BE KEPT
      IF(M(MPARM+3).EQ.0) IOVER=0
C       COUNT NUMBER OF CALLS (AND OVERFLOWS)
      K=M(MPARM+2)+MBINS-IOVER
      M(K)=M(K)+1
C
      MS=M(MPARM+1)
      IF(IOVER.NE.0.AND.MS.NE.15) RETURN
      RW=W(1)
      IF(IABS(IW).LT.128)
     >GO TO (512,522,532,540,550,560,570,580,590,600,
     >       610,590,600,610,620),MS
      GO TO (510,520,530,542,550,560,570,580,590,600,
     >       610,590,600,610,620),MS
      RETURN
C
C       L*1
C
  510 IW=RW+SIGN(.5,RW)
  512 K=4*MBINS+IBIN
      LTEMP=L(K)
      IF(ITEMP.GE.L1MAX) RETURN
      IF(L1MIN.LT.0.AND.ITEMP.LE.L1MIN) RETURN
      ITEMP=MIN0(L1MAX,MAX0(L1MIN,ITEMP+IW))
      L(K)=LTEMP
      RETURN
C
C       I*2
C
  520 IW=RW+SIGN(.5,RW)
  522 K=2*MBINS+IBIN
      ITEMP=H(K)
      IF(IABS(ITEMP).GE.I2MAX) RETURN
      H(K)=MIN0(I2MAX,MAX0(-I2MAX,ITEMP+IW))
      RETURN
C
C       I*4
C
  530 IW=RW+SIGN(.5,RW)
  532 K=MBINS+IBIN
      IF(IABS(M(K)).GE.I4MAX) RETURN
      M(K)=MIN0(I4MAX,MAX0(-I4MAX,M(K)+IW))
      RETURN
C
C       R*4
C
  540 RW=IW
  542 R(MBINS+IBIN)=R(MBINS+IBIN)+RW
      RETURN
C
C       E*4
C
  550 K=MBINS+2*IBIN
      R(K-1)=R(K-1)+W(1)
      R(K)=R(K)+W(2)
      RETURN
C
C       M*4
C
  560 K=MBINS+2*IBIN
      ERR=0.0
      IF(R(K).NE.0) ERR=1.0/R(K)
      T=0.0
      IF(W(2).NE.0.0) T=1.0/W(2)
      IF(T+ERR.NE.0.0) R(K)=1.0/(T+ERR)
      R(K-1)=(T*W(1)+R(K-1)*ERR)*R(K)
      RETURN
C
C       WEV
C
  570 K=MBINS+2*IBIN
      R(K-1)=R(K-1)+W(1)
      R(K)=R(K)+W(1)*W(1)
      RETURN
C
C       A*4
C
  580 K=MBINS+3*(IBIN-1)
      T=W(1)-R(K+1)
      T1=R(K+3)+1.0
      R(K+1)=R(K+1)+T/T1
      IF(R(K+3).GT.0.) R(K+2)=R(K+2)+(T*T/T1-R(K+2)/R(K+3))
      R(K+3)=T1
      RETURN
C
C       EFF  AND  ASM
C
  590 K=MBINS+2*IBIN
      R(K-1)=R(K-1)+RW
      R(K)=R(K)+1.0
      RETURN
C
C       EF2  AND  AS2
C
  600 K=2*MBINS+2*IBIN
      IF(H(K).GE.I2MAX) RETURN
      H(K-1)=H(K-1)+IFIX(W(1)+SIGN(.5,W(1)))
      H(K)=H(K)+1
      RETURN
C
C       EF1  AND  AS1
C
  610 K=4*MBINS+2*IBIN
      LTEMP=L(K)
      IF(ITEMP.GE.L1MAX) RETURN
      ITEMP=ITEMP+1
      L(K)=LTEMP
      LTEMP=L(K-1)
      ITEMP=ITEMP+IFIX(W(1)+SIGN(.5,W(1)))
      L(K-1)=LTEMP
      RETURN
C
C       LPT
C
  620 K=MBINS+2*IBIN
      R(K+1)=X
      R(K+2)=W(1)
      RETURN
C
C------------- END OF COMMON SECTION ---------------------------------
C    ERRORS
C
  900 WRITE(ERUNIT,902) M(NODE+6)
  902 FORMAT(/' HCUM1 CALLED FOR NON-1-D HIST, ID=',A6)
      IRETCD=3
      RETURN
  910 WRITE(ERUNIT,912) M(NODE+6),DX
  912 FORMAT(/' HCUM1 FOR ID',A6,' HAS BAD DX=',E12.3)
      IRETCD=4
      RETURN
C
C
      END
