      SUBROUTINE HGET(ID,IOPT,ND,NB,MO,VMIN,WID,IH,ITIT)
C
C    GIVES THE PARAMETERS OF THE ID'T HISTOGRAM IN /HCOM/.
C  IF IOPT='GET', THEN THE PARAMTERS ARE RETURNED IN THE ARGUMENTS.
C  IF IOPT='PRIN', THEN THE PARAMETERS ARE ONLY PRINTED OUT.
C  IF ID='ALL ', THEN THE PRINTOUT IS DONE FOR ALL HISTOGRAMS.
C
C THIS VERSION EXPECTS CHARACTER IOPT AND TIT, WHILE ITIT IS LOGICAL*1.
C I.E. HGET RETURNS HOLLERITH TITLE, WHILE HGETT RETURNS IT CHARACTER.
C
C
C  RETURN CODES:
C    IRETCD = 0  - SUCCESSFUL OPERATION
C             1  - SPECIFIED ID DOES NOT EXIST
C             2  - ILLEGAL ARGUMENTS
C             3  - THE NODE IS NOT A HISTOGRAM
C             4  - INSUFFICIENT ARGUMENTS FOR RETURNING VALUES.
C
C
#include      "hcom.INC"
      INCLUDE 'dpmode.INC'
      INCLUDE 'hretcd.INC'
C
      INTEGER IOPT
      REAL VMIN(2),WID(2)
      INTEGER NB(2)
      LOGICAL*1 ITIT(256)
      INTEGER HPNTR,ALL
      CHARACTER*4 MSS(16), COPT
      CHARACTER*1 AT,SPACE,PLUS,YES,NO,CC,JSC,JST,CTMP
      CHARACTER*6 SUBNME
C
      DATA ALL/4HALL /
      DATA MSS/'L*1 ','I*2 ','I*4 ','R*4 ','E*4 ','M*4 ','WEV ','A*4',
     >         'EFF ','EF2 ','EF1 ','ASM ','AS2 ','AS1','LPT','BAD'/
C
      DATA AT/'@'/,SPACE/' '/, PLUS/'+'/, YES/'Y'/, NO/'N'/
      DATA SUBNME/'  HGET'/
C
C
    1 NARG=NARGS()
      IF(NARG.LT.0) NARG=2
      IRETCD=0
C
      IF(ID.EQ.ALL) GO TO 100
      IF(NARG.LE.1) GO TO 110
      WRITE(COPT,'(A4)') IOPT
      CALL DPUPPR(COPT)
      IF(COPT.EQ.'PRIN') GO TO 110
      IF(COPT.NE.'GET ') GO TO 450
      IF(HPNTR(ID).LE.0) GO TO 400
      ND=M(NODE+5)
      IF(ND.LT.1.OR.ND.GT.2) GO TO 470
C
C       RETURN PARAMTERS INTO THE ARGUMENTS
      IF(NARG.LT.7) THEN
         IRETCD=4
         RETURN
      ENDIF
C
      MPARM=NODE+M(NODE+10)
      J=M(MPARM+1)
      IF(J.LT.1.OR.J.GT.15) J=16
      READ(MSS(J),'(A4)') MO
      NB(1)=M(MPARM+5)
      VMIN(1)=R(MPARM+6)
      WID(1)=R(MPARM+7)
      IF(ND.LE.1) GO TO 50
      NB(2)=M(MPARM+9)
      VMIN(2)=R(MPARM+10)
      WID(2)=R(MPARM+11)
   50 IF(NARG.GE.8) IH=NODE+M(NODE+12)
      IF(NARG.LE.8) RETURN
C
C       COPY OUT TITLE
      MT=4*(NODE+M(NODE+13))
      MAXTIT=256
      DO 60 I=1,MAXTIT
      WRITE(CTMP,'(A1)') L(MT+I)
      ITIT(I)=L(MT+I)
   60 IF(CTMP.EQ.AT) RETURN
      RETURN
C
C       PRINT OUT THE PARAMETERS
C
  100 IF(NNODES.GT.0) GO TO 104
      WRITE(LPUNIT,101) SUBNME
  101 FORMAT(/,A6,' FOUND NO HISTOGRAMS IN HCOM')
      IRETCD=1
      RETURN
C
  104 WRITE(LPUNIT,105)
  105 FORMAT('1',20X,'DIRECTORY OF HISTOGRAMS IN HCOM',/,
     >  '0  ID',4X,'LOC',2X,'SIZE',3X,'MS ',' SCAT STATS X/Y',
     >       1X,'BINS',3X,'LOWEDGE',7X,'WIDTH',6X,'TITLE')
      NN=NNODES
      NODE=NODE1+SHMOFS
      GO TO 150
C
  110 NN=1
      IF(HPNTR(ID).LE.0) GO TO 400
C
  150 DO 300 INODE=1,NN
      JD=M(NODE+5)
      IF(JD.LT.1.OR.JD.GT.2) GO TO 300
      MPARM=NODE+M(NODE+10)
      JMS=M(MPARM+1)
      IF(JMS.LT.1.OR.JMS.GT.15) JMS=16
      MT=NODE+M(NODE+13)
      IT=M(NODE+14)-M(NODE+13)
  170 N2=M(NODE+3)+SHMOFS - NODE
      IF(N2.LT.0) N2=NODEND+SHMOFS-NODE
      JSC=NO
      IF(JD.EQ.2.AND.M(MPARM+13).GT.0) JSC=YES
      JST=NO
      IF(M(NODE+11).NE.0) JST=YES
      WRITE(LPUNIT,200) M(NODE+6),NODE,N2,MSS(JMS),JSC,JST,M(MPARM+5),
     >                  R(MPARM+6),R(MPARM+7),(M(MT+J),J=1,IT)
  200 FORMAT(/,A5,2X,I5,1X,I5,A6,A4,A5,'    X',1X,I5,2G13.5,2X,14A4,
     >               /(72X,6A4))
      IF(JD.LE.1) GO TO 300
      CC=SPACE
      IF(IT.GT.62.AND.OVPRT.NE.0) CC=PLUS
      WRITE(LPUNIT,210) CC,M(MPARM+9),R(MPARM+10),R(MPARM+11)
  210 FORMAT(A1,33X,'   Y',1X,I5,2G13.5)
C
  300 IF(ID.EQ.ALL) NODE=M(NODE+3)+SHMOFS
      IF(ID.EQ.ALL) CALL HSPACE
      RETURN
C
C       NON-EXISTENT ID
  400 CALL HID2A4(ID,JD)
      WRITE(LPUNIT,410) SUBNME,JD
  410 FORMAT(/,A6,' CANNOT FIND HIST',A5,' IN HCOM')
      IRETCD=1
      RETURN
C
C       ILLEGAL OPTION
  450 WRITE(LPUNIT,460) SUBNME,IOPT
  460 FORMAT(/,A6,' CALLED WITH ILLEGAL OPTION,',A5)
      IRETCD=2
      RETURN
C
  470 WRITE(ERUNIT,480) SUBNME,M(NODE+6)
  480 FORMAT(/,A6,' ABORTED - ID=',A5,' IS NOT A 1- OR 2-D HIST')
      IRETCD=3
      RETURN
C
      END
