      SUBROUTINE HINIT(NWCOM,IHASH,NSCAT,IUNIT)
C
C  **MEMBER** HINIT
C
C  INITIALIZE THE COMMON BLOCK /HCOM/, AND /SCPBUF/.
C  NWCOM SPECIFIES THE SIZE THAT USER HAS DEFINED HCOM TO BE.
C  IHASH  (OPTIONAL) SPECIFIES THE SIZE OF THE HASH TABLE.
C  NSCAT  (OPTIONAL) SPECIFIES THE SIZE OF THE SCATTERPLOT BUFFER
C  IUNIT  (OPTIONAL) SPECIFIES UNIT NUM OF SCATTERPLOT (SCRATCH) FILE
C
#include      "hcom.INC2"
      INCLUDE 'dpmode.INC'
C
      INTEGER HPAK,DPAK,HSHMAT,GETUID
      LOGICAL HSCUNI
      DATA HPAK/4HHPAK/, DPAK/4HDPAK/, KEY/4HHPAK/, IFLAG/'0644'o/
C
      NARG=NARGS()
      IF(NARG.LT.0) NARG=1
C
      ISIZE=NWCOM
C
c     WRITE(ERUNIT,10) ISIZE
   10 FORMAT(/,' HANDYPAK  --  RELEASE 6.59 --  HCOM SIZE =',I8)
#if   defined(__SHARED)
C
C       Some Tricks for Shared-Memory Use
C
      IF (KEY.EQ.HPAK) KEY=KEY+GETUID()
      IADDR=HSHMAT(KEY,ISIZE,IFLAG,ICODE)
      IF (IADDR.NE.-1) GOTO 30
      WRITE(ERUNIT,20)
   20 FORMAT(/,' FAILED TO ALLOCATE SHARED MEMORY')
      IF (ICODE.GT.1000) WRITE(ERUNIT,25) ICODE
   25 FORMAT(/,' MAXIMUM SHARED MEMORY SIZE =',I8)
      IF (ICODE.EQ.13) WRITE(ERUNIT,27)
   27 FORMAT(/,' SEGMENT ALREADY EXISTS.  PERMISSION DENIED')
      STOP
#     if defined(__AIX)
   30 SHMOFS=(IADDR- LOC(M(1)))/4
#     else
   30 SHMOFS=(IADDR-%LOC(M(1)))/4
#     endif
C     SHMOFS=SHMOFS+MOD(SHMOFS,2)
c     IF (SHMOFS.NE.0) WRITE(LPUNIT,35) SHMOFS+1
   35 FORMAT(/,' SHARED MEMORY ALLOCATED TO /HCOM/ M(',I11,'- )')
      IF (ICODE.EQ.0) GOTO 40
c     WRITE(ERUNIT,37) ISIZE
   37 FORMAT(/,' SEGMENT ALREADY EXISTS.  SIZE =',I8)
      goto 100
#endif
C
C       NUMBER OF DEFINED NODES
   40 NNODES=0
C
C       SAVE SIZE AS DEFINED BY USER
      NHCOM=ISIZE
C
C     IHCOM(1)=0	! Used for Offset of Shared-Memory Region
      IHCOM(2)=0
C
C       DEFAULT SIZE OF HASH TABLE
      HSHLEN=137
      IF(NARG.GE.2) HSHLEN=IHASH
C
C       DEFAULT SIZE OF SCATTER PLOT BUFFER
      SCTLEN=100
      IF(NARG.GE.3) SCTLEN=NSCAT
C
C       HASH TABLE STARTS AFTER THE 17 WORD CONTROL AREA
C       HASH COUNT FOLLOWS, THEN SCATTERPLOT BUFFER FOLLOWS.
      HSHLOC=18
      HSHCNT=HSHLOC+HSHLEN
      SCTLOC=HSHCNT+HSHLEN
C
C       THE NODES FOLLOW THE ABOVE, WITH NODE1+1 POINTING TO FIRST
C       WORD OF THE NODE AREA.
C       NODE1 MUST ALSO BE ON AN EVEN WORD BOUNDARY.
      NODE1=SCTLOC+SCTLEN
      NODE1=NODE1+MOD(NODE1,2)
C
C       NODEND IS POINTER TO FREE SPACE AREA (SAME AS NODE1 INITIALLY)
      NODEND=NODE1
C
C       SAVE BACKWARD POINTER TO LAST NODE IN SEQUENCE
      M(NODEND+SHMOFS+1)=NODE1
C
C       NEXT ITEMS DONT MATTER, BUT SET THEM TO 0 ANYWAY
      NODE=0
      HASHID=0
C
C       CLEAR HASH TABLES
      DO 50 I=1,HSHLEN
      M(HSHLOC+SHMOFS+I-1)=0
   50 M(HSHCNT+SHMOFS+I-1)=0
C
      IF(DPNEW.NE.DPAK) CALL DPINIT(50000)
C
C       UNIT NUMBER FOR WRITING OUT SCATTER POINTS TO A FILE
      JUNIT=19
      IF(NARG.GE.4) JUNIT=IUNIT
C       SET SCTUNI IF HSCUNI SAYS THERE IS A SCATTERPLOT FILE.
      SCTUNI=0
      IF(HSCUNI(JUNIT)) SCTUNI=JUNIT
C
C       INITIALIZE USAGE AND FILLED STATUS OF SCATTERPLOT BUFFER
      SCTUSE=-1
      M(SCTLOC+SHMOFS+1)=1
      SCTMAX=2047
      SCTTOT=0
      SCTREC=0
C
C       SET FLAG INDICATING HCOM HAS BEEN INITIALIZED
  100 HPNEW=HPAK
C
      RETURN
C
      ENTRY HSHKEY(JKEY,JFLAG)
      KEY=JKEY
      IFLAG=JFLAG
      RETURN
      ENTRY HSHEXT(JCODE)
      JCODE=ICODE
      RETURN
      END
