      SUBROUTINE HOPTC(ID,COPT,IVAL)
      INTEGER IVAL(*)
C
C  THIS ROUTINE SETS OPTIONS INTO SPECIFIED NODES IN /HCOM/
C  (IF OPT IS NOT RECOGNIZED, THEN THE OPT IS PASSED ON TO HOPTN1)
C
C  RETURN CODES:
C     was   0 IF COPT HAS AN UNKNOWN OPTION,
C     was   1 IF THE OPTION IS LEGAL
C     was   2 IF OPTION IS LEGAL BUT NOT SET (IN HOPTN1)
C
C     IRETCD = 0  successfull operation
C              1  ID does not exist
C              2  Invalid option COPT
C              3  no room in /HCOM/ to make the change
C              4  Invalid operation, no stats block, no hist block,...
C              5  can not redefine scatterplot id
C              6  NCONT option ignored because CONT function undefined
C              7  NFUNC option ignored because FUNC function undefined
C              8  UDATA option ignored because USIZE is 0
C              9  Hist is not 1-D or 2-D.
C             10  GET error, the option has no default to get.
C             11  GET error, the option has not been set.
C
C
#include      "hcom.INC2"
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomfp.INC'
      INCLUDE 'hretcd.INC'
 
      INTEGER KFALT(20),NFALT(20),MFALT(20),IFALT(56)
      REAL DFALT(56)
      EQUIVALENCE (DFALT(1),IFALT(1))
      CHARACTER*4 KOPT(2),OPT,OPTS(20),GETC,CLRC,RESC,ALLC
      CHARACTER*4 COPT(2)
      CHARACTER*2 OPT2
      EQUIVALENCE (OPT,OPT2)
      CHARACTER*1 AT
      CHARACTER*4 CTEMP
      EQUIVALENCE (INTVAL,RVAL)
      INTEGER HPNTR,ALL,HOPTN1
C
      DATA KFALT/ 1,56,2,6,7,8,9,10,12,14,
     >           15,29,49,0,50,51,52,53,54,55/
      DATA NFALT/ 1,1,4,1,1,1,1,2,2,1,
     >           14,20,1,0,1,1,1,1,1,1/
      DATA MFALT/20*0/
      DATA IFALT/56*0/
      DATA OPTS/'STAT','ISOM','SLIM','SOMI','SOUT',
     >          'HBIN','HOMI','HLOW','HWID','HNOR',
     >          'HMSC','TITL','USIZ','UDAT','MTER',
     >          'CONT','NCON','FUNC','NFUN','YALT'/
      DATA GETC/'GET,'/, CLRC/'CLR,'/, RESC/'RES,'/,ALLC/'ALL '/
      DATA ALL/4HALL /, AT/'@'/
C
C
      KOPT(1)=COPT(1)
      KOPT(2)=COPT(2)
      CALL DPUPPR(KOPT(1))
      CALL DPUPPR(KOPT(2))
      OPT=KOPT(1)
      IF(OPT.EQ.GETC.OR.OPT.EQ.CLRC.OR.OPT.EQ.RESC) OPT=KOPT(2)
      IRETCD=0
C
      NARG=NARGS()
      IF(NARG.LT.0) NARG=3
      IDTMP=ID
C
C       DOES THIS HIST EXIST ?
      IF(IDTMP.EQ.ALL .OR. IDTMP.EQ.0) GO TO 5
      IF(HPNTR(IDTMP).GT.0) GO TO 5
      CALL HID2A4(IDTMP,IDATMP)
      WRITE(ERUNIT,4) IDATMP
    4 FORMAT(/,' HOPTN CALLED FOR NON-EXISTENT ID=',A5)
      IF(ITRACE.NE.0) CALL ERRTRA
      IRETCD=1
      RETURN
C
C      FIND INDEX FOR THIS OPTION
    5 DO 10 I=1,20
      IOPT=I
      IF(OPT.EQ.OPTS(I)) GO TO 15
   10 CONTINUE
C
C------- TEST FOR HMSC SUBOPTS  (FOR MHP USE, DOESN'T DO RES OR ALL)
      JJ=INDEX('XMIN DX   XMTI XMSU YMIN DY   YMTI YMSU'//
     >         'ZMIN DZ   ZMTI ZMSU ROTA ELVA ',OPT)
      IF(JJ.GT.0) THEN
      IF(IDTMP.EQ.0.OR.IDTMP.EQ.ALL) RETURN
      IF(HPNTR(IDTMP).LE.0) RETURN
         J=(JJ+4)/5
         MDISP=NODE+M(NODE+14)
         IF(KOPT(1).EQ.GETC) THEN
            IVAL(1)=M(MDISP+7+J)
         ELSE
            M(MDISP+7+J)=IVAL(1)
         ENDIF
         RETURN
      ENDIF
C------- END OF SPECIAL MHP CODE
C
C       THIS OPT IS NOT RECOGNIZED, PASS IT ON TO HOPTN1
   12 ISTAT=HOPTN1(KOPT,IVAL,IDTMP)
C        ISTAT=0 IF OPT NOT RECOGNISED, 1 IF OK, 2 IF NOT SET
      IF((KOPT(1).EQ.CLRC.OR.KOPT(1).EQ.RESC).AND.OPT.EQ.ALLC) GO TO 14
      IF(ISTAT.NE.0) THEN
         IF(ISTAT.EQ.1) IRETCD=0
         IF(ISTAT.EQ.2) IRETCD=11
         RETURN
      ENDIF
      WRITE(ERUNIT,13) OPT
   13 FORMAT(/,' HOPTN CALLED WITH INVALID OPTION -- ''',A4,'''')
      IF(ITRACE.NE.0) CALL ERRTRA
      IRETCD=2
      RETURN
C
   14 IOPT=1
   15 IF(KOPT(1).EQ.GETC) GO TO 1005
      KVAL=0
      IF(IVAL(1).NE.0) KVAL=1
C
C       RE-ENTER HERE FOR NEXT IOPT IF THIS IS A 'RES,ALL ' OPTION
   20 IF(OPT.EQ.ALLC) KVAL=0
      IF(IDTMP.EQ.ALL) GO TO 40
      IF(IDTMP.EQ.0) GO TO 43
      NID=1
      GO TO 50
C
   40 NID=NNODES
      NODE=NODE1+SHMOFS
      IF(KOPT(1).NE.CLRC.AND.KOPT(1).NE.RESC) GO TO 43
C      CLEAR THE DEFAULT SETTING
      MFALT(IOPT)=0
      GO TO 48
C
   43 MFALT(IOPT)=1
      N=NFALT(IOPT)
      IF(N.LE.0) GO TO 48
      K=KFALT(IOPT)
      DO 45 I=1,N
   45 IFALT(K+I-1)=IVAL(I)
   48 IF(NNODES.LE.0.OR.IDTMP.EQ.0) RETURN
C
   50 DO 1000 INODE=1,NID
      ND=M(NODE+5)
      IF(ND.LT.1.OR.ND.GT.2) GO TO 1000
      MPARM=NODE+M(NODE+10)
      MSTAT=NODE+M(NODE+11)
      MDISP=NODE+M(NODE+14)
      NPNTRS=M(NODE+9)
      INTVAL=IVAL(1)
      IF(IABS(INTVAL).LT.128) RVAL=FLOAT(INTVAL)
C
      GO TO (110,120,130,140,150,160,170,180,190,200,
     >       210,220,230,240,250,260,270,280,290,300),IOPT
C
C       'STAT'
  110 IF(IVAL(1).NE.0.AND.(M(NODE+11).GT.0)) GO TO 1000
      IF(IVAL(1).EQ.0.AND.(M(NODE+11).LE.0)) GO TO 1000
C       SIZE OF STATS BLOCK TO BE ADDED OR DELETED
  112 NW=26
      IF(M(NODE+5).EQ.1) NW=14
      IF(IVAL(1).EQ.0) NW=-NW
C      GO MODIFY THE NODE SIZE
      KOFF=2
      GO TO 500
  115 M(NODE+11)=0
C      SET 'SOUT' FLAG ALSO
      MDISP=NODE+M(NODE+14)
      M(MDISP+2)=0
      IF(NW.LT.0) GO TO 1000
      M(MDISP+2)=1
      M(NODE+11)=NODMOD-NODE
C       FILL IN XLIMS,X0 (YLIMS,Y0) IN STATS BLOCK
  116 MSTAT=NODE+M(NODE+11)
      DO 117 I=1,NW
  117 M(MSTAT+I)=0
C       (ENTER HERE ALSO FOR HIST BIN CHANGE - HLOW, HWIDTH)
  118 IF(M(NODE+11).EQ.0) GO TO 1000
      DX=0.0
C      DONT USE EDGE BINS IF HOMIT IS FALSE
      IF(M(MPARM+3).EQ.0) DX=R(MPARM+7)
      R(MSTAT+2)=R(MPARM+6)+DX
      R(MSTAT+3)=R(MPARM+8)-DX
      R(MSTAT+4)=FPMAX
      R(MSTAT+5)=-FPMAX
      R(MSTAT+6)=(R(MSTAT+2)+R(MSTAT+3))/2.0
      IF(ND.NE.2) GO TO 1000
      DY=0.0
C      DONT USE EDGE BINS IF HOMIT IS FALSE
      IF(M(MPARM+3).EQ.0) DY=R(MPARM+11)
      R(MSTAT+16)=R(MPARM+10)+DY
      R(MSTAT+17)=R(MPARM+12)-DY
      R(MSTAT+18)=FPMAX
      R(MSTAT+19)=-FPMAX
      R(MSTAT+20)=(R(MSTAT+16)+R(MSTAT+17))/2.0
      GO TO 1000
C
C       ISOMETRIC FORMAT
  120 M(MDISP+7)=IVAL(1)
      GO TO 1000
C
C       'SLIMIT'
  130 IF(M(NODE+11).LE.0) GO TO 1000
  135 M(MSTAT+2)=IVAL(1)
      M(MSTAT+3)=IVAL(2)
      IF(ND.NE.2) GO TO 1000
      M(MSTAT+16)=IVAL(3)
      M(MSTAT+17)=IVAL(4)
      GO TO 1000
C
C       'SOMIT' (OR OLD HPAK 'EXCLUDE')
  140 IF(M(NODE+11).LE.0) GO TO 1000
  145 M(MSTAT+1)=KVAL
      GO TO 1000
C
C       'SOUT' (OR OLD HPAK 'HSUMS')
  150 M(MDISP+2)=KVAL
      GO TO 1000
C
C      'HBINS'
  160 IF(IVAL(1).NE.0.AND.M(NODE+12).GT.0) GO TO 1000
      IF(IVAL(1).EQ.0.AND.M(NODE+12).LE.0) GO TO 1000
C       GET SIZE OF HISTOGRAM BINS BLOCK
      NW=M(MPARM+2)
      IF(IVAL(1).EQ.0) NW=-NW
      KOFF=3
      GO TO 500
  165 M(NODE+12)=0
      IF(NW.LT.0) GO TO 1000
      M(NODE+12)=NODMOD-NODE
      DO 167 I=1,NW
  167 M(NODMOD+I)=0
      GO TO 1000
C
C       'HOMIT'
  170 IF(M(MPARM+3).EQ.KVAL) GO TO 1000
C       MUST ADD OR DELETE 2 WORDS IF 1-D, 8 WORDS IF 2-D.
C       (FOR THE OVERFLOW STORAGE)
      NW=2
      IF(ND.EQ.2) NW=8
      IF(KVAL.EQ.0) NW=-NW
      IF(M(NODE+12).LE.0) GO TO 118
      KOFF=3
      GO TO 500
  175 MBIN=MIN0(NODMOD,NTO)
      MPARM=NODE+M(NODE+10)
      M(MPARM+3)=KVAL
      M(MPARM+2)=M(MPARM+2)+NW
      M(NODE+12)=MBIN-NODE
      NW=M(MPARM+2)
      DO 177 I=1,NW
  177 M(MBIN+I)=0
      GO TO 118
C
C       'HLOW'
  180 M(MPARM+6)=IVAL(1)
      IF(ND.EQ.2) M(MPARM+10)=IVAL(2)
      GO TO 192
C
C       'HWIDTH'
  190 M(MPARM+7)=IVAL(1)
      IF(ND.EQ.2) M(MPARM+11)=IVAL(2)
C       NEW HIGH BIN LIMITS
  192 R(MPARM+8)=R(MPARM+6)+M(MPARM+5)*R(MPARM+7)
      IF(ND.NE.2) GO TO 118
      R(MPARM+12)=R(MPARM+10)+M(MPARM+9)*R(MPARM+11)
      IF(M(MPARM+13).LE.0) GO TO 118
C       NEW SCATTERPLOT LIMITS
      TEMP1=M(MPARM+5)*R(MPARM+7)
      TEMP2=M(MPARM+9)*R(MPARM+11)
      IF(SCTTOT.LT.SCTMAX.AND.TEMP1*TEMP2.GT.0.) GO TO 196
      WRITE(ERUNIT,195)
  195 FORMAT(' HOPTN -- CANT REDFINE SCATTERPLOT')
      M(MPARM+13)=-1
      IF(ITRACE.NE.0) CALL ERRTRA
      IRETCD=5
      GO TO 118
  196 SCTTOT=SCTTOT+1
      M(MPARM+13)=SCTTOT
      R(MPARM+14)=1024./TEMP1
      R(MPARM+15)=1024./TEMP2
      GO TO 118
C
C       'HNORM'
  200 R(MDISP+1)=RVAL
      GO TO 1000
C
C       'HMSCAL'
  210 NS=8
      IF(ND.EQ.2) NS=14
      DO 212 I=1,NS
  212 M(MDISP+7+I)=IVAL(I)
      GO TO 1000
C
C       'TITLE'
  220 DO 222 I=1,64
      WRITE(CTEMP,'(A4)') IVAL(I)
      NWD=I
      DO 221 J=1,4
  221 IF(CTEMP(J:J).EQ.AT) GO TO 223
  222 CONTINUE
  223 CONTINUE
      NWOLD=M(NODE+14)-M(NODE+13)
      KOFF=4
      NW=NWD-NWOLD
      GO TO 500
  225 MTITL=MIN0(NODMOD,NTO)
      M(NODE+13)=MTITL-NODE
      DO 226 I=1,NWD
  226 M(MTITL+I)=IVAL(I)
      GO TO 1000
C
C       'USIZE'
  230 NW=IVAL(1)-M(NODE+8)
      KOFF=6
      GO TO 500
  235 M(NODE+15)=0
      M(NODE+8)=0
      IF(IVAL(1).LE.0) GO TO 1000
      M(NODE+8)=IVAL(1)
      M(NODE+15)=MIN0(NODMOD,NTO)-NODE
      GO TO 1000
C
C       'UDATA'
  240 IF(M(NODE+15).LE.0) GO TO 246
      MUSER=NODE+M(NODE+15)
      NW=M(NODE+8)
      IF(NW.LE.0) GO TO 246
      DO 242 I=1,NW
  242 M(MUSER+I)=IVAL(I)
      GO TO 1000
  246 WRITE(ERUNIT,247)
  247 FORMAT(' HOPTN -- CANT FILL UDATA CAUSE USIZE=0')
      IRETCD=8
      GO TO 1000
C
C       'MTERR'
  250 R(MDISP+5)=RVAL
      GO TO 1000
C
C       'CONTOUR'
C..#IFDEF VAX_VMS
#     if defined(__AIX)
  260 M(MPARM+16)= LOC(IVAL(1))
#     else
  260 M(MPARM+16)=%LOC(IVAL(1))
#     endif
CC..#ELSE
C 260 M(MPARM+16)=IVAL(1)
C..#ENDIF
      M(MPARM+17)=1
      GO TO 1000
C
C       'NCONTOUR'
  270 IF(M(MPARM+16).NE.0 .OR. INTVAL.EQ.0) GO TO 275
      WRITE(ERUNIT,272) M(NODE+6)
  272 FORMAT(/,' HOPTN ''NCONT'' NOT DONE -- ',
     >         'NO ''CONTOUR'' EXISTS FOR ID=',A4)
      IRETCD=6
      GO TO 1000
  275 M(MPARM+17)=IVAL(1)
      GO TO 1000
C
C       'FUNCTION'
C..#IFDEF VAX_VMS
#     if defined(__AIX)
  280 M(MDISP+3)= LOC(IVAL(1))
#     else
  280 M(MDISP+3)=%LOC(IVAL(1))
#     endif
CC..#ELSE
C 280 M(MDISP+3)=IVAL(1)
C..#ENDIF
      M(MDISP+4)=1
      GO TO 1000
C
C       'NFUNC'
  290 IF(M(MDISP+3).NE.0 .OR. INTVAL.EQ.0) GO TO 295
      WRITE(ERUNIT,292) M(NODE+6)
  292 FORMAT(/,' HOPTN ''NFUNC'' NOT DONE -- ',
     >         'NO ''FUNCTION'' EXISTS FOR ID=',A4)
      IRETCD=7
      GO TO 1000
  295 M(MDISP+4)=IVAL(1)
      GO TO 1000
C
C       'YALT'
  300 M(MDISP+6)=IVAL(1)
      GO TO 1000
C
C
C       THIS SUBPROGRAM EXPANDS OR CONTRACTS THE NODE
C      (NODMOD IS LOCATION AT WHICH NODE IS MODIFIED, AND NW IS
C       THE NUMBER OF WORDS (+ OR -) FROM THAT POINT ON)
C       FIND LOCATION OF THE KOFF'D SUBNODE
  500 DO 504 I=KOFF,NPNTRS
      IF(M(NODE+9+I).LE.0) GO TO 504
      NODMOD=NODE+M(NODE+9+I)
      IF(NW.LT.0) NODMOD=NODMOD-NW
      GO TO 510
  504 CONTINUE
      NODMOD=NODE+M(NODE+7)
      IF(NW.GT.0) GO TO 510
C       SHOULDNT GET HERE -- SOFTWARE BUG
      WRITE(ERUNIT,506) KOFF,NPNTRS
  506 FORMAT('0HOPTN ERROR -- BAD POINTERS',2I8)
      STOP 506
  510 CONTINUE
C       IS AN EXTRA WORD FOR R*8 ALIGNMENT NEEDED
      I8=ISIGN(MOD(IABS(NW),2),(1-2*MOD(M(NODE+7),2)))
      NW1=NW+I8
      NTO=NODMOD+NW
      IF(NW.EQ.0) GO TO 565
      IF(NODEND+NW1.GE.NHCOM) GO TO 800
C
C       LOOP OVER ALL REMAINING NODES AND FIX UP POINTERS
C
      NXTNOD=M(NODE+3)+SHMOFS
      DO 520 I=1,NNODES
      NODE=NXTNOD
      NXTNOD=M(NODE+3)+SHMOFS
      IF(M(NODE+1)+SHMOFS.GE.NODMOD) M(NODE+1)=M(NODE+1)+NW1
  520 IF(M(NODE+3)+SHMOFS.GE.NODMOD) M(NODE+3)=M(NODE+3)+NW1
C      SAVE BACKWARD POINTER VALUE, RESTORE IT AFTER THE SHUFFLE
      NEND=M(NODEND+SHMOFS+1)+SHMOFS
      IF(NEND.GE.NODMOD) NEND=NEND+NW1
C
      NODEND=NODEND+NW1
C
C       COLLAPSE/EXPAND THE NODE
C
      NXT=M(NODE+3)+SHMOFS
      IF(NXT.LE.NODE) NXT=NODEND+SHMOFS
CCC   NXT=NXT-I8
      DO 540 I=NTO,NODEND+SHMOFS
      K=I
      IF(NW.GT.0) K=NODEND+SHMOFS+NTO-I
      IF(K.LT.NXT) GO TO 530
      M(K+1)=M(K+1-NW1)
      GO TO 540
  530 M(K+1)=M(K+1-NW)
  540 CONTINUE
C       NEW NODE SIZE
      M(NODE+7)=M(NODE+7)+NW
C       RESTORE VALUE OF NODEND
      M(NODEND+SHMOFS+1)=NEND-SHMOFS
C
C       FIX POINTERS IN HASH TABLE
C
      DO 550 I=1,HSHLEN
      J=I-1
  550 IF(M(HSHLOC+SHMOFS+J)+SHMOFS.GE.NODMOD)
     &   M(HSHLOC+SHMOFS+J)=M(HSHLOC+SHMOFS+J)+NW1
C
C       FIX UP OFFSETS WITHIN THIS MODIFIED NODE
      DO 560 I=1,NPNTRS
      IOFF=M(NODE+9+I)
      IF(IOFF.EQ.0) GO TO 560
      IF(NODE+IOFF.LT.NODMOD) GO TO 560
      M(NODE+9+I)=M(NODE+9+I)+NW
  560 CONTINUE
C
C       DONE RE-ALLOCATING STORAGE, RETURN
  565 GO TO (115,570,570,570,570,165,175,570,570,570,
     >       570,225,235,570,570),IOPT
C
C       SHOULDNT GET HERE
  570 WRITE(ERUNIT,571) KOPT(1),KVAL,IOPT
  571 FORMAT(' SOFTWARE ERROR IN HOPTN --',A6,I8,I5)
      STOP 571
C
C       INSUFFICIENT SPACE ON HCOM
  800 WRITE(ERUNIT,805) OPT,M(NODE+6)
  805 FORMAT(/,' HOPTN ERROR - NO ROOM IN HCOM FOR',A6,' FOR ID',A5)
      IRETCD=3
C
 1000 IF(IDTMP.EQ.ALL) NODE=M(NODE+3)+SHMOFS
C       IF THIS IS A 'RES,ALL ' OPTION, THEN CYCLE THROUGH ALL IOPTS
      IF(OPT.NE.ALLC) RETURN
      IF(IOPT.GE.20) RETURN
      IOPT=IOPT+1
      GO TO 20
C
C
C
C      'GET,OPTION' HANDLED IN FOLLOWING
C
 1005 IF(IDTMP.NE.0.AND.IDTMP.NE.ALL) GO TO 1015
      N=NFALT(IOPT)
      IF(N.LE.0) THEN
         IRETCD=10
         RETURN
      ENDIF
      K=KFALT(IOPT)
      DO 1010 I=1,N
 1010 IVAL(I)=IFALT(K+I-1)
      IF(IDTMP.EQ.ALL.AND.MFALT(IOPT).EQ.0) IRETCD=11
      RETURN
C
 1015 ND=M(NODE+5)
      IF(ND.LT.1.OR.ND.GT.2) THEN
         IRETCD=9
         RETURN
      ENDIF
      MPARM=NODE+M(NODE+10)
      MSTAT=NODE+M(NODE+11)
      MDISP=NODE+M(NODE+14)
C
      GO TO (1110,1120,1130,1140,1150,1160,1170,1180,1190,1200,
     >       1210,1220,1230,1240,1250,1260,1270,1280,1290,1300),IOPT
C
C       'GET,STAT'
 1110 IVAL(1)=M(NODE+11)
      RETURN
C
C       ISOMETRIC FORMAT
 1120 IVAL(1)=M(MDISP+7)
      RETURN
C
C       'GET,SLIMIT'
 1130 IF(M(NODE+11).LE.0) GO TO 2000
      IVAL(1)=M(MSTAT+2)
      IVAL(2)=M(MSTAT+3)
      IF(ND.NE.2) RETURN
      IVAL(3)=M(MSTAT+16)
      IVAL(4)=M(MSTAT+17)
      RETURN
C
C       'GET,SOMIT'
 1140 IVAL(1)=0
      IF(M(NODE+11).LE.0) GO TO 2000
      IVAL(1)=M(MSTAT+1)
      RETURN
C
C       'GET,SOUT'
 1150 IVAL(1)=M(MDISP+2)
      RETURN
C
C       'GET,HBINS'
 1160 IVAL(1)=M(NODE+12)
      RETURN
C
C       'GET,HOMIT'
 1170 IVAL(1)=M(MPARM+3)
      RETURN
C
C       'GET,HLOW'
 1180 IF(M(NODE+11).LE.0) GO TO 2000
      IVAL(1)=M(MSTAT+4)
      IF(ND.EQ.2) IVAL(2)=M(MSTAT+7)
      RETURN
C
C       'GET,SWIDTH'
 1190 IF(M(NODE+11).LE.0) GO TO 2000
      IVAL(1)=M(MSTAT+5)
      IF(ND.EQ.2) IVAL(2)=M(MSTAT+8)
      RETURN
C
C       'GET,HNORM'
 1200 IVAL(1)=M(MDISP+1)
      RETURN
C
C       'GET,HMSCAL'
 1210 NS=8
      IF(ND.EQ.2) NS=14
      DO 1212 I=1,NS
 1212 IVAL(I)=M(MDISP+7+I)
      RETURN
C
C       'GET,TITLE'
 1220 NW=M(NODE+14)-M(NODE+13)
      MTITL=NODE+M(NODE+13)
      DO 1222 I=1,NW
 1222 IVAL(I)=M(MTITL+I)
      RETURN
C
C       'GET,USIZE'
 1230 IVAL(1)=M(NODE+8)
      RETURN
C
C      'GET,UDATA'
 1240 IF(M(NODE+15).LE.0) GO TO 2400
      MUSER=NODE+M(NODE+15)
      NW=M(NODE+8)
      IF(NW.LE.0) GO TO 2400
      DO 1242 I=1,NW
 1242 IVAL(I)=M(MUSER+I)
      RETURN
C
C       'GET,MTERR'
 1250 IVAL(1)=IFIX(R(MDISP+5))
      RETURN
C
C       'CONTOUR'
 1260 IVAL(1)=M(MPARM+16)
      RETURN
C
C       'NCONTOUR'
 1270 IVAL(1)=M(MPARM+17)
      RETURN
C
C       'FUNCTION'
 1280 IVAL(1)=M(MDISP+3)
      RETURN
C
C       'NFUNC'
 1290 IVAL(1)=M(MDISP+4)
      RETURN
C
C       'YALT'
 1300 IVAL(1)=M(MDISP+6)
      RETURN
C
C
C       MISC ERROR - NO STATS BLOCK, NOT HIST BLOCK,...
 2000 IRETCD=4
      RETURN
C
C
C       UDATA ERROR
 2400 IRETCD=8
      RETURN
      END
