      INTEGER FUNCTION HOPTN1(IOPT,PARM,ID)
C
C   **MEMBER** HOPTN1
C
C  THIS HANDLES THE DISPLAY OPTIONS STORED WITHIN A HISTOGRAM
C  NODE AND ALSO THE DEFAULT VALUES FOR THESE OPTIONS (USED BY HDEF).
C
C  IOPT  IS A STRING SPECIFYING THE OPTION BEING CHANGED.
C           IF OPT = 'GET,...', THEN THE VALUE IS RETURNED.
C           IF OPT = 'RES,...', THEN THE SETTING IS RESET,  SO THAT
C           THIS OPTION IN THIS NODE WILL NOT BE USED.
C           IF OPT = 0, THEN THE DEFAULT ARRAY IS RETURNED IN PARM.
C  PARM  IS THE VALUE(S) FOR THAT OPTION, AND MAY BE LOGICAL,
C           INTEGER, OR REAL, DEPENDING ON THE OPTION.
C           THE DEFAULT STORAGE ARRAY STORES THESE VALUES AS
C           BITS, BYTES, HALFWORDS, OR WORDS, DEPENDING ON THE OPTION.
C  ID    IS THE HISTOGRAM ID FOR WHICH THE OPTION IS TO BE CHANGED.
C           IF ID = 'ALL ', THEN ALL HISTOGRAMS AND THE DEFAULT
C              ARE CHANGED.
C           IF ID = 0, THEN ONLY THE DEFAULT VALUE IS CHANGED.
C
      CHARACTER*4 IOPT(2),OPT,OPTS(68)
      INTEGER PARM(*),HPNTR
C
#include      "hcom.INC"
C
      LOGICAL LTEMP,LALL,LRES,LGET,LPUT,LDF,LID
      EQUIVALENCE (ITEMP,LTEMP,TEMP)
      CHARACTER*4 CTEMP
C
      INTEGER IFALT(16)
      LOGICAL*1 LFALT(1)
      INTEGER*2 I2FALT(1)
      REAL DFALT(1)
      EQUIVALENCE (IFALT(1),LFALT(1),I2FALT(1),DFALT(1))
C
C
C
C OPTS HOLDS ALL THE VALID OPTIONS FOR HOPTN1.  IF ANY ARE
C CHANGED OR RE-ORDERED, THEN BE SURE TO MAKE THE CORRESPONDING
C CHANGE IN THE ITEM ARRAY IN THE HEXEC1 ROUTINE.
C
      INTEGER ALL
      CHARACTER*4 CLR,RES,GET,DEF0,ZAUT,ZLOG,ZZER,NCAL
C
      DATA IFALT/16*0/
      DATA OPTS/
     > 'YLOG','XLOG','Y2LO','YZER','XZER',
     > 'Y2ZE','XOMI','YOMI','HIDE','    ',
     1 'LOWI','CENT','FRAM','OVER','RESC',
     > 'SLIC','SLDI','G2AN','    ','L1SU',
     2 'GRAT','HIST','LSUM','L2CA','L2ZA',
     > 'EJEC','TICD','NCAL','SMOO','NUMF',
     3 '    ','    ','IDEV','YAUT','XAUT',
     > 'Y2AU','XTIC','XSUB','YTIC','YSUB',
     4 'X2TI','X2SU','Y2TI','Y2SU','ZTIC',
     > 'ZSUB','CHAR','2DLI','L2CO','L2SY',
     5 'LLIN','LINE','LCOL','COLO','ERRO',
     > 'PNTS','SLBE','SLWI','WSMO','    ',
     6 'XSIZ','YSIZ','XOFF','YOFF','LMAR',
     > 'RMAR','BMAR','TMAR'/
      DATA CLR,RES,GET/'CLR,','RES,','GET,'/, ALL/4HALL /, DEF0/'DEF0'/
      DATA ZAUT,ZLOG,ZZER,NCAL/'ZAUT','ZLOG','ZZER','#CAL'/
C
C
      OPT=IOPT(1)
      HOPTN1=0
      ITEMP=PARM(1)
      IVAL=0
      IF(LTEMP) IVAL=1
      LGET=.FALSE.
      LRES=.FALSE.
      LPUT=.TRUE.
      IF(OPT.NE.GET) GO TO 20
      LGET=.TRUE.
      GO TO 25
   20 IF(OPT.NE.CLR.AND.OPT.NE.RES) GO TO 30
      LRES=.TRUE.
   25 OPT=IOPT(2)
      LPUT=.FALSE.
C
   30 IF(OPT.NE.DEF0) GO TO 37
C
C TRANSMIT THE ENTIRE DEFAULT ARRAY
C
      DO 35 I=1,16
      IF(LPUT) IFALT(I)=PARM(I)
   35 IF(LGET) PARM(I)=IFALT(I)
      HOPTN1=1
      RETURN
C
C SEARCH THE OPTS LIST FOR THIS OPTION
C
C       ALLOW SOME ALIAS OPTION NAMES
   37 IF(OPT.EQ.ZAUT) OPT=OPTS(34)
      IF(OPT.EQ.ZLOG) OPT=OPTS(1)
      IF(OPT.EQ.ZZER) OPT=OPTS(4)
      IF(OPT.EQ.NCAL) OPT=OPTS(28)
      IF(OPT.EQ.'L2SU') OPT='LSUM'
      DO 40 JOPT=1,68
   40 IF(OPT.EQ.OPTS(JOPT)) GO TO 50
C       THIS OPT IS NOT RECOGNIZED
      RETURN
C
C CALCULATE WORD NUMBER AND POSITION OF USAGE STATUS BIT FOR THIS OPTION
C
   50 KW=(JOPT-1)/32 + 1
      KB=MOD(JOPT-1,32)
C GET MASK WORD WITH A BIT IN POSITION KB, (KB=0=LEFT, 31=RIGHT)
CCC   MASK=ISHFT(1,31-KB)
C REPLACE PREVIOUS STATEMENT WITH NEXT 3, PROFORT COMPILER BUG
      KB32=31-KB
      KB16=MOD(KB32,16)
      MASK=ISHFT(ISHFT(1,KB16),KB32-KB16)
C GET COMPLIMENT OF MASK
      MASK1=-1-MASK
C
C DEFINE SOME CONVENIENT VARIBLES
C
      LALL=ID.EQ.ALL
      LDF=LALL.OR.ID.EQ.0
C
C SET UP LOOP INDEX FOR BELOW
C
      IF(LALL) GO TO 55
      NID=1
      IF(LDF) GO TO 56
      I=HPNTR(ID)
      IF(I.LE.0) RETURN
      IF(M(NODE+5).LT.1.OR.M(NODE+5).GT.2) RETURN
      GO TO 58
   55 NID=MAX(1,NNODES)
   56 NODE=NODE1+SHMOFS
   58 HOPTN1=1
C
C MODIFY THE NODE(S), AND/OR THE DEFAULT ARRAY
C
      DO 400 INODE=1,NID
      ND=M(NODE+5)
      LID=(ID.NE.0).AND.(NNODES.GT.0).AND.(ND.EQ.1.OR.ND.EQ.2)
      IF(NNODES.LE.0) GO TO 59
      IF(.NOT.LID) GO TO 59
      MOPT=NODE+M(NODE+14)+15
      IF(M(NODE+5).EQ.2) MOPT=MOPT+6
C
   59 IF(.NOT.LRES) GO TO 60
C
C THIS IS A CLEAR OPERATION, SO WE ONLY MODIFY STATUS BIT.
C THE CONTENTS OR VALUE FOR THIS OPTION REMAIN UNCHANGED.
      IF(LDF) IFALT(KW)=IAND(IFALT(KW),MASK1)
      IF(LID) M(MOPT+KW)=IAND(M(MOPT+KW),MASK1)
      GO TO 400
C
   60 IF(.NOT.LPUT) GO TO 65
C
C THIS IS A PUT OPERATION. MODIFY STATUS BIT HERE, OPTION VALUE LATER.
      IF(LDF) IFALT(KW)=IOR(IFALT(KW),MASK)
      IF(LID) M(MOPT+KW)=IOR(M(MOPT+KW),MASK)
      GO TO 68
C
   65 HOPTN1=0
C
C THIS IS A GET OPERATION. IF STATUS BIT NOT SET FOR THIS OPTION
C THEN RETURN WITH AN ERROR VALUE (2) FOR HOPTN1.
      IF(LDF) HOPTN1=IAND(IFALT(KW),MASK)
      IF(LID.AND..NOT.LDF) HOPTN1=IAND(M(MOPT+KW),MASK)
      IF(HOPTN1.NE.0) GO TO 68
      HOPTN1=2
      RETURN
C
   68 J=JOPT
      HOPTN1=1
C
C WHAT GROUP ? (BIT, BYTE, INTEGER OR REAL DATA)
C
CREAL      IF(J.GT.68) GO TO 250
      IF(J.GT.58) GO TO 200
      IF(J.GT.56) GO TO 150
      IF(J.GT.32) GO TO 100
C
C  HANDLE BIT PARAMETERS HERE
C
      IF(LPUT.AND.LDF) IFALT(4)=IOR(MASK*IVAL,IAND(IFALT(4),MASK1))
      IF(LPUT.AND.LID) M(MOPT+4)=IOR(MASK*IVAL,IAND(M(MOPT+4),MASK1))
      IF(LGET.AND.LDF) LTEMP=IAND(IFALT(4),MASK).NE.0
      IF(LGET.AND.LID) LTEMP=IAND(M(MOPT+4),MASK).NE.0
      GO TO 390
C
C  HANDLE BYTE PARAMETERS HERE
C
  100 J=J-32+16
      IF(LPUT.AND.LDF) LFALT(J)=LTEMP
      IF(LPUT.AND.LID) THEN
C         CHAR option needs special treatment
         IF(JOPT.EQ.47) THEN
            WRITE(CTEMP,'(A4)') LTEMP
            READ(CTEMP,'(A1)') L(4*MOPT+J)
         ELSE
            L(4*MOPT+J)=LTEMP
         ENDIF
      ENDIF
      IF(LGET.AND.LDF) LTEMP=LFALT(J)
      IF(LGET.AND.LID) THEN
C         CHAR option needs special treatment
         IF(JOPT.EQ.47) THEN
            WRITE(CTEMP,'(A1)') L(4*MOPT+J)
            READ(CTEMP,'(A4)') LTEMP
         ELSE
            LTEMP=L(4*MOPT+J)
         ENDIF
      ENDIF
      GO TO 390
C
C  HANDLE HALFWORD INTEGER PARAMETERS HERE
C
  150 J=J-56+20
      IF(LPUT.AND.LDF) I2FALT(J)=ITEMP
      IF(LPUT.AND.LID) H(2*MOPT+J)=ITEMP
      IF(LGET.AND.LDF) ITEMP=I2FALT(J)
      IF(LGET.AND.LID) ITEMP=H(2*MOPT+J)
      GO TO 390
C
C HANDLE HALFWORD (PACKED REAL*1000.) PARAMETERS
C
  200 J=J-58+22
      IF(LPUT.AND.LDF) I2FALT(J)=TEMP*1000.
      IF(LPUT.AND.LID) H(2*MOPT+J)=TEMP*1000.
      IF(LGET.AND.LDF) TEMP=I2FALT(J)/1000.
      IF(LGET.AND.LID) TEMP=H(2*MOPT+J)/1000.
      GO TO 390
C
C HANDLE REAL WORD PARAMETERS (NOT USED)
C
CREAL  250 J=J-68+16
CREAL      IF(LPUT.AND.LDF) DFALT(J)=TEMP
CREAL      IF(LPUT.AND.LID) R(MOPT+J)=TEMP
CREAL      IF(LGET.AND.LDF) TEMP=DFALT(J)
CREAL      IF(LGET.AND.LID) TEMP=R(MOPT+J)
CREAL      GO TO 390
C
C FOR GET OPTIONS, THIS IS ALL WE NEED. OTHERS CONTINUE.
  390 IF(LGET) PARM(1)=ITEMP
C
      IF(LGET.OR.(ID.EQ.0).OR.(NNODES.LE.0)) RETURN
C
  400 IF(LALL) NODE=M(NODE+3)+SHMOFS
C
      RETURN
      END
