      SUBROUTINE HSET1(ID,X,W)
C
C
C  HSET1 STORES THE VALUE(S) IN W INTO THE HISTOGRAM WITH
C  IDENTIFIER ID INTO A BIN WHICH IS DETERMINED FROM THE VALUE OF X.
C  (THE HISTOGRAM MUST HAVE PREVIOUSLY BEEN DEFINED BY HDEF1).
C
C   A. BOYARSKI,  1978
C
C
C  RETURN CODES:
C    IRETCD = 0  - SUCCESSFUL OPERATION
C             1  - HISTORAM DOES NOT EXIST
C             2  - HISTOGRAM NOT 1-D FOR HSET1, OR 2-D FOR HSET2.
C             3  - BAD BIN WIDTH STORED FOR THE HISTOGRAM
C
C
C
      REAL W(2)
      INTEGER HPNTR
      LOGICAL LITEMP
      EQUIVALENCE (ITEMP,LITEMP)
      LOGICAL*1 LTEMP,L4TEMP(4)
C..#IFDEF VAX_VMS
      EQUIVALENCE (LTEMP,L4TEMP(1))
CC..#ELIF PC_F77L
C     EQUIVALENCE (LTEMP,L4TEMP(1))
CC..#ELSE
C     EQUIVALENCE (LTEMP,L4TEMP(4))
C..#ENDIF
C
#include      "hcom.INC"
      INCLUDE 'dpmode.INC'
      INCLUDE 'hretcd.INC'
C
      IRETCD=0
C
      IF(HPNTR(ID).LE.0) THEN
         IRETCD=1
         RETURN
      ENDIF
C
C       MAKE SURE THIS IS A 1-D NODE
  100 IF(M(NODE+5).NE.1) GO TO 900
      MPARM=NODE + M(NODE+10)
      DX=R(MPARM+7)
      IF(DX.LE.0.0) GO TO 105
      XMIN=R(MPARM+6)
      IF(X.LT.XMIN) RETURN
      IF(X.GE.R(MPARM+8)) RETURN
      IBIN=IFIX((X-XMIN)/DX) +1
      GO TO 500
C
  105 IF(M(MPARM+1).NE.15) GO TO 910
C      ITS A 'LPT' MODE OF STORAGE
      IF(M(NODE+12).LE.0) RETURN
      MBINS=NODE+M(NODE+12)
      IBIN=M(MBINS+1)+1
      IF(IBIN.GT.M(MPARM+5)) IBIN=1
      M(MBINS+1)=IBIN
      M(MBINS+2)=MIN0(M(MPARM+5),M(MBINS+2)+1)
      GO TO 500
C
C
      ENTRY HSET2(ID,X,Y,W)
C
C  HSET2 STORES THE VALUE(S) IN W INTO THE HISTOGRAM WITH
C  IDENTIFIER ID INTO A BIN WHICH IS DETERMINED FROM THE VALUES OF
C  X AND Y.  (THE HISTOGRAM MUST HAVE PREVIOUSLY BEEN DEFINED BY HDEF2).
C
      IRETCD=0
C
      IF(HPNTR(ID).LE.0) THEN
         IRETCD=1
         RETURN
      ENDIF
C
C       MAKE SURE THIS IS A 2-D NODE
  200 IF(M(NODE+5).NE.2) GO TO 940
      MPARM=NODE + M(NODE+10)
      DX=R(MPARM+7)
      DY=R(MPARM+11)
      IF(DY.LE.0.0.OR.DX.LE.0.0) GO TO 950
      XMIN=R(MPARM+6)
      YMIN=R(MPARM+10)
      IF(X.LT.XMIN) RETURN
      IF(X.GE.R(MPARM+8)) RETURN
      IBIN=IFIX((X-XMIN)/DX) + 1
      IF(Y.LT.YMIN) RETURN
      IF(Y.GE.R(MPARM+12)) RETURN
      IBIN=IBIN + IFIX((Y-YMIN)/DY)*M(MPARM+5)
C
C
C       STORE THE VALUE  (1-D AND 2-D)
C
  500 IF(M(NODE+12).LE.0) RETURN
      MS=M(MPARM+1)
      MBINS=NODE + M(NODE+12)
      GO TO (510,520,530,540,550,560,570,580,590,600,
     >       610,590,600,610,620),MS
      RETURN
C
C       L*1
C
  510 K=4*MBINS+IBIN
C..#IFDEF VAX_VMS
      ITEMP=MIN0(127,MAX0(-127,IFIX(W(1)+SIGN(.5,W(1)) +200.)-200))
CC..#ELSE
C     ITEMP=MIN0(255,MAX0(0,IFIX(W(1)+SIGN(.5,W(1)) +400.)-400))
C..#ENDIF
      L(K)=LTEMP
      RETURN
C
C       I*2
C
  520 K=2*MBINS+IBIN
      H(K)=MIN0(32767,MAX0(-32767,IFIX(W(1)
     >     +SIGN(.5,W(1))+40000.)-40000))
      RETURN
C
C       I*4
C
  530 K=MBINS+IBIN
      M(K)=IFIX(W(1)+SIGN(.5,W(1)))
      IF(W(1).LT.0.) M(K)=M(K)-1
      RETURN
C
C       R*4
C
  540 R(MBINS+IBIN)=W(1)
      RETURN
C
C       E*4
C
  550 K=MBINS+2*IBIN
      R(K-1)=W(1)
      R(K)=W(2)
      RETURN
C
C       M*4
C
  560 K=MBINS+2*IBIN
      R(K-1)=W(1)
      R(K)=W(2)
      RETURN
C
C       WEV
C
  570 K=MBINS+2*IBIN
      R(K-1)=W(1)
      R(K)=W(1)*W(1)
      RETURN
C
C      A*4
C
  580 K=MBINS+3*(IBIN-1)
      R(K+1)=W(1)
      R(K+2)=W(2)
      R(K+3)=1.0
      RETURN
C
C       EFF  AND  ASM
C
  590 K=MBINS+2*IBIN
      R(K-1)=W(1)
      R(K)=W(2)
      IF(R(K).LE.0.) R(K)=1.
      RETURN
C
C
C       EF2  AND  AS2
C
  600 K=2*MBINS+2*IBIN
      H(K-1)=IFIX(W(1)+SIGN(.5,W(1))+40000.)-40000
      H(K)=IFIX(W(2)+SIGN(.5,W(2))+40000.)-40000
      IF(H(K).LE.0) H(K)=1
      RETURN
C
C       EF1  AND  AS1
C
  610 K=4*MBINS+2*IBIN
      ITEMP=IFIX(W(1)+SIGN(.5,W(1))+400.)-400
      L(K-1)=LTEMP
      ITEMP=IFIX(W(2)+SIGN(.5,W(2))+400.)-400
      IF(ITEMP.LE.0) ITEMP=1
      L(K)=LTEMP
      RETURN
C
C       LPT
C
  620 K=MBINS+2*IBIN
      R(K+1)=X
      R(K+2)=W(1)
      RETURN
C
C
C    ERRORS
C
  900 WRITE(ERUNIT,902) M(NODE+6)
  902 FORMAT(/' HSET1 CALLED FOR NON-1-D HIST, ID=',A6)
      IRETCD=2
      RETURN
  910 WRITE(ERUNIT,912) M(NODE+6),DX
  912 FORMAT(/' HSET1 FOR ID',A6,' HAS BAD DX=',E12.3)
      IRETCD=3
      RETURN
  940 WRITE(ERUNIT,942) M(NODE+6)
  942 FORMAT(/' HSET2 CALLED FOR NON-2-D HIST, ID=',A6)
      IRETCD=2
      RETURN
  950 WRITE(ERUNIT,952) M(NODE+6),DX,DY
  952 FORMAT(/' HSET2 FOR ID',A6,' HAS BAD DX,DY=',2E12.3)
      IRETCD=3
      RETURN
C
C
      END
