      SUBROUTINE HWRITE(ID,LUN,IREW,IREC)
C
C   **MEMBER** HWRITE
C
C
C  WRITES OUT HISTOGRAM(S) FROM /HCOM/ TO A MASS STORAGE DEVICE.
C
C  ID    = IDENTIFIER OF A SINGLE HISTOGRAM TO BE WRITTEN OUT, OR
C          IF ID='ALL ', THEN ALL HISTOGRAMS ARE WRITTEN, OR
C          IF ID=0, ALL THE HISTOGRAMS AND THE HCOM CONTROL AREA
C                   ARE WRITTEN (I.E. /HCOM/ IS OUTPUT IN ONE BLOCK)
C          IF ID IS NOT SUPPLIED, THE DEFAULT IS 0.
C  LUN   = FORTRAN LOGICAL UNIT NUMBER OF OUTPUT FILE, DEFAULT=20
C  IREW  = 0, OUTPUT IS DONE TO NEXT RECORD ON OUTPUT FILE.
C          1, LUN IS REWOUND AND THE OUTPUT IS DONE TO RECORD 1.
C              (1 IS THE DEFAULT).
C  IREC  = (OUTPUT VARIABLE) RECORD NUMBER FOR THIS WRITE. IF ALL
C          HISTOGRAMS ARE OUTPUT, THEY WILL ALL HAVE THIS RECORD NUMBER.
C          EACH CALL TO HWRITE BUMPS THE RECORD NUMBER BY ONE.
C
C
#include      "hcom.INC"
      INCLUDE 'dpmode.INC'
C
        SAVE / DPHEAD /
      COMMON / DPHEAD / IHDR(24)
      CHARACTER*4 IHDR
C
      INTEGER ALL,HPNTR
      DATA ALL/4HALL /
      DATA I1/1/, I0/0/
CC..#IFDEF VM_CMS
C     DATA IMASK/Z3FF00000/
C..#ELIF VAX_VMS
C     DATA IMASK/'3FF00000'X/
CC..#ELSE
      DATA IMASK/Z'3FF00000'/
C..#ENDIF
C
      NARG=NARGS()
      IF(NARG.LT.0) NARG=2
C
      JD=0
      IF(NARG.GE.1) JD=ID
      IUNIT=20
      IF(NARG.GE.2) IUNIT=LUN
C
      JREC=0
C
C       DETERMINE WHETHER TO REWIND FILE OR TO WRITE NEXT RECORD
C
      IF(NARG.LT.3) GO TO 5
      IF(IREW.GT.0) GO TO 5
C
C       WRITE ONTO NEXT RECORD,
CCCC      IF(IREW.EQ.0) GO TO 8
C       OR, APPEND AFTER THE LAST RECORD ON THE FILE/TAPE.
      BACKSPACE IUNIT
      BACKSPACE IUNIT
      READ (IUNIT,END=2,ERR=3) KD,KREC,NWDS,KBLK,NBLK,KMORE
      READ (IUNIT)
      JREC=KREC
      GO TO 8
C       END OF FILE HIT - NO DATA ON THE FILE
    2 BACKSPACE IUNIT
      GO TO 8
C       ERROR ON READING OUTPUT FILE - NO HOPE
    3 WRITE(LPUNIT,4) IUNIT
    4 FORMAT(/' HWRITE ERROR WHILE READING UNIT',I6,'  - ABORTING')
      RETURN
C
C       DO THE REWIND BEFORE WRITING
    5 REWIND IUNIT
C
    8 KSCAT=0
      IF(SCTUNI.EQ.0) GO TO 15
C
C       SCTUSE TELLS STATUS AND USE OF SCATTERPLOT FILE
C        -1  VIRGIN FILE, NOT YET USED.
C         0  READ BACK MODE, FILE POSITION NOT AT ITS END
C         1  COLLECT MODE, FILE SITTING AT ITS END RECORD.
C
      KSCAT=SCTREC
      IF(SCTUSE.EQ.0) GO TO 12
      IF(M(SCTLOC+SHMOFS+1).LE.1) GO TO 10
C      FLUSH OUT THE LAST SCATTERPLOT BLOCK FROM MEMORY
CW    WRITE(SCTUNI) (M(SCTLOC+SHMOFS+I),I=1,SCTLEN)
      CALL HWSBUF
      M(SCTLOC+SHMOFS+1)=1
      SCTREC=SCTREC+1
      KSCAT=SCTREC
C
   10 ENDFILE SCTUNI
   12 REWIND SCTUNI
      SCTUSE=0
C
C
   15 IF(JD.NE.0) GO TO 200
C
C WRITE OUT HCOM IN ONE BLOCK
C AND ALSO DPHEAD AND SCATTERPLOT FILE (IF THERE)
C
      NWDS=NODEND+1
      ISCAT=0
      JREC=JREC+1
      IF(KSCAT.GT.0) ISCAT=1
      WRITE (IUNIT) JD,JREC,NWDS,I1,I1,ISCAT
      WRITE (IUNIT) (M(I+SHMOFS),I=1,NWDS),IHDR
C
C       OUTPUT ALL SCATTERPLOT BLOCKS (IF ANY)
      IF(KSCAT.LE.0) GO TO 100
      ILAST=0
      DO 30 J=1,KSCAT
      READ (SCTUNI,END=50,ERR=40)
     &   (M(SCTLOC+SHMOFS+I),I=1,SCTLEN)
      IF(J.EQ.KSCAT) ILAST=1
      WRITE (IUNIT) JD,JREC,SCTLEN,I0,I0,ILAST
   30 WRITE(IUNIT) (M(SCTLOC+SHMOFS+I),I=1,SCTLEN)
CDBUG      WRITE(LPUNIT,550) KSCAT
C
      GO TO 100
C
   40 WRITE(ERUNIT,45) M(SCTLOC+SHMOFS+1),IFLG,
     >       SCTLEN,MREC,SCTREC,NREAD,
     >       NPTS,MAXPTS
   45 FORMAT(/,' ERROR IN READING SCATTER PLOT SCRATCH FILE',I10,8I5)
      GO TO 100
C
   50 WRITE(ERUNIT,55)
   55 FORMAT(/,' END OF FILE HIT IN SCATTER PLOT SCRATCH FILE')
C
C       DONE COPYING SCATERPLOT FILE TO OUTPUT FILE
  100 IF(SCTUNI.EQ.0) GO TO 105
      M(SCTLOC+SHMOFS+1)=1
      REWIND SCTUNI
C
  105 WRITE (LPUNIT,110) IUNIT,JREC
  110 FORMAT(/' HWRITE HAS DUMPED ALL OF HCOM ON UNIT',I4,
     > ' WITH REC NUM',I5)
C
      GO TO 900
C
C
C       OUTPUT ALL HISTOGRAMS (BUT NOT CONTROL AREA)
C
  200 NN=NNODES
      IF(NN.LE.0) GO TO 910
      IF(JD.NE.ALL) GO TO 300
      NODE=NODE1+SHMOFS
      GO TO 400
C
C       OUTPUT ONLY ONE HISTOGRAM
C
  300 IF(HPNTR(JD).EQ.0) GO TO 910
      NN=1
C
C       COPY OUT ONE (OR ALL) OF THE NODES.
C     BUT FIRST SET FLAG AS TH WHETHER THERE WILL BE SCATTER DATA OR NOT
C
  400 ISCAT=0
      IF(KSCAT.GT.0.AND.SCTUNI.NE.0) ISCAT=1
      JREC=JREC+1
C
      DO 490 INODE=1,NN
      NWDS=M(NODE+7)
      WRITE (IUNIT) M(NODE+4),JREC,NWDS,INODE,NN,ISCAT
      WRITE (IUNIT) (M(NODE+I),I=1,NWDS)
CDBUG      WRITE(LPUNIT,480) M(NODE+6),IUNIT,JREC
CDBUG  480 FORMAT(/' HWRITE WROTE HISTOGRAM ',A5,'  ON UNIT',I4,
CDBUG     >   ' WITH REC NUM',I5)
  490 IF(JD.EQ.ALL) NODE=M(NODE+3)+SHMOFS
C
C      THEN OUTPUT ALL SCATTERPOINTS (FOR ONE OR ALL HISTS)
C
C       NOW READ SCATTERPLOT BLOCKS, IF ANY
      IF(ISCAT.EQ.0) GO TO 650
C
      NSHY=NODEND+1+SCTLEN-NHCOM
      IF(NSHY.GE.0) GO TO 600
C
  525 MEND=NODEND+SHMOFS+1
      M(MEND+1)=1
      ILAST=0
      ISCAT=0
      MPARM=NODE+M(NODE+10)
      IF(JD.NE.ALL) NPLT=ISHFT(M(MPARM+13),20)
C
C      READ SCATTER BLOCKS ONE BY ONE AND OUTPUT POINTS
      DO 540 ISC=1,KSCAT
      READ (SCTUNI,END= 50,ERR= 40)
     &   (M(SCTLOC+SHMOFS+J),J=1,SCTLEN)
      NPTS=M(SCTLOC+SHMOFS+1)
      IF(NPTS.LE.1) GO TO 540
      DO 530 J=2,NPTS
      IF(JD.EQ.ALL) GO TO 527
      IF(IAND(IMASK,M(SCTLOC+SHMOFS+J)).NE.NPLT) GO TO 530
  527 IF(M(MEND+1).LT.SCTLEN) GO TO 528
      WRITE (IUNIT) M(NODE+4),JREC,SCTLEN,I0,I0,ILAST
      WRITE(IUNIT) (M(MEND+I),I=1,SCTLEN)
      M(MEND+1)=1
      ISCAT=ISCAT+1
  528 M(MEND+1)=M(MEND+1)+1
      M(MEND+M(MEND+1))=M(SCTLOC+SHMOFS+J)
  530 CONTINUE
  540 CONTINUE
      ILAST=1
      WRITE (IUNIT) M(NODE+4),JREC,SCTLEN,I0,I0,ILAST
      WRITE(IUNIT) (M(MEND+I),I=1,SCTLEN)
      ISCAT=ISCAT+1
C       LEAVE SCATTERPLOT FILE IN COLLECT MODE
      BACKSPACE SCTUNI
      SCTREC=SCTREC-1
      SCTUSE=1
C
CDBUG      WRITE(LPUNIT,550) ISCAT
CDBUG  550 FORMAT(/' HWRITE WROTE ',I5,' SCATTERPOINT BLOCKS')
      GO TO 650
C
C
C       NOT ENOUGH ROOM TO READ SCATTERPOINTS
  600 WRITE(LPUNIT,601) NSHY
  601 FORMAT(/' HREAD CANT READ IN SCATTER POINTS - HCOM TOO SMALL BY',
     >  I5,' WORDS')
C
  650 WRITE(LPUNIT,655) NN,IUNIT,JREC
  655 FORMAT(/' HWRITE WROTE',I5,' HISTS ON UNIT',I4,' INTO REC NUM',I5)
      GO TO 900
C
C       CLEAN UP OUTPUT FILE (LEAVE IT WITH EOF)
  900 ENDFILE IUNIT
      BACKSPACE IUNIT
C
C       RETURN RECORD NUMBER TO CALLER IF ARG IS THERE
  910 IF(NARG.GE.4) IREC=JREC
C
      RETURN
C
      END
