      SUBROUTINE DFUNC(F,NF,CORNER,FX,FY,FYE,N,NJ)
      REAL CORNER(2,4)
      EXTERNAL F,FX,FY,FYE
C
C   **MEMBER** DFUNC
C
C  DRAWS THE FUNCTION F(X,I) VS X IN THE XY PLANE, WHERE X IS THE
C  X COORDINATE, I IS THE FUNCTION NUMBER (I=1,NF), AND F(X,I) GIVES
C  THE Y VALUE AT X FOR FUNCTION I.
C  ALSO, A SMOOTH CURVE IS DRAWN THROUGH THE DATA POINTS FX,FY
C  IF THE SMOOTHING SIGMA (IN XSMTH) IS GT 0.
C
      INCLUDE 'dpmode.INC'
C
      REAL SMIN(2),SMAX(2),GMIN(2),DGDS(2)
      EQUIVALENCE (XL,SMIN(1)),(YL,SMIN(2)),(XU,SMAX(1)),(YU,SMAX(2)),
     >  (GXMN,GMIN(1)),(GYMN,GMIN(2)),(DGDX,DGDS(1)),(DGDY,DGDS(2))
C
      REAL XDRAW(2),YDRAW(2)
C
      LOGICAL SLCFLG
C
C
      NMAX=NF
      IF(XSMTH.GT.0.) NMAX=NMAX+1
C
C       SET UP LOCAL VARIABLES
      IF(NMAX.LE.0) RETURN
      DO 5 I=1,2
      SMIN(I) = ASCALE(1,I)
      SMAX(I) = SMIN(I) + ASCALE(2,I)*ASCALE(3,I)
C     IF(ILOG(3-I).NE.0) SMAX(I)=SMIN(I)+ASCALE(3,I)
      J=3-I
      IF(ILOG(J).NE.0) SMAX(I)=SMIN(I)+ASCALE(3,I)
      DGDS(I) = (CORNER(I,3) - CORNER(I,1))/(SMAX(I) - SMIN(I))
    5 GMIN(I) = CORNER(I,1) - SMIN(I)*DGDS(I)
C
C       PROTECT AGAINST UNREASONABLE NUMBER OF CURVES
      MAXF=MIN0(25,NMAX)
C
C       DO THE FUNCTIONS, ONE BY ONE
      DO 1000 IFN=1,MAXF
      INVIS = 0
C       SETUP FOR ANALYTIC FUNCTION PLOT
      NSTEP=300
      IF(IFN.LE.NF) GO TO 100
C       SETUP FOR SMOOTHING CURVE INSTEAD
      NSTEP=100
      IDASH=1
      IF(NF.GT.0) IDASH=2
C..#IFDEF DGSYS
      CALL DGSET('DASH',IDASH)
CC..#ELIF GKSYS
C      CALL GSLN(IDASH)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C      SLCFLG IS NEEDED IN DSMTH1
      SLCFLG=(SLFLAG.EQ.0.OR.NJ.GT.1)
C
C       LOOP OVER X IN NSTEP SMALL STEPS
C
  100 DX = (XU-XL)/NSTEP
      JMAX=NSTEP+1
      DO 500 J=1,JMAX
      X = XL + (J-1)*DX
      GX = X*DGDX + GXMN
      IF(ILOG(2).NE.0) X = 10.**X
      IF(IFN.LE.NF) Y = F(X,IFN)
      IF(IFN.GT.NF) Y = DSMTH1(X,FX,FY,FYE,N,SLCFLG)
      IF(ILOG(1).EQ.0) GO TO 400
      IF(Y.GT.0.0) GO TO 350
      Y = YL
      GO TO 400
  350 Y = ALOG10(Y)
  400 Y = AMIN1(YU,AMAX1(YL,Y))
      GY = Y*DGDY + GYMN
  450 IF(INVIS.EQ.1) GO TO 460
      XDRAW(2)=GX
      YDRAW(2)=GY
      INVIS = 1
      GO TO 500
  460 XDRAW(1)=XDRAW(2)
      YDRAW(1)=YDRAW(2)
      XDRAW(2)=GX
      YDRAW(2)=GY
C..#IFDEF DGSYS
      CALL DGLNS(XDRAW,YDRAW,2)
CC..#ELIF GKSYS
C      CALL GPL(2,XDRAW,YDRAW)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
  500 CONTINUE
C
 1000 CONTINUE
C..#IFDEF DGSYS
      CALL DGSET('DASH',0)
CC..#ELIF GKSYS
C      CALL GSLN(1)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
      RETURN
C
      END
