      SUBROUTINE DKSCAL(SMIN,SMAX,SBINS,IFLAG,ISCALE)
C
C  **MEMBER** DKSCAL
C
C  THE INPUTS SMIN AND SMAX DEFINE A RANGE THAT IS TO BE DIVIDED
C  INTO SBINS SEGMENTS OF EQUAL SIZE.  IN ORDER THAT EACH SEGMENT
C  HAVE A VALUE WHICH IS SIMPLE (LIKE 1.0, OR 2.0, OR 5.0 TIMES A
C  POWER OF 10) THE VALUES OF SMIN AND SMAX WILL BE EXPANDED AS
C  NEEDED AND STORED IN AMINS AND AMAXS.
C  NOTE THAT ANY POWER OF 10 TIMES SBINS IS EQUIVALENT TO SBINS.
C            RFLAG = 0 -- BOTH MIN AND MAX ARE VARIABLE
C                    1 -- MIN IS FIXED
C                    2 -- MAX IS FIXED
C  THE FINAL SCALE FACTORS ARE STORED IN ISCALE, WHERE
C    ISCALE(1) -- HAS VALUE OF FIRST TIC ON OR TO LEFT OF ORIGIN
C    ISCALE(2) -- HAS THE SEGMENT VALUE (1, 2, 4, OR 5)
C    ISCALE(3) -- HAS K, THE POWER OF 10
C
      INCLUDE 'dcomfp.INC'
C
      DIMENSION ISCALE(3),VALUES(4)
      DATA VALUES/1.,2.,4.,5./, NVAL /4/
      BINS = SBINS
      IF (SBINS.LE.10.0/9.0) BINS = 10.0
      IF (SMAX-SMIN) 1,3,4
 3    IF (SMAX) 12,10,11
 10   AMAX = 1.0
      AMIN = -1.0
      GO TO 2
 11   AMAX = SMAX + SMAX
      AMIN = 0.
      GO TO 2
 12   AMAX = 0.
      AMIN = SMIN + SMIN
      GO TO 2
 1    AMAX = SMIN
      AMIN = SMAX
      GO TO 2
 4    AMIN = SMIN
      AMAX = SMAX
 2    R = AMAX - AMIN
      DA = R/BINS
      RE = ALOG10(DA)
      IF (RE.LT.0.0) RE = RE - ALMOS1
      IT = IFIX(RE)
      K = IT
      IF ((DA)/(10.0**IT).GT.VALUES(NVAL)) K = IT + 1
      DO 5 I=1,NVAL
      L = I
      IF (VALUES(I).GE.(DA)/(10.**K)) GO TO 6
 5    CONTINUE
C                            NOW HAVE STEP SIZE.
 6    S = VALUES(L)*(10.**K)
      WIDTH = BINS * S
      IF (IFLAG.EQ.0) GO TO 30
      IF (IFLAG.EQ.1) GO TO 20
C                            IFLAG = 2.  MAX IS FIXED.
 9    AMAXS = AMAX
      AMINS = AMAXS - WIDTH
      IF (AMIN.GE.AMINS) GO TO 60
C                            INCREASE STEP SIZE AND TRY AGAIN
 8    L = L + 1
      IF (L.LE.NVAL) GO TO 6
      K = K + 1
      L = 1
      GO TO 6
C                            IFLAG = 1.  MIN IS FIXED.
 20   AMINS = AMIN
      AMAXS = AMIN + WIDTH
C                            DOES IT WORK?
      IF (AMAXS.GE.AMAX) GO TO 60
C                            NOPE.  GO INCREASE STEP SIZE + TRY AGAIN
      GO TO 8
C                            IFLAG = 0.  BOTH MOVEABLE.
 30   IF (AMIN.EQ.0.0) GO TO 20
C                            TEST FOR ANOTHER SIMPLE CASE
      IF (AMIN.LT.0.0 .OR. AMAX.GT.WIDTH) GO TO 32
C                            YES, THIS IS SIMPLE.
      AMINS = 0.0
      AMAXS = WIDTH
      GO TO 60
C                            SEE IF THEY STRADDLE ZERO
 32   IF (AMIN*AMAX.GT.0.) GO TO 35
C                            YES.  SET MIN AT MULT OF 10*STEP
      TENS = 10.*S
      AMINS = TENS*AINT(AMIN/TENS) - TENS
      AMAXS = AMINS + WIDTH
      IF (AMAXS.GE.AMAX) GO TO 60
C                            DIDNT WORK.  TRY MULT OF STEP
      AMINS = S*AINT(AMIN/S) - S
      AMAXS = AMINS + WIDTH
      IF (AMAXS.GE.AMAX) GO TO 60
C                            THAT DIDNT WORK EITHER
      GO TO 8
C                            NOT SIMPLE.  DO THE WHOLE TRIP.
 35   RE = ALOG10(ABS(AMIN))
      IF (RE.LT.0.0) RE = RE - ALMOS1
      IT = IFIX(RE)
C                            IT IS THE POWER OF 10
 40   PLACE = 10.**IT
      DIGITS =AMIN/PLACE
      IF (AMIN.LT.0.0) DIGITS = DIGITS - ALMOS1
C                            REMOVE THE PART LT THE LOW DIGIT
      DIGITS = AINT(DIGITS)
C                            COMBINE DIGITS AND POWER OF TEN
      AMINS = DIGITS*PLACE
      AMAXS = AMINS + WIDTH
C                            DID IT WORK?
      IF (AMAXS.GE.AMAX) GO TO 60
C                            NO.  SHOULD I INCREASE THE STEP?
      IF (IT.LE.K) GO TO 8
C                            NO, USE MORE DIGITS.
      IT = IT - 1
      GO TO 40
C                            ALL DONE. CHECK FOR SWITCH
 60   IF (SMAX.GE.SMIN) GO TO 70
      TEMP = AMINS
      AMINS = AMAXS
      AMAXS = TEMP
C
C                            FILL OUTPUT
   70 ISCALE(1)=IFIX(AMINS/10.**K + SIGN(.5,AMINS))
      ISCALE(2)=IFIX(SIGN(VALUES(L)+.5,AMAXS-AMINS))
      ISCALE(3)=K
C                            ADJUST SO FIRST TIC IS CLOSE TO ORIGIN
   80 TEMP=(ISCALE(1)+ISCALE(2))*10.**K
      IF(ISCALE(2).GE.0 .AND. TEMP.GT.SMIN) RETURN
      IF(ISCALE(2).LE.0 .AND. TEMP.LT.SMIN) RETURN
      ISCALE(1)=ISCALE(1)+ISCALE(2)
      GO TO 80
      END
