      SUBROUTINE DPDGIT(I,IPWR0,IPWR,NDECI)
C
C   **MEMBER** DPDGIT
C
C  TAKES THE NUMBER  J = I*10.**IPWR0  AS INPUT, AND
C  RETURNS A NEW EXPONENT AND NUMBER OF DECIMAL DIGITS
C  IN ORDER TO PRESENT THE NUMBER IN AN ENGINEERING
C  DECIMAL NOTATION (EXPONENTENTS CAN ONLY BE MULTIPLES OF 3).
C    I.E. THE NUMBER J CAN BE FORMATTED AS
C
C  FW.D TIMES 10.**IPWR
C
C  WHERE W=NDIGIT
C        D=NDECI
C      AND IPWR WILL BE A MULTIPLE OF 3
C
      CHARACTER*8 TEMP8
C
C      GET NUMBER OF DIGITS IN THE NUMBER I
      CALL DPITOA(I,TEMP8,NDIGIT,8,10)
C      SET POWER VALUE INTO A MULTIPLE OF 3
      K=NDIGIT+IPWR0-1
      IF(K.LT.0) K=K-2
      IPWR=3*(K/3)
C      BUT BIAS POWER TOWARDS ZERO, IF IT IS NEAR ZERO
C      AND THERE ARE ONLY A FEW DIGITS IN THE VALUE.
      IF(NDIGIT.EQ.1.AND.IPWR0.EQ.-1) IPWR=0
      IF(NDIGIT.LE.2.AND.IPWR0.EQ.-2) IPWR=0
      NDECI=MAX0(0,IPWR-IPWR0)
C      ALSO, ADD 1 FOR DECIMAL POINT IF DECIMALS ARE NEEDED
      IF(NDECI.GT.0) NDECI=NDECI+1
      RETURN
CTEST      END
CTESTC
CTEST      INTEGER J(6)
CTEST      DATA R/1,12,123,1234,12345,123456/
CTEST      REAL*8 A
CTESTC
CTEST      DO 100 NDIGIT=1,6
CTEST      DO 100 I=1,11
CTEST      IPWR0=I-5-NDIGIT
CTEST      IJ=J(NDIGIT)*10.**IPWR0
CTEST      CALL DPDGIT(IJ,IPWR0,IPWR,NDECI)
CTEST      RR=IJ/10.**IPWR
CTEST      CALL DPRTOA(RR,A,NN,8,NDECI)
CTEST      WRITE(6,60) IJ,A,IPWR,NDECI
CTEST   60 FORMAT(1X,I12,2X,'"',A8,'",',I2,I3)
CTEST  100 CONTINUE
CTEST      STOP
      END
