      SUBROUTINE DPGR1(X,Y,YE,N,NF,TITLE,SMAN,F,NAF)
C
C   **MEMBER** DPGR1
C   **ALIAS** DPGRS
C
C
C  DRAWS THE FUNCTION Y(I) VS X(I) WITH (OPTIONAL) ERROR BARS +-YE(I)
C  ABOUT Y(I), FOR I=1,N.
C
C  MULTIPLE FUNCTIONS WILL BE PLOTTED ON SAME PLOT IF NF > 1.
C  THE FUNCTIONS Y(I,J) WILL BE PLOTTED VERSUS X(I,J), FOR J=1,NF.
C
      EXTERNAL X,Y,YE
      CHARACTER*(*) TITLE
      CHARACTER*1 DOLAR,CURLY,SUBT1
      REAL SMAN(8)
C
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomti.INC'
      CHARACTER*255 SUBTI
      EQUIVALENCE (SUBTIT(1),SUBTI)
C
      REAL PLIMIT(4),CORNER(2,5),DLEN(2),XCORN(5),YCORN(5),CORN2(5,2)
      EQUIVALENCE (XCORN(1),CORN2(1,1)),(YCORN(1),CORN2(1,2))
CC..#IFDEF GKSYS
C      REAL WINDOW(4),VIEWPT(4)
C..#ENDIF
      INTEGER CORIDX(2,5)
      INTEGER IMAR(5)
      INTEGER GXMN,GXMX,GYMN,GYMX
      EQUIVALENCE (GXMN,PLIMIT(1)),(GYMN,PLIMIT(2))
     >           ,(GXMX,PLIMIT(3)),(GYMX,PLIMIT(4))
C
C       PLIMIT HOLDS PROGRAMMER GRAPHIC LIMITS,
C       G1MARG IS THE INDENTATION INWARD FROM PLIMITS FOR MARGINS.
C       CORIDX GIVES INDICES WHICH MAP CORNER COORDS TO PLIMITS.
C       IMAR GIVES INDICES WHICH MAP MARGINS TO SIDES.
C
C       ASCALE HOLDS XMIN,DX,XTICS,XSUBS,YMIN,DY,YTICS,YSUBS
C
C       ISCALE HOLDS IXM,IDX,IPWRX,IYM,IDY,IPWRY
C
C
      REAL DIRN2(2),DIRN4(2),TICXY(2),FRAMSZ(2),TAGLOC(4)
      REAL XEXP(2),YEXP(2),TIMARG(4)
C
      REAL LOGTAB(9)
      CHARACTER*8 TEMP8
      EQUIVALENCE (ITEMP,TEMP)
C
      INTEGER JEDGE(2)
      INTEGER IB(2)
C
      CHARACTER*29 KFRAM
      CHARACTER*20 KFONT
      INTEGER TISIDE(4)
      REAL XDRAW(2),YDRAW(2)
      INTEGER DPSCAL,DMMY
C
C
C     THE NUMBERING SCHEME OF THE CORNERS AND SIDES OF THE FRAME IS:
C
C          Y
C          |
C
C        4         3        3
C           --------------
C          |              |
C          |              |
C          |              |
C          |              |
C        4 |              | 2
C          |              |
C          |              |
C          |              |
C          |              |
C           --------------     ------> X
C        1         1        2
C
      DATA DOLAR/'$'/, CURLY/'{'/
      DATA CORIDX/1,2,3,2,3,4,1,4,1,2/
      DATA IMAR/2,3,4,1,2/
      DATA TAGLOC/0.5,0.0,0.5,1.0/
      DATA LOGTAB/0., .30103, .47712, .60206, .69897, .77815,
     >           .84510, .90309, .95424 /
      DATA JEDGE/2*0/
      DATA KFONT/' ID=     HAS NO DATA'/
      DATA KFRAM/' ID=     HAS NO ROOM FOR AXES'/
C       TISIDE GIVES THE SUBTITLE INDEX FOR EACH SIDE
      DATA TISIDE/2,4,1,3/
      DATA IBLANK/4H    /
      DATA TIMARG/.040,.027,-.005,-.013/
      DATA IB/2,1/
C
C
C       TAKE CARE OF SCALING
C
C        OVERPLOTS MAY NOT WANT TO BE RESCALED
      IF(NOVRG.GT.0.AND.RESCAL.EQ.0) GO TO 142
C
      IF(IAUTO(2).NE.0) GO TO 120
      DO 110 I=1,4
  110 ASCALE(I,1)=SMAN(I)
C
  120 ISAVE=SLFLAG
C      TURN OFF SLICE FLAG FOR DPSCAL WHILE SCALING X
      SLFLAG=0
C     CALL DPSCAL(X,N,NF,IAUTO(2),ILOG(2),0,IZERO(2),G1TIC(1,1),
C    >            ASCALE(1,1),ISCALE(1,1),LOWIN)
      DMMY=DPSCAL(X,N,NF,IAUTO(2),ILOG(2),0,IZERO(2),G1TIC(1,1),
     >            ASCALE(1,1),ISCALE(1,1),LOWIN)	! for unix-fortran
      SLFLAG=ISAVE
      IF(IAUTO(1).NE.0) GO TO 140
      DO 130 I=1,4
  130 ASCALE(I,2)=SMAN(I+4)
C 140 CALL DPSCAL(Y,N,NF,IAUTO(1),ILOG(1),IEDGE(1),IZERO(1),
C    >            G1TIC(1,2),ASCALE(1,2),ISCALE(1,2),2)
  140 DMMY=DPSCAL(Y,N,NF,IAUTO(1),ILOG(1),IEDGE(1),IZERO(1),
     >            G1TIC(1,2),ASCALE(1,2),ISCALE(1,2),2)	! for unix-fortran
  142 IENTRY=1
      GO TO 10
C
C
C
      ENTRY DPGRS(TITLE,C,NC)
C
C       THIS ENTRY IS USED FOR SCATTER PLOTS
      IENTRY=2
C
   10 CONTINUE
C
C       GET PROGRAMMER LIMITS
C
C..#IFDEF DGSYS
      CALL DGGET('PLIM',PLIMIT)
CC..#ELIF GKSYS
C      CALL GQCNTN(IGERR,NTRN)
C      CALL GQNT(NTRN,IGERR,WINDOW,VIEWPT)
C      PLIMIT(1)=WINDOW(1)
C      PLIMIT(2)=WINDOW(3)
C      PLIMIT(3)=WINDOW(2)
C      PLIMIT(4)=WINDOW(4)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
C       FILL IN THE COORDINATES OF THE 4 CORNERS (5 IS SAME AS 1)
C       (ADJUST MARGINS IF TITLSZ IS LARGE)
      TISTEP=AMAX1(0.,TITLSZ-1.)
      DO 150 I=1,5
      DO 150 J=1,2
      I1=CORIDX(J,I)
      CORNER(J,I)=PLIMIT(I1) + G1MARG(I1)
      IF(G1MARG(I1).NE.0.0) CORNER(J,I)=CORNER(J,I)+TIMARG(I1)*TISTEP
      CORN2(I,J)=CORNER(J,I)
  150 CONTINUE
C
C       SIZE OF FRAME IN X AND Y
      FRAMSZ(1)=CORNER(1,2)-CORNER(1,1)
      FRAMSZ(2)=CORNER(2,4)-CORNER(2,1)
C
C       UNPACK TITLE INTO THE FOUR SUBTITLES - ONE FOR EACH SIDE
      CALL DPTITL(TITLE,NTITLE,0)
      WRITE(KFONT(5:8),'(A4)') IDA
      IF(IENTRY.EQ.2) GO TO 200
      IF(N.GT.0.OR.NAF.GT.0) GO TO 200
C
C      THIS PLOT HAS NO POINTS
C..#IFDEF DGSYS
      CALL DGTXT(.2,.6,KFONT)
CC..#ELIF GKSYS
C      CALL GTX(.2,.6,KFONT)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      RETURN
C
C
  200 IF(FRAMSZ(1).GT.0.001 .AND. FRAMSZ(2).GT.0.001) GO TO 208
C      FRAME SIZE IS TOO SMALL (OR NEGATIVE)
      WRITE(KFRAM(5:8),'(A4)') IDA
C..#IFDEF DGSYS
      CALL DGTXT(CORNER(1,1),CORNER(2,1),KFRAM)
CC..#ELIF GKSYS
C      CALL GTX(CORNER(1,1),CORNER(2,1),KFRAM)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      RETURN
C
C
  208 IF(ASCALE(2,1).EQ.0. .OR. ASCALE(2,2).EQ.0.) GO TO 900
C
C       FRAME, LABELLED AXES, AND TITLES
C
      IF(FRAME.EQ.0) GO TO 500
C
C      FRAME
C..#IFDEF DGSYS
      CALL DGLNS(XCORN,YCORN,5)
CC..#ELIF GKSYS
C      CALL GPL(5,XCORN,YCORN)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
C       GET SIZE OF HARDWARE CHARACTER, OR USE .025 IF TITLSZ NE 0
C
C       GET X & Y PROGRAMMER UNITS PER DEVICE UNIT (FOR CHAR SIZES)
C..#IFDEF DGSYS
      CALL DGLEN(DLEN)
CC..#ELIF GKSYS
C      DLEN(1)=1.0
C      DLEN(2)=1.0
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      CXMAG=AMAX1(DLEN(2)/DLEN(1),1.0)
      CSIZXL=CSIZX*CXMAG
      CSIZYL=CSIZY
      IF(TITLSZ.EQ.0) GO TO 220
      CSIZXL=(.015+TITLSZ*.01)*CXMAG
      CSIZYL=(.015+TITLSZ*.01)
  220 CONTINUE
C..#IFDEF DGSYS
      CALL DGGET('XSPA',XSPAL)
      CALL DGSET('XSPA',CSIZXL)
CC..#ELIF GKSYS
C      CALL GQCHH(IGERR,XSPAL)
C      CALL GSCHH(CSIZXL)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
C       SET UP COORDS FOR POWER LABELS (FOR LINEAR SCALES)
C
      COFF=.030
      IF(TICDIR.NE.0) COFF=.75*.030
      XEXP(1)=CORNER(1,2)-2.*CSIZXL
      YEXP(1)=CORNER(2,2)-2.3*CSIZYL-COFF/CXMAG
      XEXP(2)=CORNER(1,4)-2.7*CSIZXL-COFF
      YEXP(2)=CORNER(2,4)+1.5*CSIZYL+COFF/CXMAG
C
C       DRAW TIC MARKS
C
C
      DO 450 ISIDE=1,4
C
C       BUT DONT DRAW TIC MARKS OR LABELS IF THERE IS NO MARGIN
C       FOR THIS SIDE
      ITIT=TISIDE(ISIDE)
      IJ=2-MOD(ISIDE,2)
      JI=3-IJ
      IBEG=ISIDE+(ISIDE/3)
      TICS=AMAX1(1.0,ASCALE(3,IJ))
      IPWR=MOD(ISCALE(3,IJ)+500,1000) - 500
      NDECI=(ISCALE(3,IJ)+500)/1000
      FDECI=0.10**MAX0(0,NDECI-1)
      TICMAG=ISCALE(2,IJ)*10.**IPWR*FDECI/ASCALE(2,IJ)
      TICOFF=(ASCALE(1,IJ)/10.**IPWR/FDECI-ISCALE(1,IJ))/ISCALE(2,IJ)
      TICSEP=FRAMSZ(IJ)/TICS*TICMAG
      SUBS=AMAX1(1.0,AINT(ASCALE(4,IJ)))
C
C       FILL TEMPORARY VARIABLES FOR PLOTTING DIRECTIONS OF AXIS AND
C       OF TICS OF THIS SIDE.
      DO 320 I=1,2
      DIRN2(I)=(CORNER(I,IJ+1)-CORNER(I,IJ))/FRAMSZ(I)
  320 DIRN4(I)=(CORNER(I,ISIDE+1)-CORNER(I,ISIDE))/FRAMSZ(I)
C
C       LOOP OVER ALL MAJOR AND MINOR TICS FOR THIS SIDE
      ITMAX=TICS+TICOFF + 1.9999
      MAXCHR=0
C
C       MAJOR TIC LOOP
      DO 410 IT=1,ITMAX
C
      JT=IT-1
      IF(ISIDE.GT.2) JT=ITMAX-IT
      ISUBM=SUBS
      IF(JT.EQ.ITMAX-1) ISUBM=1
      IVAL=ISCALE(1,IJ)
      IF(ILOG(JI).NE.0) GO TO 325
      IVAL=IVAL+JT*ISCALE(2,IJ)
      DTAGY=.0
      GO TO 326
  325 IVAL=IVAL+JT
      DTAGY=.80*CSIZYL
  326 CALL DPRTOA(IVAL*FDECI,TEMP8,NCHR,8,NDECI)
      MAXCHR=MAX0(MAXCHR,NCHR)
C
C       MINOR TIC LOOP (SUB-TICS)
      DO 400 ISUB=1,ISUBM
      ISUB1=ISUB-1
      IF(ISIDE.GT.2) ISUB1=ISUBM-ISUB
      FRACT=ISUB1/SUBS
      IF(ILOG(JI).EQ.0) GO TO 330
      FRACT=LOGTAB(ISUB1+1)
      IF(ISUB1.EQ.1.AND.ISUBM.EQ.2) FRACT=LOGTAB(5)
C
C       FILL BEGINNING COORD OF NEXT TIC
  330 TEMP=JT+FRACT
C
      DO 340 J=1,2
  340 TICXY(J)=CORNER(J,IBEG)+(TEMP-TICOFF)*TICSEP*DIRN2(J)
C
C       IGNORE ANY TICS LOCATED OUTSIDE OF FRAME
      TICCUT=(TICXY(IJ)-CORNER(IJ,ISIDE))*(TICXY(IJ)-CORNER(IJ,ISIDE+1))
      IF(TICCUT.GT.0.001) GO TO 400
C
      TICLEN=.010
      IF(TICDIR.NE.0) TICLEN=-TICLEN
      IF(ISUB1.NE.0) GO TO 380
C       THIS IS A MAJOR TIC
      TICLEN=SIGN(.025,TICLEN)
      COFF=AMAX1(-.75*1.2*TICLEN,1.2*TICLEN)
      COFFY=CSIZYL/CSIZXL*COFF
      IF(ISIDE.EQ.2.OR.ISIDE.EQ.3) GO TO 380
C       DONT PUT UP LABELS IF THERE IS NO MARGIN
      IF(G1MARG(IMAR(ISIDE)).EQ.0.0) GO TO 380
C       DONT PUT UP LAST LABEL IF NEXT SIDE IN SEQUENCE HAS NO MARGIN
      IF(IT.EQ.ITMAX.AND.G1MARG(IMAR(ISIDE+1)).EQ.0.0) GO TO 380
C
C       PUT UP LABEL FOR THIS MAJOR TIC (LEFT AND BOTTOM AXES)
      CXLIN=1.0
      IF(ILOG(JI).NE.0) CXLIN=0.7
      TAGX=TICXY(1)-TAGLOC(ISIDE)*(NCHR-1)*CSIZXL*CXLIN
     >             +(0.7*CXLIN*CSIZXL+COFF)*DIRN4(2)
      TAGY=TICXY(2)-(0.7*CXLIN*CSIZYL+COFFY+DTAGY)*DIRN4(1)
C
      IF(ILOG(JI).EQ.0) GO TO 370
      TAGX=TAGX+0.8*CSIZXL*DIRN4(1)
C..#IFDEF DGSYS
      CALL DGTXT(TAGX-1.85*CSIZXL,TAGY,'10')
      CALL DGGET('XSPA',XSPA)
      CALL DGSET('XSPA',0.7*CSIZXL)
  370 CALL DGTXT(TAGX,TAGY+DTAGY,TEMP8(1:NCHR))
      IF(ILOG(JI).NE.0) CALL DGSET('XSPA',XSPA)
CC..#ELIF GKSYS
C      CALL GTX(TAGX-1.65*CSIZXL,TAGY,'10')
C      CALL GQCHH(IGERR,XSPA)
C      CALL GSCHH(0.7*CSIZXL)
C  370 CALL GTX(TAGX,TAGY+DTAGY,TEMP8(1:NCHR))
C      IF(ILOG(JI).NE.0) CALL GSCHH(XSPA)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
C       DRAW THE TIC (IN OUTWARD DIRECTION IF TICDIR=0)
  380 CONTINUE
C       DON'T PUT OUT TIC STROKE ON AN AXIS
      IF(TICCUT.GE.-0.001) GO TO 400
      IF(G1MARG(IMAR(ISIDE)).EQ.0.0.AND.TICDIR.EQ.0) GO TO 400
      XDRAW(1)=TICXY(1)+TICLEN*DIRN4(2)
      YDRAW(1)=TICXY(2)-TICLEN*DIRN4(1)
      XDRAW(2)=TICXY(1)
      YDRAW(2)=TICXY(2)
C..#IFDEF DGSYS
      CALL DGLNS(XDRAW,YDRAW,2)
CC..#ELIF GKSYS
C      CALL GPL(2,XDRAW,YDRAW)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
  400 CONTINUE
  410 CONTINUE
C
C       LABELS FOR EXPONENTS (FOR LINEAR PLOTS) ON SIDE 1 AND 4
      IF(G1MARG(IMAR(ISIDE)).EQ.0.0) GO TO 450
C       PRESET OFFSET FOR SUBTITLE (WHEN EXPONENT IS PRESENT)
      EXPSPA=0.
      IF(ILOG(JI).NE.0) GO TO 420
      IF(ISIDE.EQ.2.OR.ISIDE.EQ.3) GO TO 420
C       DONT BOTHER TO PUT UP ZERO POWERED EXPONENT
      IF(IPWR.EQ.0) GO TO 420
      CALL DPITOA(IPWR,TEMP8,NCHR,8,10)
C..#IFDEF DGSYS
      CALL DGTXT(XEXP(IJ),YEXP(IJ),'X10')
      CALL DGGET('XSPA',XSPAC)
      CALL DGSET('XSPA',0.7*CSIZXL)
      CALL DGTXT(XEXP(IJ)+3.*CSIZXL,YEXP(IJ)+.8*CSIZYL,TEMP8(1:NCHR))
      CALL DGSET('XSPA',XSPAC)
CC..#ELIF GKSYS
C      CALL GTX(XEXP(IJ),YEXP(IJ),'X10')
C      CALL GQCHH(IGERR,XSPAC)
C      CALL GSCHH(0.7*CSIZXL)
C      CALL GTX(XEXP(IJ)+3.*CSIZXL,YEXP(IJ)+.8*CSIZYL,TEMP8(1:NCHR))
C      CALL GSCHH(XSPAC)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      EXPSPA=1.3
C
C
  420 CONTINUE
C
C       TITLE FOR THIS SIDE
C
      NCHR=LENTI(ITIT)
      IF(NCHR.EQ.0) GO TO 450
      HLFTIT=0.5*(NCHR-1)*CSIZXL
      IF(IJ.EQ.2) HLFTIT=HLFTIT/CXMAG
      SUBT1=SUBTIT(LOCTI(ITIT)+1)
      IF(SUBT1.EQ.DOLAR) HLFTIT=HLFTIT*0.5
      IF(SUBT1.EQ.CURLY) HLFTIT=HLFTIT*0.75
C      CLEFT IS LEFT AXIS SUBTITLE OFFSET (BASED ON LABEL SIZES)
      CLEFT=MAXCHR+2.5
      IF(ILOG(JI).NE.0) CLEFT=0.7*MAXCHR+3.8
C      ADJUST BOTTOM SUBTITLE IF EXPONENTIAL TAGS
      IF(ISIDE.EQ.1.AND.ILOG(JI).NE.0) EXPSPA=EXPSPA+0.8
C      ADJUST TOP SUBTITLE LOCATION DOWN A LINE, UNLESS NCALLS THERE
      IF(ISIDE.EQ.3) EXPSPA=EXPSPA-.5
      IF(ISIDE.EQ.3.AND.(ICALLS.LE.0.OR.NWCALL.LE.0).AND.
     >   MOD(ISTATS,2).EQ.0) EXPSPA=EXPSPA-1.0
      TX=0.5*(CORNER(1,ISIDE+1)+CORNER(1,ISIDE))
     >      +(CLEFT*CSIZXL+COFF)*DIRN4(2)-HLFTIT*ABS(DIRN4(1))
      TX=AMIN1(PLIMIT(3)-.75*CSIZXL,AMAX1(PLIMIT(1)+.75*CSIZXL,TX))
      IF(IJ.EQ.1) TX=AMAX1(TX,CORNER(1,1)+.05)
      TY=0.5*(CORNER(2,ISIDE+1)+CORNER(2,ISIDE))
     > -((2.0+EXPSPA)*CSIZYL+2.*COFFY)*DIRN4(1)-HLFTIT*ABS(DIRN4(2))
      TY=AMIN1(PLIMIT(4)-.75*CSIZXL,AMAX1(PLIMIT(2)+.75*CSIZXL,TY))
      IF(IJ.EQ.2) TY=AMAX1(TY,CORNER(2,1)+.05)
      LCT=LOCTI(ITIT)
C..#IFDEF DGSYS
      IF(IJ.EQ.2) CALL DGSET('ANGL',90.)
      CALL DGTXT(TX,TY,SUBTI(LCT+1:LCT+MIN0(255,NCHR)))
      IF(IJ.EQ.2) CALL DGSET('ANGL',0.)
CC..#ELIF GKSYS
C      IF(IJ.EQ.2) CALL GSCHUP(-1.0,0.)
C      CALL GTX(TX,TY,SUBTI(LCT+1:LCT+MIN0(255,NCHR)))
C      IF(IJ.EQ.2) CALL GSCHUP(0.,1.0)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
  450 CONTINUE
C
C       PUT UP ID FONT, NCALLS, AVGS  ALONG TOP SIDE
C
      IF(G1MARG(4).EQ.0.0) GO TO 500
      CSIZXL=AMIN1(.020,CSIZXL)
C..#IFDEF DGSYS
      CALL DGSET('XSPA',CSIZXL)
CC..#ELIF GKSYS
C      CALL GSCHH(CSIZXL)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      IF(IDFONT.EQ.0 .OR. IDA.EQ.IBLANK) GO TO 440
      TY=PLIMIT(4)-.01-0.5*CSIZXL
C..#IFDEF DGSYS
      CALL DGTXT(PLIMIT(1)+.01,TY,KFONT(1:8))
CC..#ELIF GKSYS
C      CALL GTX(PLIMIT(1)+.01,TY,KFONT(1:8))
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
C       PUT UP NUMBER OF CALLS, UNDERFLOWS, AND OVERFLOWS
  440 TY=CORNER(2,4)+.035
      IF(ICALLS.LE.0 .OR. NWCALL.LE.0) GO TO 445
      CALL DPGNUM(CORNER(1,4)+.05,TY)
      TY=TY-.07
C
C       PUT UP STATISTICS ALONG TOP SIDE
C
  445 IF(MOD(ISTATS,2).EQ.0) GO TO 455
      CALL DPGAVG(CORNER(1,1)+.05,TY)
      TY=TY-.022
C
C  ALLOW A USER TO PUT UP HIS OWN THING
  455 CALL DPG1U(CORNER,TY)
C
C
  500 CONTINUE
C
      IF(IENTRY.NE.1) GO TO 550
C
C       NOW GO GENERATE THE DATA POINTS
C
      CALL DPLINE(X,Y,YE,N,NF,CORNER)
      CALL DFUNC(F,NAF,CORNER,X,Y,YE,N,NF)
      GO TO 560
C
C        GENERATE THE CONTOUR PLOT
  550 CALL DCURVE(C,NC,CORNER)
C
C..#IFDEF DGSYS
  560 CALL DGSET('XSPA',XSPAL)
CC..#ELIF GKSYS
C  560 CALL GSCHH(XSPAL)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      RETURN
C
C  ERROR
  900 NTITLE=MIN0(80,NTITLE)
      JEDGE(2)=IEDGE(1)
      WRITE(ERUNIT,910) TITLE(1:NTITLE)
      WRITE(ERUNIT,920) ((ASCALE(J,I),J=1,4),(ISCALE(J,I),J=1,3),
     >ILOG(IB(I)),IAUTO(IB(I)),JEDGE(I),IZERO(IB(I)),G1TIC(1,I),
     >G1TIC(2,I),I=1,2)
  910 FORMAT(/,' HANDYPAK SCALING PROBLEM IN DPGR1 FOR : ',A)
  920 FORMAT('   |',13X,'ASCALE',22X,'|',8X,'ISCALE',6X,'|  ',
     >'  LOG AUTO EDGE ZERO NTIC NSUB',
     > /,' X |',4G10.2,' | ',3I6,' | ',6I5,/,
     >   ' Y |',4G10.2,' | ',3I6,' | ',6I5,/)
      RETURN
      END
