      SUBROUTINE DPICT(K)
C
C  **MEMBER** DPICT
C
C  CONTROLS INITIALIZATION AND OUTPUTTING OF THE GRAPHIC BUFFER
C  FOR GRAPHIC DEVICES.  DOES NOTHING FOR NON-GRAPHIC DEVICES.
C
C  THE ARGUMENT K SPECIFIES INITIALIZATION OR CLOSURE OF GRAPHIC PLOT
C    K = 0  INITIALIZE (INIT UG BUFFER, CLEAR SCREEN, ETC)
C    K = 1  OUTPUT PLOT (WRITE UG BUFFER OUT, CLOSE PLOT, ETC)
C
C  IF INTER IS 1, THEN A PAUSE IS DONE AFTER EVERY PICTURE. A
C  CARRIAGE RETURN IS THEN NECESSARY TO CONTINUE WITH THE JOB.
C
C  VARIABLE SETTINGS ON ENTRY TO DPICT:          SET BY:
C
C   SCREEN = 0   Screen is in text mode          DGSCRN
C            1   Screen is in graf mode            "
C
C   INTER  = 0   clear plot after plotting       DPSLCT, HANDY(chp)
C            1   clear plot before plotting        "       "
C           -1   chp mode (reading cinput file)    "       "
C            2   don't do UG clear or writ (MarkII) "
C
C   OVRPLT = 0   no over plotting                DOPTC
C            1   in over plot mode                 "           DPSLCT
C           -1   change overplot state             "    DPCLOS DPSLCT
C
C   WINDOW = 0   no windowing in progress        DPWDOW
C            1   windowing is in progress          "           DPSLCT
C           -1   end a windowing screen.           "    DPCLOS DPSLCT
C           -2   begin a windowing screen.         "
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomwn.INC'
C
      REAL PLIMIT(4)
CC..#IFDEF GKSYS
C      REAL WINDPT(4), VIEWPT(4)
C..#ENDIF
C
      REAL TSIZE(2),TOFSET(2)
C
      CHARACTER*27 L1BUF
C
      DATA L1BUF/'HANDYPAK                   '/
C
C
      INTR=IABS(INTER)
      IF(IDEV.GT.2) GO TO 50
C
C       DONT DO ANYTHING FOR NON-GRAPHIC DEVICES
      IF(IDEV.LE.2) GO TO 500
C      NEXT STATEMENT WILL NEVER BE EXECUTED - IT IS HERE TO
C      ASSURE THAT UGXERR IS LOADED FROM HANDYPAK AND NOT
C      FROM UG LIB ON VAX
C..#IFDEF DGSYS
      CALL UGXERR
C..#ENDIF
C
C       FOR INTERACTIVE PANEL APPLICATION (INTER=2), DONT DO ANY
C       CALLS TO DGPUT OR DGPIC SINCE DEXEC DOES IT.
C
   50 IF(K.NE.0) GO TO 100
      NEWIND=0
C       ADVANCE WINDOW, IF WINDOWING, AND NOT OVERPLOTTING
      IF(WINDOW.NE.1.OR.OVRPLT.GT.0) GO TO 52
      IF(IWNDW(IDEV).LT.0) GO TO 51
        IWNDW(IDEV)=IWNDW(IDEV)+1
        IF(IWNDW(IDEV).LE.NWNDWS) GO TO 51
          NEWIND=1
          IWNDW(IDEV)=1
   51 IF(IWNDW(IDEV).LT.0) IWNDW(IDEV)=-IWNDW(IDEV)
   52 IF(INTR.EQ.2) GO TO 55
C
C       INITIALIZE THE BUFFER
      IF(INTR.NE.1) GO TO 54
C       FLIP TO GRAPHIC SCREEN
      IF(SCREEN.EQ.1) GO TO 53
      IF((INTER.EQ.1.AND.WINDOW.GE.0.AND.OVRPLT.GE.0).OR.
     >   (INTER.EQ.-1.AND.((WINDOW.LE.0.AND.OVRPLT.EQ.0).OR.
     >                     (WINDOW.EQ.0.AND.OVRPLT.EQ.-1))))
     >   CALL DGSCRN('GRAF')
   53 IF(OVRPLT.GT.0) GO TO 60
      IF(WINDOW.GT.0.AND.NEWIND.EQ.0) GO TO 60
      IF(WINDOW.EQ.-1.AND.IWNDW(IDEV).GT.0) GO TO 60
C       ACTIVATE DEVICE, CLEAR SCREEN, ETC.
      IF(SCREEN.NE.1) CALL DGSCRN('GRAF')
CC..#IFDEF GKSYS
C      CALL GCLRWK(IDEV,1)
C..#ELIF DGSYS
      CALL DGPIC(0,0)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C       FLIP TO TEXT SCREEN IF IN CHP, STARTING AN OVERPLOT
      IF(INTER.EQ.1.AND.(OVRPLT.EQ.-1.OR.WINDOW.LE.-1))
     >    CALL DGSCRN('TEXT')
C..#IFDEF DGSYS
   54 CALL DGINT(0)
CC..#ELIF GKSYS
C   54 CONTINUE
C      CALL GQWKS(IDEV,IERR,ISTATE)
C      IF(ISTATE.EQ.0) CALL GACWK(IDEV)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
   55 IF(OVRPLT.EQ.0) NOVRG=0
C
C      ALSO SET THE UG PROGRAMMER LIMITS FROM GSIZE AND GOFSET
   60 CALL DPLIMS
      GO TO 500
C
C
C       OUTPUT THE BUFFER
  100 IF(INTR.EQ.2) GO TO 115
C
C       FLIP TO GRAPHIC SCREEN IN CHP, ENDING AN OVERPLOT
      IF(SCREEN.EQ.1) GO TO 110
      IF(INTER.EQ.1.AND.(OVRPLT.EQ.-1.OR.WINDOW.LE.-1))
     >    CALL DGSCRN('GRAF')
C       SEND OUT THE GRAPHIC BUFFER CONTENTS
  110 CONTINUE
C..#IFDEF DGSYS
      CALL DGPUT(0,0)
      CALL DGINT(0)
C..#ENDIF
C
C       COUNT UP NUMBER OF PLOTS WHEN OVERPLOTTING IS BEING DONE
  115 IF(OVRPLT.LE.0) GO TO 120
      NOVRG=NOVRG+1
      GO TO 200
C
  120 IF(WINDOW.EQ.1.AND.IWNDW(IDEV).NE.NWNDWS) GO TO 200
      IF(WINDOW.EQ.-1.AND.IWNDW(IDEV).EQ.NWNDWS) GO TO 200
C
C       PUT UP JOB NAME, DATE FONT
C
  130 IF(JBFONT.EQ.0) GO TO 150
C      PUT OUT PREVIOUS BUFFER, IF ANY
C..#IFDEF DGSYS
      IF(INTR.NE.2) CALL DGPUT(0,0)
C..#ENDIF
C      SAVE GSIZE AND GOFSET, AND RESTORE LATER.
         TSIZE(1)=GSIZE(1)
         TSIZE(2)=GSIZE(2)
         TOFSET(1)=GOFSET(1)
         TOFSET(2)=GOFSET(2)
         JWNDOW=WINDOW
         GSIZE(1)=1.
         GSIZE(2)=1.
         GOFSET(1)=0.
         GOFSET(2)=0.
         WINDOW=0
         CALL DPLIMS
         WRITE(L1BUF(11:27),'(2A4,1X,2A4)') JBNAM,JBDAT
CC..#IFDEF GKSYS
C      CALL GQCNTN(IGERR,NTRN)
C      CALL GQNT(NTRN,IGERR,WINDPT,VIEWPT)
C      PLIMIT(1)=WINDPT(1)
C      PLIMIT(2)=WINDPT(3)
C      PLIMIT(3)=WINDPT(2)
C      PLIMIT(4)=WINDPT(4)
C         CALL GQCHH(IGERR,XSPA)
C         CALL GSCHH(.012)
C      XJB=.02
C      YJB=.035
C      IF(JBFONT.EQ.1) CALL GTX(XJB,YJB,L1BUF(11:27))
C      IF(JBFONT.EQ.2) CALL GTX(XJB,YJB,L1BUF(1:8))
C      IF(JBFONT.GE.3) CALL GTX(XJB,YJB,L1BUF(1:27))
C         CALL GSCHH(XSPA)
C         IF(INTR.NE.2) CALL GDAWK(IDEV)
C..#ELIF DGSYS
      CALL DGGET('PLIMIT',PLIMIT)
      IF(INTR.NE.2) CALL DGINT(0)
         CALL DGGET('XSPA',XSPA)
         CALL DGSET('XSPA',.012)
         XJB=PLIMIT(1)+.006
         YJB=PLIMIT(2)+.010
      IF(JBFONT.EQ.1) CALL DGTXT(XJB,YJB,L1BUF(11:27))
      IF(JBFONT.EQ.2) CALL DGTXT(XJB,YJB,L1BUF(1:8))
      IF(JBFONT.GE.3) CALL DGTXT(XJB,YJB,L1BUF(1:27))
      IF(INTR.NE.2) CALL DGPUT(0,0)
      IF(INTR.NE.2) CALL DGINT(0)
         CALL DGSET('XSPA',XSPA)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
         GSIZE(1)=TSIZE(1)
         GSIZE(2)=TSIZE(2)
         GOFSET(1)=TOFSET(1)
         GOFSET(2)=TOFSET(2)
         WINDOW=JWNDOW
         CALL DPLIMS
C
CC..#IFDEF GKSYS
C  150 IF(INTR.EQ.0) CALL GCLRWK(IDEV,1)
C..#ELIF DGSYS
  150 IF(INTR.EQ.0) CALL DGPIC(0,0)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      IF(OVRPLT.LE.0) NOVRG=0
      IF(INTR.NE.1) GO TO 500
C
C       WAIT FOR A KEYBOARD RESPONCE, BUT NOT IF READING COMMANDS
C       FROM A FILE (INTER=-1 THEN).
      IF(INTER.EQ.1.OR.(OVRPLT.LE.0.AND.(WINDOW.LE.0.OR.
     >         IWNDW(IDEV).GE.NWNDWS))) CALL DGWAIT
C
C       FLIP TO TEXT SCREEN IF WE ARE IN INTERACTIVE MODE
  200 IF(INTER.EQ.1) CALL DGSCRN('TEXT')
  500 RETURN
C
      END
