      SUBROUTINE DPITOA(I,A,NCHR,MAXA,NBASE)
C
C   **MEMBER** DPITOA
C
C
C  CONVERTS THE INTEGER STORED IN I TO A CHARACTER STRING IN A.
C  LEADING ZEROS ARE SUPPRESSED, AND THE RESULT CAN BE EITHER LEFT
C  OR RIGHT JUSTIFIED IN THE A ARRAY.
C
C  WHERE:
C    I     (I*4)  IS THE INTEGER TO BE CONVERTED
C    A     (C*1)  RETURNS THE CHARACTER RESULT
C    NCHR  (I*4)  RETURNS THE NUMBER OF CHARACTERS PUT INTO A
C                   (LEADING ZEROS ARE SUPPRESSED AND NOT COUNTED)
C    MAXA  (I*4)  ABSOLUTE VALUE GIVES THE MAXIMUM NUMBER OF CHARACTERS
C                 THAT MAY BE PUT INTO A.  IF MAXA IS POSITIVE(NEGATIVE)
C                 THEN THE CHARACTERS ARE LEFT(RIGHT) JUSTIFIED IN A.
C    NBASE (I*4)  IS THE BASE TO BE USED (10 FOR DECIMAL, 16 FOR HEX,
C                   AND THE RANGE MAY BE FROM 2 TO 36)
C
C
      INCLUDE 'dcomfp.INC'
C
      CHARACTER*1 A(1)
      CHARACTER*1 BLNK, STAR, MINUS, DIGIT(36)
      DATA DIGIT/'0','1','2','3','4','5','6','7','8','9',
     >           'A','B','C','D','E','F','G','H','I','J',
     >           'K','L','M','N','O','P','Q','R','S','T',
     >           'U','V','W','X','Y','Z'/
      DATA BLNK/' '/, STAR/'*'/, MINUS/'-'/
C
C
      NARG=NARGS()
      IF(NARG.LT.0) NARG=5
      MXA=4
      IF(NARG.GE.4) MXA=MAXA
      NMX=IABS(MXA)
      NB=10
      IF(NARG.GE.5) NB=MAX0(2,MIN0(36,NBASE))
      IF(NMX.GT.0) GO TO 10
      N=0
      A(1)=STAR
      GO TO 320
C
C       CLEAR THE A ARRAY
   10 DO 15 J=1,NMX
   15 A(J)=BLNK
C
C       GET MAXIMUM DIGITS POSSIBLE FOR THIS NBASE AND EXPMAX
   20 IF(NB.EQ.10) GO TO 30
      IF(NB.EQ.16) GO TO 40
      BASE=ALOG10(FLOAT(NB))
      GO TO 50
   30 BASE=1.0
      GO TO 50
   40 BASE=1.2041
   50 NMX9=MIN0(IFIX(EXPMAX/BASE),NMX)
      IAB=IABS(I)
C       SEARCH FOR NUMBER OF SIGNIFICANT DIGITS IN I
      DO 100 M=1,NMX9
      IF(IAB.LT.NB**M) GO TO 200
  100 CONTINUE
      GO TO 500
C
  200 J0=0
      IF(MXA.LT.0) J0=NMX-M
C
      IF(I.GE.0) GO TO 220
C       IF I IS NEGATIVE, ALLOW ONE MORE SPACE FOR '-'
      IF(M+1.GT.NMX) GO TO 500
      IF(J0.GT.0) J0=J0-1
      A(J0+1)=MINUS
      J0=J0+1
C
C       FILL UP A WITH THE DIGITS, DECADE BY DECADE
  220 DO 300 J=1,M
      IDEC=MOD(IAB/NB**(M-J),NB)
  300 A(J+J0)=DIGIT(IDEC+1)
      N=M+J0
  320 IF(NARG.GE.3) NCHR=N
      RETURN
C
C       I OVERFLOWS THE SPECIFIED SIZE, SO FILL A WITH NMX STARS
  500 N=NMX9
      DO 510 J=1,NMX9
  510 A(J)=STAR
      GO TO 320
C
      END
