      SUBROUTINE DPLINE(FX,FY,FYE,N,NF,CORNER)
C
C   **MEMBER** DPLINE
C
C   PUTS THE GRAPH(S) OF FY VS FX INTO THE GRAPHIC ELEMENT BUFFER.
C
C
C   FX, FY ARE REAL FUNCTIONS WHICH SUPPLY THE COORDINATES
C   FYE    IS A REAL FUNCTION WHICH SUPPLIES THE ERROR IN FY
C   N      GIVES THE NUMBER OF POINTS
C   NF     THE NUMBER OF FUNTIONS NF TO BE OVERPLOTTED,
C          IF NF=0, THEN THE GRAPH FY(I) VS FX(I) FOR I=1,N IS MADE,
C          OTHERWISE THE NF GRAPHS ARE GENERATED AS
C            FY(I,J) VS FX(I,J) FOR I=1,N FOR EACH J (AS J=1,NF).
C   CORNER PROVIDES THE PROGRAMMER COORDINATES OF THE FRAME CORNERS.
C
      REAL CORNER(2,4)
      EXTERNAL FX,FY,FYE,DPSLCI
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomg1.INC'
C
      LOGICAL POINT,SLCFLG
      CHARACTER*1 HEX(16),L1CHAR(4),BLANK,L1ZRO
      CHARACTER*4 CHAR
C
      EQUIVALENCE (CHAR,L1CHAR(1))
      REAL XPL(2),YPL(2)
C
      DATA BLANK,IZRO/' ',0/
      DATA HEX/'0','1','2','3','4','5','6','7','8',
     >         '9','A','B','C','D','E','F'/
C
C
C       NUMBER OF POINTS TO BE PLOTTED
      IF(N.LE.0) RETURN
C       NUMBER OF FUNCTIONS TO BE PLOTTED (EACH WITH N POINTS)
      SLCFLG=(SLFLAG.EQ.0.OR.NF.GT.1)
      NF1=NF
      IF(NF.LE.0) NF1=1
C
      GXMN=CORNER(1,1)
      GYMN=CORNER(2,1)
      GXMX=CORNER(1,2)
      GYMX=CORNER(2,4)
      GXRAN=CORNER(1,2)-GXMN
      GYRAN=CORNER(2,4)-GYMN
C
C
      IF (ASCALE(2,1).EQ.0.0.OR.ASCALE(2,2).EQ.0.0) RETURN
C
      WRITE(L1ZRO,'(A1)') IZRO
C..#IFDEF DGSYS
      CALL DGGET('XSPA',SYMSV)
CC..#ELIF GKSYS
C      CALL GQCHH(IGERR,SYMSV)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      IF(SYMSIZ.GE.0) THEN
         SYMSZ=.015+.01*SYMSIZ
      ELSE
         SYMSZ=.015+.01*AMAX0(0,TITLSZ-1)
      ENDIF
C..#IFDEF DGSYS
      CALL DGSET('XSPA',SYMSZ)
CC..#ELIF GKSYS
C      CALL GSCHH(SYMSZ)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      XRANGE=AMAX1(1.0,ASCALE(3,1))
      IF(ILOG(2).EQ.0) XRANGE=XRANGE*ASCALE(2,1)
      YRANGE=AMAX1(1.0,ASCALE(3,2))
      IF(ILOG(1).EQ.0) YRANGE=YRANGE*ASCALE(2,2)
C..#IFDEF DGSYS
      CALL DGGET('COLO',ICOLSV)
CC..#ELIF GKSYS
C      CALL GQTXCI(IGERR,ICOLSV)
C      CALL GQPLCI(IGERR,JCOLSV)
C      CALL GQPMCI(IGERR,KCOLSV)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      NEWCOL=0
C
C       DO EACH FUNCTION IN TURN
C
      DO 1000 J=1,NF1
C
C       GET CHARACTER AND COLOR FOR THIS FUNCTION
C
      WRITE(CHAR,'(A4)') PLTCHR(J)
      IERR=-1
      ICOLOR=COLOR
      ILINE=-1
C       SEARCH FOR COLOR AND LINE OPTS WITHIN PLTCHR WORD
      DO 1 KCOL=1,16
      IF(L1CHAR(2).EQ.HEX(KCOL)) ICOLOR=KCOL-1
      IF(L1CHAR(3).EQ.HEX(KCOL)) IERR=KCOL-1
    1 IF(L1CHAR(4).EQ.HEX(KCOL)) ILINE=KCOL-1
C
      IF(ILINE.EQ.-1) ILINE=G1LINS
      IF(IERR.EQ.-1) IERR=ERRS
C
      IF(ICOLOR.NE.ICOLSV) NEWCOL=1
      IF(NEWCOL.EQ.1) THEN
C..#IFDEF DGSYS
         CALL DGSET('COLO',ICOLOR)
CC..#ELIF GKSYS
C         CALL GSTXCI(ICOLOR)
C         CALL GSPLCI(ICOLOR)
C         CALL GSPMCI(ICOLOR)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      ENDIF
CC..#IFDEF GKSYS
C      IF(MARK.NE.0) THEN
C         CALL GSMK(MARK)
CCCCCC    CALL GSMKSC(1.0+AMAX1(0.,.66667*(TITLSZ-1)))
C         IF(WKCATS(IDEV).NE.4) THEN
CC             This is for XGKS display.
C            CALL GSMKSC(SYMSZ/6.0*1280.)
C         ELSE
CC             This is for XGKS MO (fudge by /2.5 experimentally)
C            CALL GSMKSC(SYMSZ/6.0*1280./2.5)
C         ENDIF
C      ENDIF
C..#ENDIF
C
      POINT= ILINE.EQ.0.AND.IERR.EQ.0.AND.L1CHAR(1).EQ.BLANK
     >       .AND.MARK.EQ.0
C
C       THIS LOOP DRAWS LINES ON FIRST PASS, AND ERRORS OR SYMBOL ON 2ND PASS
      DO 950 LOOP=1,2
C
C       SKIP OVER LOOP IF NOTHING TO DO IN THIS PASS
      IF(LOOP.EQ.1.AND. ILINE.EQ.0) GO TO 950
      IF(LOOP.EQ.2.AND.IERR.EQ.0.AND.(L1CHAR(1).EQ.BLANK.AND.MARK.EQ.0)
     > .AND.ILINE.NE.0)
     >     GO TO 950
C
C       FIRST BIN INITIALIZATION BEFORE ENTERING DO LOOP BELOW
      XNEXT=FX(1,J)
      X=XNEXT
      XW=FX(2,J)-XNEXT
      XLAST=XNEXT-XW
      IF( ILINE.EQ.0 .OR. LOOP.EQ.2) GO TO 30
      IF( ILINE.EQ.2) GO TO 5
      X=XLAST
      IF(LOWIN.NE.0.AND.BINCEN.NE.0) X=(XLAST+XNEXT)/2.0
      GO TO 10
    5 X=XNEXT
      IF(LOWIN.EQ.0) X=(XLAST+XNEXT)/2.0
   10 CALL DPG1X(X,GX)
      GXL=GX
      XPL(2)=GXL
      YPL(2)=GYMN
   30 CONTINUE
C
C       LOOP OVER ALL N BINS, DRAWING HIST, LINE, ERRORS ETC.
C
      DO 900 I=1,N
C
      XW=XNEXT-XLAST
      XLAST=XNEXT
      IF(I.LT.N) XNEXT=FX(I+1,J)
      IF(I.GE.N) XNEXT=XNEXT+XW
C
C       COMPUTE BIN CENTER XC, AND RIGHT EDGE XR, AND Y VALUE
C
      XC=XLAST
      IF(LOWIN.NE.0.AND.BINCEN.NE.0) XC=(XLAST+XNEXT)/2.0
      X=XC
      CALL DPG1X(X,GX)
      GXC=GX
C
      IF(SLCFLG) YC=FY(I,J)
      IF(.NOT.SLCFLG) YC=DPSLCF(FY,I)
      Y=YC
      CALL DPG1Y(Y,GY)
      GYC=GY
C
      IF(LOOP.EQ.2) GO TO 300
C
C
C  DRAW THE LINES
C
C
C       HISTOGRAM
  100 IF( ILINE.NE.2) GO TO 200
      XPL(1)=XPL(2)
      XPL(2)=GXL
      YPL(1)=YPL(2)
      YPL(2)=GY
C..#IFDEF DGSYS
      CALL DGLNS(XPL,YPL,2)
CC..#ELIF GKSYS
C      CALL GPL(2,XPL,YPL)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      XR=XNEXT
      IF(LOWIN.EQ.0) XR=(XLAST+XNEXT)/2.0
      X=XR
      CALL DPG1X(X,GX)
      XPL(1)=XPL(2)
      XPL(2)=GX
      YPL(1)=YPL(2)
      YPL(2)=GY
C..#IFDEF DGSYS
      CALL DGLNS(XPL,YPL,2)
CC..#ELIF GKSYS
C      CALL GPL(2,XPL,YPL)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      GXL=GX
      GO TO 900
C
C       LINES
  200 IF( ILINE.NE.1) GO TO 900
      XPL(1)=XPL(2)
      XPL(2)=GX
      YPL(1)=YPL(2)
      YPL(2)=GY
C..#IFDEF DGSYS
      IF(I.GT.1) CALL DGLNS(XPL,YPL,2)
CC..#ELIF GKSYS
C      IF(I.GT.1) CALL GPL(2,XPL,YPL)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      GO TO 900
C
C
C  PUT UP ERROR BARS, PLOT SYMBOL OR POINT
C
C
  300 IF((L1CHAR(1).EQ.BLANK .OR. L1CHAR(1).EQ.L1ZRO)
     )    .AND.MARK.EQ.0) GO TO 400
      IF(GY.GT.GYMX.OR.GY.LT.GYMN) GO TO 400
      IF(GXC.GT.GXMX.OR.GXC.LT.GXMN) GO TO 400
C       USE MARKER SYMBOLS IF MARK IS NON ZERO
      IF(MARK.NE.0.AND.J.EQ.1) THEN
C..#IFDEF DGSYS
         CALL DGSYM(GXC,GY,MARK)
CC..#ELIF GKSYS
C         CALL GPM(1,GXC,GY)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      ELSE
C..#IFDEF DGSYS
         CALL DGTXT(GXC,GY,L1CHAR(1))
CC..#ELIF GKSYS
C         CALL GTX(GXC,GY,L1CHAR(1))
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      ENDIF
C
C       ERROR BARS
  400 IF(IERR.EQ.0) GO TO 500
      GXPT=GXC
      GYPT=GY
C       CHECK IF ONLY +-YERR, OR Y1,Y2 AND/OR X ERR
      IYE=MOD(IERR,4)
      IF(IYE.EQ.0) GO TO 430
      IF(GXPT.GT.GXMX.OR.GXPT.LT.GXMN) GO TO 430
      IF(SLCFLG.AND.NF.EQ.0) E=FYE(I,1,1,1)
      IF(SLCFLG.AND.NF.GT.0) E=FYE(I,J,1,1)
      IF(.NOT.SLCFLG) E=DPSLCE(FYE,I,1,1)
      Y=YC+E
      CALL DPG1Y(Y,GY)
      XPL(1)=GXC
      YPL(1)=GY
      XPL(2)=GXC
      YPL(2)=GYC+0.350*SYMSZ
      IF(MARK.EQ.0) GO TO 415
      IF(YPL(2).GT.GY.OR.YPL(2).GT.GYMX) GO TO 415
C..#IFDEF DGSYS
      CALL DGLNS(XPL,YPL,2)
CC..#ELIF GKSYS
C      CALL GPL(2,XPL,YPL)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
  415 IF(IYE.EQ.1) GO TO 418
C       DO THE ASYMMETRIC ERROR IN Y
      IF(SLCFLG.AND.NF.EQ.0) E=FYE(I,2,1,1)
      IF(SLCFLG.AND.NF.GT.0) E=FYE(I,J,2,1)
      IF(.NOT.SLCFLG) E=DPSLCE(FYE,I,2,1)
  418 Y=YC-E
      CALL DPG1Y(Y,GY)
      XPL(2)=GXC
      YPL(2)=GY
      IF(MARK.EQ.0) GO TO 425
      YPL(1)=GYC-0.350*SYMSZ
      IF(YPL(1).LT.GY.OR.YPL(1).LT.GYMN) GO TO 430
C..#IFDEF DGSYS
  425 CALL DGLNS(XPL,YPL,2)
CC..#ELIF GKSYS
C  425 CALL GPL(2,XPL,YPL)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
C       CHECK IF XERR IS TO BE DONE
  430 IXE=MOD(IERR/4,4)
      IF(IXE.EQ.0) GO TO 500
      IF(GYPT.GT.GYMX.OR.GYPT.LT.GYMN) GO TO 500
      IF(SLCFLG.AND.NF.EQ.0) E=FYE(I,1,2,1)
      IF(SLCFLG.AND.NF.GT.0) E=FYE(I,J,1,2)
      IF(.NOT.SLCFLG) E=DPSLCE(FYE,I,1,2)
      X=XC+E
      CALL DPG1X(X,GX)
      XPL(1)=GX
      YPL(1)=GYC
      YPL(2)=GYC
      XPL(2)=GXC+0.350*SYMSZ
      IF(MARK.EQ.0) GO TO 445
      IF(XPL(2).GT.GX.OR.XPL(2).GT.GXMX) GO TO 445
C..#IFDEF DGSYS
      CALL DGLNS(XPL,YPL,2)
CC..#ELIF GKSYS
C      CALL GPL(2,XPL,YPL)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
  445 IF(IXE.EQ.1) GO TO 448
C       DO THE ASYMMETRIC ERROR IN X
      IF(SLCFLG.AND.NF.EQ.0) E=FYE(I,2,2,1)
      IF(SLCFLG.AND.NF.GT.0) E=FYE(I,J,2,2)
      IF(.NOT.SLCFLG) E=DPSLCE(FYE,I,2,2)
  448 X=XC-E
      CALL DPG1X(X,GX)
      XPL(2)=GX
      YPL(2)=GYC
      IF(MARK.EQ.0) GO TO 455
      XPL(1)=GXC-0.350*SYMSZ
      IF(XPL(1).LT.GX.OR.XPL(1).LT.GXMN) GO TO 500
      YPL(1)=GYC
C..#IFDEF DGSYS
  455 CALL DGLNS(XPL,YPL,2)
CC..#ELIF GKSYS
C  455 CALL GPL(2,XPL,YPL)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
C       POINTS  (IF NONE OF THE ABOVE WERE DONE)
C..#IFDEF DGSYS
  500 IF(POINT) CALL DGPNT(GXC,GYC)
CC..#ELIF GKSYS
C  500 IF(POINT) CALL GPM(1,GXC,GYC)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
  900 CONTINUE
C       FINISH UP LAST EDGE OF HIST PLOT
      IF(LOOP.EQ.1.AND. ILINE.EQ.2) THEN
         XPL(1)=XPL(2)
         XPL(2)=GXL
         YPL(1)=YPL(2)
         YPL(2)=GYMN
C..#IFDEF DGSYS
         CALL DGLNS(XPL,YPL,2)
CC..#ELIF GKSYS
C         CALL GPL(2,XPL,YPL)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      ENDIF
C
  950 CONTINUE
 1000 CONTINUE
      IF(NEWCOL.EQ.1) THEN
C..#IFDEF DGSYS
         CALL DGSET('COLO',ICOLSV)
CC..#ELIF GKSYS
C         CALL GSTXCI(ICOLSV)
C         CALL GSPLCI(JCOLSV)
C         CALL GSPMCI(KCOLSV)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      ENDIF
C..#IFDEF DGSYS
      CALL DGSET('XSPA',SYMSZ)
CC..#ELIF GKSYS
C      CALL GSCHH(SYMSZ)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
      RETURN
      END
      SUBROUTINE DPG1X(X,GX)
C
C
C THE FOLLOWING FUNCTIONS WILL CONVERT THE X AND Y VALUES TO THE
C GRAPHIC VALUES GX AND GY NEEDED BY THE UG ROUTINES.
C
C        CONVERT THE X VALUE
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomg1.INC'
C
      IF (ILOG(2).EQ.0) GO TO 9001
      IF (X.GT.0) GO TO 9002
      GX=GXMN-.001*GXRAN/XRANGE
      GO TO 9005
 9002 X=ALOG10(X)
 9001 GX=GXMN+GXRAN*AMAX1(-.00001,
     >   AMIN1(1.00001,(X-ASCALE(1,1))/XRANGE))
CDBUG      WRITE(6,9010) I,J,LOOP,X,GX,GXMN,GXRAN,XRANGE,ASCALE(1,1)
CDBUG 9010 FORMAT(/,' X: ',3I4,6G10.3)
 9005 RETURN
C
C
      ENTRY DPG1Y(Y,GY)
C
C        CONVERT THE F VALUE
      IF (ILOG(1).EQ.0) GO TO 9901
      IF (Y.GT.0) GO TO 9902
      GY=GYMN-.001*GYRAN/YRANGE
      GO TO 9905
 9902 Y=ALOG10(Y)
 9901 GY=GYMN+GYRAN*AMAX1(-.00001,
     >   AMIN1(1.00001,(Y-ASCALE(1,2))/YRANGE))
CDBUG      WRITE(6,9910) I,J,LOOP,Y,GY,GYMN,GYRAN,YRANGE,ASCALE(1,2)
CDBUG 9910 FORMAT(  ' F: ',3I4,6G10.3,/)
 9905 RETURN
C
      END
