      SUBROUTINE DPLP1 (FX,FY,FYE,N,NF,TITLE,SCAL,AF,NAF)
C
C   **MEMBER** DPLP1
C
C
C   DRAWS THE GRAPHICAL REPRESENTATION OF FY(I) VS I FOR I=1,N ON THE
C  LINE PRINTER. ERROR BARS MAY ALSO BE DRAWN ABOUT THE Y VALUE OF
C  EACH POINT FROM FY(I)-FYE(I) TO (FY(I)+FYE(I). THE NUMERICAL VALUES
C  OF FX(I), FY(I) AND FYE(I) ARE ALSO LISTED FOR EACH POINT.
C
C  MULTIPLE FUNCTIONS MAY BE OVERPLOTTED AT EACH VALUE OF I IF NF > 1.
C  IN THIS CASE FY(I,J) IS PLOTTED, WITH J=1,NF FOR EACH
C  POINT I.  IF NF=0 OR 1, THEN ONLY ONE FUNCTION (FY(I)) IS USED.
C
      EXTERNAL FX,FY,FYE,AF,DPLFX0
      CHARACTER*(*) TITLE
      CHARACTER*1 BLNK,XP,MINUS,PLUS,GRAT,ES
     >          ,STAR,A1Y,A1S,GRTHAN(2),CC
      REAL SCAL(8),LOGTAB(9)
      CHARACTER*8 TEMP8
      CHARACTER*1 XLOC(8,2)
      CHARACTER*4 BUFW(64), BUF2W(64),BLANK
      EQUIVALENCE (BUF,BUFW), (BUF2,BUF2W)
C
      CHARACTER*1 BIN3(3),CUM3(3),ERR3(3)
C
      CHARACTER*4 IDEQU
C
      INCLUDE 'dcomti.INC'
      INCLUDE 'dcomli.INC'
      INCLUDE 'dpmode.INC'
C
      CHARACTER*1 BBV(4),UND(3),OVR(3),A1DEC(16),C1ZRO,CHAR
C
C
      CHARACTER*4 MYPL
C
      INTEGER DPLEXP,DPSCAL
      INTEGER NTIK(2)
      INTEGER SFLAG1
      LOGICAL SLCFLG,EJT
      INTEGER IYE(10),KY(10),KYE(10),LOCY(10),LOCYE(10)
C
      DATA BLNK/' '/,XP/'X'/,MINUS/'-'/,PLUS/'+'/
     >  ,ES/'E'/,STAR/'*'/,A1Y/'Y'/, A1S/'S'/,GRTHAN/'>','<'/
      DATA GRAT/'I'/
      DATA XLOC/
     >'L','O',' ','E','D','G','E',' ',' ','M','I','D','B','I','N',' '/
      DATA BIN3/'B','I','N'/, CUM3/'C','U','M'/, ERR3/'E','R','R'/
      DATA BLANK/'    '/, IDEQU/'ID= '/, IBLANK/4H    /
      DATA BBV/' ','|','|','V'/
      DATA UND/'U','N','D'/, OVR/'O','V','R'/
      DATA LOGTAB/0.,.30103,.47712,.60206,.69897,.77815,.84510,.90309,
     >           .95424/
      DATA A1DEC/'O','1','2','3','4','5','6','7','8','9',
     >           'A','B','C','D','E','F'/
      DATA IZRO/0/
C
C       UNPACK TITLE INTO THREE SUBTITLES
      CALL DPTITL(TITLE,NTITLE,0)
C
      IF(IPLOT.EQ.0) GO TO 900
      NF1=MAX0(1,NF)
      SLCFLG=(SLFLAG.EQ.0.OR.NF.GT.1)
      WRITE(C1ZRO,'(A1)') IZRO
C
C      SET UP POINTERS TO BUF FOR THOSE ITEMS TO BE PRINTED
      KBIN=4
      KCUM=8
      IF(L2SUMS.EQ.0.OR.N.LE.0) KCUM=0
      KT=3
      KX=6
      KA=7
      KYTOT=0
      DO 2 I=1,NF1
      KY(I)=KA
      IF(N.LE.0) KY(I)=0
      IERR=-1
      WRITE(MYPL,'(A4)') PLTCHR(I)
      DO 1 K=1,16
    1 IF(MYPL(4:4).EQ.A1DEC(K)) IERR=K-1
      IF(IERR.EQ.-1) IERR=ERRS
      IYE(I)=MOD(IERR,4)
      KYE(I)=KA
      IF(IYE(I).EQ.2) KYE(I)=2*KA
      IF(N.LE.0.OR.IERR.EQ.0) KYE(I)=0
    2 KYTOT=KYTOT+KY(I)+KYE(I)
      NAFS=NAF
      IF(XSMTH.GT.0.) NAFS=NAFS+1
      KAFS=NAFS*KA
      KCOL=MAX0(60,MIN0(256,LCOL-1))
      KMAX=KCOL-KBIN-KT-KX-40
      IF(KCUM+KYTOT+KAFS.LE.KMAX) GO TO 5
C       WONT FIT ON LINE, REDUCE NUMBER OF ITEMS
      KCUM=0
      IF(KYTOT+KAFS.LE.KMAX) GO TO 5
      DO 3 I=1,NF1
      J=NF1-I+1
      KYTOT=KYTOT-KYE(J)
      KYE(J)=0
      IF(KYTOT+KAFS.LE.KMAX) GO TO 5
    3 CONTINUE
      NAFS=MAX0(0,(KMAX-KYTOT)/KA)
      KAFS=NAFS*KA
      DO 4 I=1,NF1
      J=NF1-I+1
      IF(KYTOT+KAFS.LE.KMAX) GO TO 5
      KYTOT=KYTOT-KY(J)
    4 KY(J)=0
C
   5  LOCB=1
      LOCC=LOCB+KBIN
      LOCY(1)=LOCC+KCUM
      DO 6 I=1,NF1
      IF(I.GT.1) LOCY(I)=LOCYE(I-1)+KYE(I-1)
    6 LOCYE(I)=LOCY(I)+KY(I)
      LOCAFS=LOCYE(NF1)+KYE(NF1)
      LOCT=LOCAFS+KAFS
      LOCX=LOCT+KT
      LOCG=LOCX+KX+1
      NBUFW=MIN0(64,(KCOL+3)/4)
      LLEN=((KCOL-LOCG)/10)*10
C
C       TAKE CARE OF SCALING
C
      IF (IAUTO(1).NE.0.AND.N.GT.0) GO TO 20
      DO 10 I=1,4
   10 ASCALE(I,2)=SCAL(I+4)
   20 ITEMP=MIN0(1,IAUTO(1))
      NTIK(1)=LLEN/10
      NTIK(2)=0
      ISC=DPSCAL(FY,N,NF,ITEMP,ILOG(1),IEDGE(1),IZERO(1),NTIK
     >            ,ASCALE(1,2),ISCALE(1,2),2)
C       UNPACK PWR AND NUM OF DECIMALS FROM ISCALE(3
      IPWR=MOD(ISCALE(3,2)+500,1000)-500
      NDECI=(ISCALE(3,2)+500)/1000
      FDECI=0.10**MAX0(0,NDECI-1)
C       NOW GET EXPONENTS AND # DECIMAL PLACES FOR X AND Y LISTS
C       DONT DO SLICING FOR X COORDINATE
      SFLAG1=SLFLAG
      SLFLAG=0
      IF(N.GT.0) GO TO 28
      DO 27 I=1,4
   27 ASCALE(I,1)=SCAL(I)
      IPX=DPLEXP(DPLFX0,1,50,1,1,5,LENX,NDECX,0,0,8)
      GO TO 29
   28 IPX=DPLEXP(FX,1,N,1,1,5,LENX,NDECX,0,0,8)
   29 SLFLAG=SFLAG1
      IPY=DPLEXP(FY,1,N,1,1,5,LENY,NDECY,0,0,8)
      NDECYE=NDECY
      IF(NDECY.EQ.0.AND.NUMFMT.NE.0) NDECYE=2
      EX=10.**IPX
      EY=10.**IPY
C
C       LINE 1        PAGE HEADER
C
      EJT=EJECT.NE.0.AND.ISC.EQ.0
      CALL DWRHDR(LPUNIT,EJT)
C
      NTICS=MAX1(1.0,ASCALE(3,2))
      NTICP1=NTICS+1
      NSP=LLEN/NTICS
      LLEN=NSP*NTICS
      LENBUF=LOCG+LLEN
      RLEN=FLOAT(LLEN)
C
C       LINE 2              ID=AAAA        TITLE
C
      DO 30 I=1,NBUFW
   30 BUFW(I)=BLANK
      IF(IDA.NE.IBLANK) BUFW(1)=IDEQU
      WRITE(BUFW(2),'(A4)') IDA
      WRITE(BUFW(4),'(A4)') JBNAM(1)
      WRITE(BUFW(5),'(A4)') JBNAM(2)
      K1=MIN0(40,MAX0(LOCG,22)) + 1
      K=LENTI(1)
      K=MIN0(KCOL-K1-1,MAX0(1,K))
      DO 34 I=1,K
   34 BUF(K1+I)=SUBTIT(LOCTI(1)+I)
      K=K+K1
      WRITE(LPUNIT,90) (BUF(I),I=1,K)
      IF(N.GT.0) GO TO 42
      IF(NAF.GT.0) GO TO 55
      WRITE(LPUNIT,41)
   41 FORMAT(/,' NO DATA POINTS -- OUTPUT SUPPRESSED')
      GO TO 900
C
   42 IF(ISC.EQ.0) GO TO 55
C
C       ERROR OR EMPTY PLOT
      TEMP1=FY(1,1)
      TEMP2=FY(2,1)
      TEMP3=FY(N,1)
      IF(TEMP1.NE.TEMP2.OR.TEMP3.NE.TEMP2) GO TO 55
      IF(ISC.EQ.1) WRITE(LPUNIT,45) TEMP2
   45 FORMAT(' CONTENTS ALL',G10.3,
     >       ' -- HISTOGRAM SUPPRESSED')
      IF(ISC.EQ.2) WRITE(LPUNIT,50)
   50 FORMAT(' LOG SCALE PROBLEM -- DATA ALL LE ZERO')
      GO TO 800
C
C       LINE 3                  Y SUBTITLE    Y  E XX
C
   55 DO 60 J=1,NBUFW
   60 BUFW(J)=BLANK
      BUF(LENBUF-5)=A1Y
      IF(LENTI(3).LE.0) GO TO 85
      K=LENTI(3)
      K=MAX0(1,MIN0(LLEN-4,K))
      K1=LOCG+(LLEN-K)/2-2
      DO 80 J=1,K
   80 BUF(K1+J)=SUBTIT(LOCTI(3)+J)
   85 IF(ILOG(1).NE.0) GO TO 87
      BUF(LENBUF-3)=ES
      CALL DPITOA(IPWR,BUF(LENBUF-2),NCHR,3,10)
   87 WRITE(LPUNIT,90) (BUF(I),I=1,LENBUF)
   90 FORMAT (1H ,255A1,A1)
C
C       LINE 4                              LO/CEN EDGE  TIC0  TIC1 ---
C
      IXLOC=1
      IF(LOWIN.EQ.0) IXLOC=2
      IYMN=ISCALE(1,2)
      IDY=ISCALE(2,2)
      DO 100 J=1,NBUFW
  100 BUFW(J)=BLANK
      DO 105 J=1,8
  105 BUF(LOCX-2+J)=XLOC(J,IXLOC)
      DO 110 I=1,NTICP1
      Y=(IYMN+IDY*(I-1))*FDECI
      CALL DPRTOA(Y,TEMP8,N1,7,NDECI)
      IB=LOCG+MAX0(NSP*(I-1)-N1/2,0)
      IF(I.EQ.NTICP1) IB=LENBUF-N1+1
      IF(ILOG(1).EQ.0) GO TO 110
      IF(I.EQ.NTICP1) IB=IB-1
      BUF(IB)=ES
      IB=IB+1
  110 CALL DPRTOA (Y,BUF(IB),N1,N1,NDECI)
      WRITE(LPUNIT,90) (BUF(I),I=1,LENBUF)
C
C       LINE 5    BIN  YCUM  Y YERR  A  B ..  0  1 .. S  X  +------
C  ALSO LAST LINE IS FILLED HERE BUT PRINTED LATER.
C
      CHAR=A1Y
      WRITE(MYPL,'(A4)') PLTCHR(1)
      IF(NF.GT.1.AND.MYPL(1:1).NE.BLNK) CHAR=MYPL(1:1)
      DO 120 I=1,NBUFW
      BUF2W(I)=BLANK
  120 BUFW(I)=BLANK
      DO 125 I=1,3
      IF(KBIN.GT.0) BUF(LOCB+KBIN-4+I)=BIN3(I)
      IF(KCUM.GT.0) BUF(LOCC+KCUM-4+I)=CUM3(I)
  125 CONTINUE
      IF(KCUM.LE.0) GO TO 130
      BUF(LOCC+KCUM-4)=CHAR
      BUF2(LOCC+KCUM-4)=ES
      CALL DPITOA(IPY,BUF2(LOCC+KCUM-3),NCHR,-3,10)
  130 IF(N.LE.0) GO TO 140
      DO 138 I=1,NF1
      IF(I.GT.1) WRITE(CHAR,'(A1)') PLTCHR(I)
      LOCI=LOCY(I)+KY(I)
      BUF(LOCI-1)=CHAR
      BUF2(LOCI-4)=ES
      CALL DPITOA(IPY,BUF2(LOCI-3),NCHR,-3,10)
      IF(KYE(I).LE.0) GO TO 138
      NERR=KYE(I)/KA
      DO 137 K=1,NERR
      LOCI=LOCYE(I)+ K*KA
      BUF(LOCI-4)=CHAR
      DO 135 J=1,3
  135 BUF(LOCI-4+J)=ERR3(J)
      BUF2(LOCI-4)=ES
      CALL DPITOA(IPY,BUF2(LOCI-3),NCHR,-3,10)
  137 CONTINUE
  138 CONTINUE
  140 IF(NAFS.LE.0) GO TO 150
      DO 145 I=1,NAFS
      LOCI=LOCAFS+I*KA-1
      BUF(LOCI)=A1DEC(I)
      IF(I.GT.NAF) BUF(LOCI)=A1S
      BUF2(LOCI-3)=ES
  145 CALL DPITOA(IPY,BUF2(LOCI-2),NCHR,-3,10)
  150 BUF(LOCG-2)=XP
      BUF2(LOCG-5)=ES
      CALL DPITOA(IPX,BUF2(LOCG-4),NCHR,-3,10)
C
      DO 195 I=1,LLEN
  195 BUF2(LOCG+I)=MINUS
      DO 200 I=1,NTICP1
  200 BUF2(LOCG+NSP*(I-1))=PLUS
      IF(NTICS.GT.4) GO TO 260
      NSUB=MAX1(1.0,ASCALE(4,2))
      NSUB1=NSUB-1
      IF (ILOG(1).EQ.1) GO TO 230
      IF(NSUB1.LE.0) GO TO 260
      J=1
      TEMP=NSP/NSUB
      DO 220 I=1,NTICS
      DO 210 I2=1,NSUB1
      K=TEMP*I2
  210 BUF2(LOCG+J+K-1)=PLUS
  220 J=J+NSP
      GO TO 260
  230 J=1
      DO 250 I=1,NTICS
      DO 240 I2=1,NSUB
      K=NSP*LOGTAB(I2)
  240 BUF2(LOCG+J+K-1)=PLUS
  250 J=J+NSP
  260 WRITE(LPUNIT,90) (BUF(J-1),J=2,LOCG),(BUF2(I),I=LOCG,LENBUF)
C
C       SET UP VARIABLES FOR LOOP BELOW
C
      CUM=0.
      PY=10.**IPWR *FDECI
      MIN=ISCALE(1,2)
      DEL=FLOAT(NTICS)*AMAX1(1.,ASCALE(2,2)/PY)
      SSR=0.0
      SSRN=0.0
      SMSSR=0.
      MT=LENTI(2)
      ITIT=MAX0(1,(N-MT)/2)
      ITITL=ITIT+MT-1
      ITITLL=ITITL+4
      IF(MT.LE.0.OR.MT.GT.55) ITITLL=0
      ITRUNC=0
      CC=BLNK
      IF(OVPRT.NE.0) CC=PLUS
C
C       LOOP OVER THE DATA POINTS, GENERATING A LINE PER POINT
      IMAX=N
      IF(N.LE.0) IMAX=50
C       USE 50 POINTS IF ONLY ANALYTIC FUNCTION SUPPLIED (N=0)
      DO 390 I=1,IMAX
C
C       INITIALIZE LINE BUFFER FOR A NEW LINE OF DATA
      DO 280 J=1,NBUFW
  280 BUFW(J)=BLANK
      BUF(LOCG)=GRAT
      BUF(NSP*NTICS+LOCG)=GRAT
      IF(KBIN.GT.0) CALL DPITOA(I,BUF(LOCB), NCHR,-KBIN,10)
      IF (L1GRAT.EQ.0) GO TO 300
      DO 290 K=1,NTICS
      BUF(NSP*K+LOCG)=GRAT
      IF((IMAX-I).LE.4) GO TO 290
      IF(MOD(I,10).EQ.0) BUF(NSP*K+LOCG)=PLUS
  290 CONTINUE
C
  300 IF(N.GT.0) GO TO 302
C       SINCE NO DATA POINTS, GET X FROM ASCALE RANGE WITH 50 BINS
      X=DPLFX0(I)
      X1=X
      GO TO 371
C
C       LOOP OVER ALL NF DATA SETS FOR THIS POINT
  302 DO 370 JFREV=1,NF1
C      DO FIRST DATA SET LAST, TO LEAVE ITS VARIABLES AVAIL FOR LATER
      JF=NF1-JFREV+1
      X=FX(I,JF)
      IF(SLCFLG) Y=FY(I,JF)
      IF(.NOT.SLCFLG) Y=DPSLCF(FY,I)
      ERL=Y
      ERH=Y
      E=0.
C       CHECK IF NON-SYMMETRIC ERRORS IN Y
      IF(IYE(JF).EQ.0) GO TO 305
      IF(SLCFLG.AND.NF.EQ.0) E=FYE(I,1,1,1)
      IF(SLCFLG.AND.NF.GT.0) E=FYE(I,JF,1,1)
      IF(.NOT.SLCFLG) E=DPSLCE(FYE,I,1,1)
      ERH=Y+E
      IF(IYE(JF).EQ.1) GO TO 304
      IF(SLCFLG.AND.NF.EQ.0) E=FYE(I,2,1,1)
      IF(SLCFLG.AND.NF.GT.0) E=FYE(I,JF,2,1)
      IF(.NOT.SLCFLG) E=DPSLCE(FYE,I,2,1)
  304 ERL=Y-E
  305 YVAL=Y
      IYTRNC=0
C      IF Y OVERFLOW, MARK Y FIELD WITH < OR > (AND ALSO YCUM).
      IF(FYMAX.GT.0.0 .AND. YVAL.GE.FYMAX) IYTRNC=1
      IF(FYMAX.GT.0.0 .AND. YVAL.LE.-FYMAX) IYTRNC=2
      IF(KY(JF).LE.0) GO TO 372
      CALL DPRTOA(YVAL/EY,BUF(LOCY(JF)),NCHR,-KY(JF),NDECY)
      IF(IYTRNC.EQ.0) GO TO 372
      BUF(LOCY(JF)+KY(JF)-NCHR-1)=GRTHAN(IYTRNC)
      IF(JF.EQ.1) ITRUNC=IYTRNC
  372 IF(JF.GT.1.OR.KCUM.LE.0) GO TO 373
      CUM=CUM+Y
      CALL DPRTOA(CUM/EY,BUF(LOCC),NCHR,-KCUM,NDECY)
      IF(ITRUNC.NE.0) BUF(LOCC+KCUM-NCHR-1)=GRTHAN(ITRUNC)
  373 IF(KYE(JF).LE.0) GO TO 374
      CALL DPRTOA((ERH-Y)/EY,BUF(LOCYE(JF)),NCHR,-KYE(JF),NDECYE)
      IF(KYE(JF).EQ.2*KA) CALL DPRTOA((ERL-Y)/EY,BUF(LOCYE(JF)),
     >                               NCHR,-KA,NDECYE)
      IF(JF.GT.1) GO TO 308
C       SAVE X AND Y FOR USE IN FUNCTION PLOT LATER
  374 X1=X
      Y1=Y
      E1=E
      ITRUNC=IYTRNC
C
  308 IF (ILOG(1).EQ.0) GO TO 320
      IF(Y.GT.0.0) GO TO 310
      Y=PY*MIN
      GO TO 312
  310 Y=ALOG10(Y)
  312 IF(ERL.GT.0.0) GO TO 314
      ERL=PY*MIN
      GO TO 316
  314 ERL=ALOG10(ERL)
  316 IF(ERH.GT.0.0) GO TO 318
      ERH=PY*MIN
      GO TO 320
  318 ERH=ALOG10(ERH)
  320 IPL =AMAX1(0.,AMIN1(RLEN,((  Y/PY-MIN)/DEL)*RLEN)) + 0.5
      IPL1=AMAX1(0.,AMIN1(RLEN,((ERL/PY-MIN)/DEL)*RLEN)) + 0.5
      IPL2=AMAX1(0.,AMIN1(RLEN,((ERH/PY-MIN)/DEL)*RLEN)) + 0.5
      WRITE(CHAR,'(A1)') PLTCHR(JF)
      IF(CHAR.EQ.BLNK) CHAR=STAR
      IF(IYTRNC.NE.0) CHAR=GRTHAN(IYTRNC)
      IF(CHAR.EQ.C1ZRO) CHAR=BLNK
      IF(Y/PY.GE.MIN) BUF(IPL+LOCG)=CHAR
C
C       INSERT FILL CHARACTERS IF HIST MODE (BUT ONLY ON FIRST FUNCTION)
      IF (L1FILL.EQ.0.OR.JF.GT.1) GO TO 330
      IF(Y/PY.LE.MIN) GO TO 330
      DO 325 JL=1,IPL
      J=JL-1+LOCG
      IF(BUF(J).EQ.BLNK.OR.
     >(L1GRAT.NE.0.AND.(BUF(J).EQ.GRAT.OR.BUF(J).EQ.PLUS))) BUF(J)=XP
  325 CONTINUE
C
C       INSERT ERROR BARS IF ERRS SET
  330 IF (IYE(JF).EQ.0) GO TO 370
      IF(IPL1.GE.IPL.AND.IPL.GE.IPL2) GO TO 370
      DO 360 JL=IPL1,IPL2
      J=JL+LOCG
      IF(BUF(J).EQ.BLNK.OR.
     >(L1GRAT.NE.0.AND.(BUF(J).EQ.GRAT.OR.BUF(J).EQ.PLUS))) BUF(J)=MINUS
  360 CONTINUE
  370 CONTINUE
C
C       LINE NN          (CUM  Y  ERR  X   I  AND GRAPH OF DATA VALUE)
C
  371 IF(I.GE.ITIT.AND.I.LE.ITITL) BUF(LOCT+2)=SUBTIT(LOCTI(2)+I-ITIT+1)
      IF(I.GT.ITITL.AND.I.LE.ITITLL) BUF(LOCT+2)=BBV(I-ITITL)
      IF(NWCALL.NE.1) GO TO 3745
      IF(I.GT.1.AND.I.LT.IMAX) GO TO 3745
C      MARK EDGE BINS AS UNDER/OVERFLOW IF OMIT IS FALSE
      DO 3742 J=1,KX
 3742 BUF(LOCX+J-1)=BLNK
      DO 3743 J=1,3
      IF(I.EQ.1) BUF(LOCX+KX-4+J)=UND(J)
      IF(I.EQ.IMAX) BUF(LOCX+KX-4+J)=OVR(J)
 3743 CONTINUE
      GO TO 3747
 3745 CALL DPRTOA(X/EX,BUF(LOCX),NCHR,-KX,-NDECX)
 3747 CONTINUE
      IF(OVPRT.EQ.0) GO TO 3765
      WRITE(LPUNIT,90) (BUF(J),J=1,LENBUF)
      DO 3750 J=1,NBUFW
 3750 BUFW(J)=BLANK
      LFULL=0
      IF(I.NE.ITITLL) GO TO 3765
      BUF(LOCT+2)=BBV(2)
      LFULL=1
C
C       LOOP OVER ANALYTIC FUNCTIONS, IF ANY
C       AND DO THE SMOOTHING, IF CALLED FOR.
C
 3765 NMAX=NAF
      IF(XSMTH.GT.0.) NMAX=NMAX+1
      IF(NMAX.LE.0) GO TO 390
      LFULL=1
      IF(LOWIN.EQ.0) GO TO 377
      IF(N.LE.0) GO TO 377
      IF(I.LT.IMAX) X1=X1+(FX(I+1,1)-X1)/2.0
      IF(I.GE.IMAX) X1=X1+(X1-FX(I-1,1))/2.0
  377 DO 388 JF=1,NMAX
      CHAR=A1DEC(JF)
      IF(JF.GT.NAF) GO TO 378
C       1-D FUNCTION, OR SLICE OF 2-D FUNCTION BEING DONE
      IF(SLCFLG) Y=AF(X1,JF)
      IF(.NOT.SLCFLG) Y=DFNSLC(AF,X1,FY,JF)
      IF(JF.GT.1) GO TO 382
      GO TO 380
C       SMOOTH CURVE BEING DONE
  378 Y=DSMTH1(X1,FX,FY,FYE,N,SLCFLG)
      CHAR=A1S
C
C       COMPUTE CHI SQUARE IF ERRORS SPECIFIED, AND ANAL FUNC
  380 IF(IYE(JF).EQ.0.OR.N.LE.0) GO TO 382
      IF(IYE(JF).EQ.1) GO TO 381
C      SINCE ASSYMMETRIC ERROR BARS, USE ERROR ON CORRESPONDING SIDE
      IER=1
      IF(Y.LT.Y1) IER=2
      IF(SLCFLG.AND.NF.EQ.0) E1=FYE(I,IER,1,1)
      IF(SLCFLG.AND.NF.GT.0) E1=FYE(I,JF,IER,1)
      IF(.NOT.SLCFLG) E1=DPSLCE(FYE,I,IER,1)
  381 IF(E1.LE.0.0) GO TO 382
C      PROTECT AGAINST UNDER/OVER FLOWS
      TEMP=(AMAX1(1.E-15*E1,AMIN1(1.E15*E1,ABS(Y1-Y)))/E1)**2
      IF(JF.GT.NAF) SMSSR=SMSSR+TEMP
      IF(JF.GT.NAF) GO TO 382
      SSR=SSR+TEMP
      SSRN=SSRN+1.0
  382 IF(JF.GT.NAFS) GO TO 384
C       USE SAME NUM OF DECIMAL PLACES FOR ANALYTIC AS FOR ERRORS.
      CALL DPRTOA(Y/EY,BUF(LOCAFS+(JF-1)*KA),NCHR,-KA,NDECYE)
  384 IF(ILOG(1).EQ.0) GO TO 385
      IF(Y.LE.0.0) GO TO 388
      Y=ALOG10(Y)
  385 RPL =(Y/PY-MIN)/DEL*RLEN + 0.5
      IPL=RPL
      IF(IPL.LT.0.OR.IPL.GT.LLEN) GO TO 388
      IF(OVPRT.NE.0) GO TO 387
      WRITE(MYPL,'(A4)') PLTCHR(1)
      IF(BUF(LOCG+IPL).EQ.MYPL(1:1).AND.MYPL(1:1).NE.BLNK) GO TO 388
C       OVERPLOT 'O' FOR FUNCTION, 'S' FOR SMOOTH CURVE
  387 BUF(LOCG+IPL)=CHAR
  388 CONTINUE
C
  390 IF(OVPRT.EQ.0.OR.LFULL.EQ.1) WRITE(LPUNIT,392) CC,
     >                             (BUF(J),J=1,LENBUF)
  392 FORMAT(A1,255A1)
C
C       LAST LINE       E NN  E NN  E NN  E NN    +---------+----
C      (BUF2 WAS FILLED WHILE LINE 5 WAS BEING DONE ABOVE)
C
      WRITE(LPUNIT,90) (BUF2(J),J=1,LENBUF)
C
C       SMOOTHED CHISQ
C
      IF(N.LE.0) RETURN
      IF(XSMTH.GT.0.) WRITE(LPUNIT,485) PLTCHR(1),SMSSR,XSMTH
  485 FORMAT(/,' (',A1,'-S) CHI SQUARE =',G12.3,
     >       ' SMOOTHING SIGMA =',G12.3)
C
C        SSR, SSRN
C
      IF(IYE(1).EQ.0.OR.NAF.LE.0) GO TO 800
      WRITE(LPUNIT,490) PLTCHR(1),SSR,SSRN
  490 FORMAT(/,' (',A1,'-O) CHI SQUARE =',G12.3,' FOR',F8.0,' TERMS')
C
C       OUTPUT NUMBER OF CALLS, AND UNDER/OVER FLOWS
  800 IF(ICALLS.LE.0.OR.NWCALL.LE.0) GO TO 900
      NW=MIN0(3,NWCALL)
      WRITE(LPUNIT,810) (BLNK,NCALLS(I),I=1,NW)
  810 FORMAT(/' #CALLS=',A1,I8,2(A1,'/',I8),'    = UNDER / HIST / OVER')
C
C       OUTPUT STATISTICS, IF FLAG SAYS SO
C
  900 IF(MOD(ISTATS,2).EQ.0) RETURN
      ISUM=SUM1
      IF(IPLOT.EQ.0) WRITE(LPUNIT,905) IDA,STATYP,ISUM,SUMW,BLNK,
     >               TITLE
  905 FORMAT(/' ',A4,' STATS FROM ',A4,', #CALLS=',I9,', WTS=',G12.5,
     >       A3,A70/(62X,A70))
      IF(IPLOT.NE.0) WRITE(LPUNIT,905) BLANK,STATYP,ISUM,SUMW
  915 WRITE(LPUNIT,920) XP,XAVG,XDAVG,XSIG,XDSIG,XLIMIT(1),XP,XLIMIT(2),
     >      XP,XMNX
  920 FORMAT(6X,'<',A1,'>=',G12.5,'+-',G9.3,', SD=',G11.5,'+-',G9.3,
     > '  FOR',G10.3,'< ',A1,' <',G10.3,'  (EXTREME',A2,'=',2G10.3,')')
      RETURN
      END
      FUNCTION DPLFX0(I)
C
C
C  THIS FUNCTION SUPPLIES AN X VALUE BASED ON THE CURRENTLY
C  SET VALUES IN THE SCALING ARRAY ASCALE. (USED BY DPLP1
C  WHEN NO DATA BUT AN ANALYTIC FUNCTION IS SUPPLIED).
C
      INCLUDE 'dpmode.INC'
C
      TMP=I-1
      IF(LOWIN.NE.0) TMP=TMP+.5
      DPLFX0 = ASCALE(1,1) + TMP*ASCALE(2,1)*ASCALE(3,1)/50.
      RETURN
      END
