      SUBROUTINE DPLP2(X2,Y2,Z2,Z2E,NX,NY,TITLE,SMAN,FF,KF,FC,KC)
C
      IMPLICIT INTEGER(A-H,O-R,T-Z)
      EXTERNAL X2,Y2,Z2,Z2E,FF,FC
      CHARACTER*(*) TITLE
      REAL X2,Y2,Z2,Z2E,SMAN(16),FF,FC
C
C GLOSSARY OF THE VARIABLES USED IN THIS SUBROUTINE
C
C MB     = BASE NUMBER FOR ARITHMETIC FOR SCATTER PLOTS
C          ( DEFAULT = 10 )
C MS     = SCALING FACTOR FOR NORMALISATION IN THE Z DIRECTION.
C ZAUTO  = IF TRUE, MS IS CALCULATED INTERNALLY, OTHERWISE MS=1.
C MC     = NO. OF COLUMNS TO BE USED PER ELEMENT
C MW     = MAX NUMBER OF CHARACTERS TO BE USED TO REPRESENT A POINT
C          IN THE SCATTER PLOT OR TABLE.
C MN     = MAXIMUM VALUE TO BE PRINTED IN THE PLOT OR TABLE.
C          IF XYAUTO IS TRUE, THEN MN IS CALCULATED INTERNALLY
C          OTHERWISE, IT IS OBTAINED FROM THE USER.
C NPL    = MAXIMUM NUMBER OF ELEMENTS OF THE PLOT OR TABLE TO BE
C          PRINTED PER LINE.
C MO     = VALUE AT WHICH OVERFLOW FIRST OCCURS IN THE PRINTED
C          NUMBER.
C MT     = NUMBER OF BYTES OF TITLE IN THE TITLE TO BE PRINTED.
C A      = INDEX OF FIRST ELEMENT TO BE PRINTED ON THE LINE
C C      = INDEX OF LAST  ELEMENT TO BE PRINTED ON THE LINE
C D      = NUMBER OF ELEMENTS TO BE PRINTED IN THE CURRENT LINE.
C IPX    = POWER OF 10 PLUS ONE OF MAXIMUM X VALUE
C IPY    = POWER OF 10 PLUS ONE OF MAXIMUM Y VALUE
C IPTX   = POWER OF 10 PLUS ONE OF MAXIMUM VALUE OF SUMS
C          PROJECTED ON X
C IPTY   = POWER OF 10 PLUS ONE OF MAXIMUM VALUE OF SUMS
C          PROJECTED ON Y
C PX     = 10**IPX
C PY     = 10**IPY
C PTX    = 10**IPTX
C PTY    = 10**IPTY
C ML     = NUMBER OF LINES PRINTED SO FAR ON THE PAGE ( EXCLUDES
C          OVERPRINTS ).
C NL     = NUMBER OF LINES PRINTED FOR CURRENT SECTION OF TABLE
C ST     = SUM OF CONTENTS OF HISTOGRAM
C
C THE FOLLOWING VARIABLES DEFINE THE SCALING ETC. OF LPUT2
C
C SYMBOL = THE BASE SPECIF IED BY THE USER FOR THE SCATTER PLOT
C          CHARACTERS ( DEFAULT = 10 )
C XYAUTO = A TRUE VALUE WILL AUTOMATICALLY ADJUST THE NUMBER
C          OF CHARACTERS PER VARIABLE.
C
C
      EXTERNAL DPSLCF
      REAL DPSLCF
      INTEGER DPLEXP
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomti.INC'
      INCLUDE 'dcomli.INC'
      INCLUDE 'dcomfp.INC'
C
      REAL PTY,PTX,X,T,XP1,XP2,YP1,YP2,DY,RT,PX,PY,PZ
      INTEGER Y(224)
      CHARACTER*4 P4(56,4)
      CHARACTER*1 P(224,4),SP(4), L1Y(224)
      EQUIVALENCE (P4(1,1),P(1,1),L1Y(1))
      CHARACTER*4 C0
      EQUIVALENCE (SP(1),C0)
      REAL U1,U2,U3,U4
      INTEGER S,S0
      CHARACTER*1 CC,CCALLS,UNSCOR,C1TMP
      CHARACTER*8 HSYMB,DCALL(3),YTOTE,XTOTE
      CHARACTER*1 L1TOT(8)
      EQUIVALENCE (L1TOT(1),YTOTE)
C
      CHARACTER*1 PLUS,HI,A1X,A1Y,OH,L1BLNK,MINUS,L1ZRO
      CHARACTER*1 L1E,L1EQAL,L1STAR
      LOGICAL OMIT,EJT
      CHARACTER*1 SYMZLO(8)
      EQUIVALENCE (SYMZLO(1),HSYMB)
C
      CHARACTER*4 UND,OVR
      CHARACTER*1 L1UND(4),L1OVR(4)
      EQUIVALENCE (UND,L1UND(1)),(OVR,L1OVR(1))
C
C SET UP THE OBJECT TIME FORMATS
C
      CHARACTER*4 YINDX1(8),XTOT1(8),YLABL(7)
      CHARACTER*4 XTOT(7)
C
      CHARACTER*4 YINDX(13)
C
      CHARACTER*4 BLANK,ZERO,BBBZRO
      CHARACTER*4 IDEQU,IDEQ
C
      REAL TEMP,ZLTMP,SLTMP,FMAX,FMIN,ZVAL,ZIJTOT
      CHARACTER*1 MMGT(4),BBV(4)
      CHARACTER*8 DBUF(32), DBLANK
      CHARACTER*4 CBUF(64)
      INTEGER IBLANK
      EQUIVALENCE (DBUF(1),BUF(1),CBUF(1))
      REAL ROUND,RNUM
C
      DATA UNSCOR/'_'/
      DATA MCMAX/224/
      DATA PLUS/'+'/,HI/'I'/,A1X/'X'/,A1Y/'Y'/,OH/'O'/,L1STAR/'*'/
      DATA L1BLNK/' '/, MINUS/'-'/, L1ZRO/'0'/, L1E/'E'/, L1EQAL/'='/
      DATA HSYMB/' SYM ZLO'/,YTOTE/' YTOT.E'/, XTOTE/'XTOT.E'/
      DATA DCALL/'0       ',' #CALLS=','        '/
      DATA UND/' UND'/, OVR/' OVR'/
      DATA YINDX1  /'(4H0','Z.E,','I3,6','X,2H','J , ','240I','CCCC'
     >             ,')   '/
     >    ,XTOT1 /'(5X,','A6,','I3,','1X,','N','I','N',',I8)'/
     >    ,YLABL  /'(12X',',3H','\Y ,','N','A1,','2H.E',',I3)'/
     >    ,XTOT  /'(5X,','A6,','I3,','1X,','N','A1,','I8)'/
C
      DATA YINDX  /'(1H0','    ',', 12','X,2H','J , ','NNNN','   I',
     >        'CCCC',',  ''',' J=''',',I3,',''','',','I3/)'/
      DATA  BLANK/'    '/, ZERO/'0   '/, BBBZRO/'   0'/
     >       , IDEQU/'ID= '/
      DATA MMGT/' ','-','-','>'/, BBV/' ','|','|','V'/
      DATA DBLANK/'        '/, IBLANK/4H    /
C
C ROUNDING FUNCTION FOR +VE AND -VE NUMBERS
      ROUND(RNUM)=RNUM+SIGN(0.5,RNUM)
C
C UNPACK TITLE INTO ITS SUBTITLES
      CALL DPTITL(TITLE,NTITLE,0)
C      SET UP CARIAGE CONTROL CHARACTER FOR OVER-PRINTING
      CC=L1BLNK
      CCALLS=MINUS
      IF(OVPRT.NE.0) CC=PLUS
      IF(OVPRT.NE.0) CCALLS=UNSCOR
C
      IF(IPLOT.EQ.0) GO TO 6000
C
C
      OMIT= IEDGE(1).EQ.1  .AND.  NX.GE.2  .AND.  NY.GE.2
C
      M=0
      ZIJTOT=0.
      SSR=0.
      SSRN=0.
      IF (NX .LT. 1 .OR. NY .LT. 1) GO TO 100
      IPZ=0
      PZ=1.0
C
C SCALE FACTORS FOR THE BINNED Z VALUES
C
      MB=MAX0(10,MIN0(36,L2SYM))
      MW=L2COL
      M=MB**(MW-1)
      MS=1
      ST=0.0
      M=1
C
C EXCLUDE OVERFLOWS AND UNDERFLOWS AS REQUESTED
C
      A=1
      IF (OMIT) A=2
      B=NX+1-A
      C=NY+1-A
C
C SOME FORM OF AUTO SCALING REQUIRED.
      IF (L2CAUT.EQ.0 .AND. L2ZAUT.EQ.0 .AND. ILOG(1).EQ.0) GO TO 70
      IF(ILOG(1).NE.0) GO TO 50
C
C
C USE SCALING ROUTINE FOR Z (SUPRESS LEADING OR TRAILING ZEROS)
      ILOOP=0
   30 IF(L2CAUT.EQ.0) GO TO 31
      MW=6
      IF(L2ZAUT.EQ.0) GO TO 31
      MW=MAX0(1,MIN0(7,(LCOL-33)/NY))
      IF(MW.GE.3) MW=MW-1
   31 IF(L2ZAUT.NE.0) THEN
          IPZ=DPLEXP(Z2,A,B,A,C,MW,NC,NDEC,MB,MS,10)
      ELSE
          IPZ=DPLEXP(Z2,A,B,A,C,MW,NC,NDEC,MB,MS,9)
      ENDIF
      IF(NC.LE.0) M=0
      IF(L2CAUT.EQ.0) GO TO 60
C     USE 10 SYMBOLS ONLY WHEN L2CAUTO IS 1 AND MULTI-COLUMN (MW GT 1)
      IF(MW.EQ.1) GO TO 32
      IF(MB.EQ.10) GO TO 32
      ILOOP=ILOOP+1
      IF(ILOOP.GT.1) GO TO 32
      MB=10
      GO TO 30
   32 IF(L2ZAUT.NE.0) GO TO 33
      NC=MAX0(1,MIN0(6,IFIX(NC*ALOG10(MB+.5)+IPZ)))
      IPZ=0
   33 IF(NC.GE.MW) GO TO 60
      MW=NC
      IF(MW.EQ.2.AND.(MW+2)*NY.LT.LCOL-33) MW=MW+1
      IF(MW.EQ.1.AND.(MW+1)*NY.LT.LCOL-33) MW=MW+1
      GO TO 60
C
C DO LOG SCALING FOR Z CONTOURS
C
   50 MW=MAX0(1,MIN0(2,(LCOL-33)/NY))
      IF(L2CAUT.EQ.0) MW=MIN0(2,L2COL)
      FMIN=FPMAX
      FMAX=0.
      DO 52 I=A,B
      DO 52 J=A,C
      T=ABS(Z2(I,J))
      IF(T.EQ.0.) GO TO 52
      IF(T.LT.FMIN) FMIN=T
      IF(T.GT.FMAX) FMAX=T
   52 CONTINUE
      M=0
      IF(FMAX.EQ.0.) GO TO 100
C       LIMIT RANGE TO 4 DECADES
      FMIN=AMAX1(FMIN,FMAX/1000.)
      M=1
      NC=ALOG10(FMAX)
      IF(FMAX.LT.1.0) NC=NC-1
      IPZ=NC-3
C      SET NLOG, THE MAX NUMBER OF SYMBOLS FOR LOG PLOT
      NLOG=MIN0(MAX0(10,NX),MB**MW)
      ZLTMP=(NLOG-1)/ALOG10(FMAX/FMIN)
      SLTMP=(FMAX/FMIN)**(1./(NLOG-1))
C
C
   60 PZ=10.**IPZ
C
C SCALE FACTORS FOR THE PROJECTED TOTALS
C
   70 IF (L2SUMS.NE.0) GO TO 80
      IPTX=0
      IPTY=0
      GO TO 90
   80 SLDIR=0
      SLBEG=1
      SLWDTH=0
      CALL DPSLCI(NX,NY)
      IPTX=DPLEXP(Z2,A,B,1,1,4,0,0,0,0,6)
      SLDIR=1
      CALL DPSLCI(NX,NY)
      IPTY=DPLEXP(Z2,A,C,1,1,MAX0(4,MW),0,0,0,0,6)
      SLFLAG=0
   90 PTX=10.0**IPTX
      PTY=10.0**IPTY
C
C SCALE FACTORS FOR THE X AND Y AXIS LABELS
C
      IPX=DPLEXP(X2,1,NX,1,1,5,LENX,NDECX,0,0,8)
      IPY=DPLEXP(Y2,1,NY,1,1,MAX0(4,MW),LENY,NDECY,0,0,8)
C      DONT USE ENGINEERING NOTATION FOR VERTICLE STYLE Y LABELS
      IF(MW.LE.2) IPY=IPY-MAX0(0,NDECY-1)
      PY=10.**IPY
      PX=10.**IPX
C
C DONE SCALING
C
C PRINT OUT THE HEADING AND TITLE. RETURN IF ERRORS ARE FOUND.
C
  100 EJT= EJECT.NE.0  .AND.  M.GT.0
      CALL DWRHDR(LPUNIT,EJT)
      IDEQ=IDEQU
      IF(IDA.EQ.IBLANK) IDEQ=BLANK
      MT1=LENTI(1)
      MT1=MIN0(LCOL-23,MAX0(1,MT1))
      WRITE(LPUNIT,115) IDEQ,IDA,JBNAM,TITLE(1:MT1)
  115 FORMAT(1X,A3,A5,3X,2A4,3X,A)
      IF(NX.GE.1.AND.NY.GE.1) GO TO 130
      WRITE(LPUNIT,120)
  120 FORMAT(/' NO DATA POINTS -- OUTPUT SUPPRESSED')
      GO TO 6000
C
C SET UP COUNTERS TO GIVE THE NUMBER OF LINES PRINTED.
C
  130 NL=2
      ML=0
      ST=0
      IF (M.NE.0) GO TO 140
      WRITE(LPUNIT,9997)
 9997 FORMAT(' CONTENTS ALL ZERO -- OUTPUT SUPPRESSED')
      GO TO 5000
  140 MC=MW
      IF (MC.GE.3) MC=MC+1
      A=1
      T=Y2(1)
      DY=(Y2(2)-T)/MW
C
      CALL DPITOA(MC,YINDX1(7),NCHR,4,10)
      XTOT1(7) = YINDX1(7)
      YINDX(8)  = YINDX1(7)
C
      NPL=MAX0(MC,MIN0(MCMAX,LCOL-33))/MC
C
C PRINT OUT THE NEXT PAGE OF THE PLOT OR TABLE.
C
  141 B=A+NPL-1
      C=MIN0(NY,B)
      D=C-A+1
      NCBOX=MC*D
C
      CALL DPITOA(D,YINDX(6),NCHR,4,10)
      XTOT1(5)=YINDX(6)
      CALL DPITOA(NCBOX,YLABL(4),NCHR,4,10)
      XTOT(5)=YLABL(4)
C
C
C PRINT Z AND Y SUBTITLES, AND SET UP FOR X SUBTITLE
      MT=LENTI(4)
      MT=MIN0(LCOL-3,MT)
      IF(MT.GT.0) WRITE(LPUNIT,142) (SUBTIT(LOCTI(4)+K),K=1,MT)
  142 FORMAT(' Z=',254A1)
      MT=LENTI(3)
      MT=MIN0(LCOL-22,MT)
      MH=MAX0(1,(NCBOX-MT-4)/2)
      IF(MT.GT.0) WRITE(LPUNIT,144) (BLANK,K=1,MH),(SUBTIT(LOCTI(3)+K),
     >            K=1,MT),MMGT
  144 FORMAT(16X,241A1)
C
      MT=LENTI(2)
  146 ITIT=MAX0(1,(NX-MT)/2)
      ITITL=ITIT+MT-1
      ITITLL=ITITL+4
      IF(MT.LE.0.OR.MT.GT.55) ITITLL=0
C
      IF (MC.GE.4) GO TO 160
      DO 150 J=A,C
      K=MOD(J,10)
      IF (K.EQ.0) K=MOD(J/10,10)
  150 Y(J-A+1)=K
      WRITE(LPUNIT,YINDX) (Y(K),K=1,D),A,C
      NL=NL+1
C PRINT VERTICAL Y-AXIS LABELS
      ASSIGN 2200 TO GETSP
      ASSIGN 155 TO DONE
      GO TO 2000
  155 WRITE(LPUNIT,YLABL) (P(K,4),K=1,NCBOX),IPY
      NL=NL+1
      GO TO 195
C
C PRINT TABLE TYPE Y AXIS LABEL
C
C NORMALISE Y FOR PRINTING
  160 DO 170 J=A,C
      TEMP=Y2(J)
      IF(NWCALL.NE.1) GO TO 166
C      PUT 'UND' OR 'OVR' IN EDGE BINS INSTEAD OF NUMERIC LABELS
      IF(J.GT.1.AND.J.LT.NY) GO TO 166
      I0=(J-A)*MC
      DO 162 I=1,MC
  162 L1Y(I0+I)=L1BLNK
      I0=I0+MC-4
      DO 164 I=1,4
      IF(J.LE.1) L1Y(I0+I)=L1UND(I)
  164 IF(J.GE.NY) L1Y(I0+I)=L1OVR(I)
      GO TO 170
  166 CALL DPRTOA(TEMP/PY,L1Y((J-A)*MC+1),NCHR,-MC,NDECY)
  170 CONTINUE
      L1Y(NCBOX+1)=L1STAR
      L1Y(NCBOX+2)=L1E
      CALL DPITOA(IPY,L1Y(NCBOX+3),NCHR,-3,10)
      WRITE(LPUNIT,YINDX1) IPZ,(K,K=A,C)
      K=NCBOX+5
      WRITE(LPUNIT,175) (L1Y(J),J=1,K)
  175 FORMAT(/12X,3H Y ,243A1)
      NL=NL+2
C
C DONE WITH Y-AXIS LABEL
C
C SET UP FOR BOX BOUNDARY LINE
C
  195 NCBOX2=NCBOX+2
      DO 201 I=1,NCBOX2
      BUF2(I)=MINUS
  201 IF(MC.GE.2.AND.MOD(I,MC).EQ.0) BUF2(I)=PLUS
      IF(NY.GT.B) NCBOX2=NCBOX2-2
      IF(NY.GT.B) GO TO 203
      BUF2(NCBOX2)=PLUS
      NCBOX1=NCBOX2
      IF(L2SUMS.EQ.0) GO TO 203
C      PUT IN EXPONENT FOR THE SUMMATIONS ON X AXIS
      DO 202 I=1,7
  202 BUF2(NCBOX2+I)=L1TOT(I)
      NCBOX2=NCBOX2+7
      CALL DPITOA(IPTX,BUF2(NCBOX2+1),NCHR,-3,10)
      NCBOX2=NCBOX2+3
  203 WRITE(LPUNIT,204) (BUF2(I),I=1,NCBOX2)
  204 FORMAT(6X,'I     X +',243A1)
      NL=NL+1
C
C X-BINS 1 PER LINE
C
  205 DO 1000 I=1,NX
      X=X2(I)/PX
      T=0.0
      DO 207 J=1,17
  207 DBUF(J)=DBLANK
      IF(I.GE.ITIT.AND.I.LE.ITITL) BUF(1)=SUBTIT(LOCTI(2)+I-ITIT+1)
      IF(I.GT.ITITL.AND.I.LE.ITITLL) BUF(1)=BBV(I-ITITL)
      CALL DPITOA(I,BUF(3),NCHR,-4,10)
      IF(NWCALL.NE.1) GO TO 2074
      IF(I.GT.1.AND.I.LT.NX) GO TO 2074
      IF(I.LE.1) CBUF(3)=UND
      IF(I.GE.NX) CBUF(3)=OVR
      GO TO 2076
 2074 CALL DPRTOA(X,BUF(7),NCHR,-6,-NDECX)
 2076 BUF(14)=HI
      LOC=14
C
C Y-BINS NPL PER LINE
C
      DO 300 J=A,C
      ZVAL=Z2(I,J)
      ZIJTOT=ZIJTOT+ZVAL
      T=T+ZVAL
      RT=ZVAL/PZ
      MZ=ROUND(RT)
      M=MZ/MS
      IF(ILOG(1).EQ.0) GO TO 208
C       DO IT FOR LOG SCALE
      M=0
      MZ=0
      IF(ZVAL.GT.0.) M=MAX1(0.,ZLTMP*ALOG10(ZVAL/FMIN) + 1.0)
  208 IF(M.NE.0) CALL DPITOA(M,BUF(LOC+MC-MW+1),NCHR,-MW,MB)
      LOC=LOC+MC
      IF (M.EQ.0 .AND. RT.NE.0.) BUF(LOC)=L1ZRO
C
C      CALCULATE CHI2 IF ANALYTIC FUNCTION SUPPLIED
      IF(KF.LE.0.OR.ERRS.EQ.0) GO TO 300
      XT=X*PX
      YT=Y2(J)
      IF(LOWIN.EQ.0) GO TO 210
C       ADJUST TO MID BIN
      XT=XT+(X2(I+1)-XT)/2.0
      YT=YT+(Y2(J+1)-YT)/2.0
  210 ZT=FF(XT,YT,1)/PZ
      IER=1
      IF(ZT.LT.RT) IER=2
      ERR=Z2E(I,J,IER)/PZ
      IF(ERR.LE.0) GO TO 300
C       PROTECT AGAINST VERY LARGE OR VERY SMALL RESIDUALS
      TEMP=AMAX1(1.E-15*ERR,AMIN1(1.E15*ERR,ABS(RT-ZT)))
      SSR=SSR+(TEMP/ERR)**2
      SSRN=SSRN+1.
  300 CONTINUE
C
C
C FINISHED X SO DO SUM ALONG Y UNLESS ALL X'S ARE ON 1 PAGE
C
      II=2
      IF (MS.EQ.1) II=1
      JTEMP=MW*(MB-1)+II+1
      IF(ILOG(1).NE.0) JTEMP=NLOG+1
      IF(NY.GT.B) GO TO 435
      BUF(LOC+2)=HI
      LOC=LOC+2
      IF(L2SUMS.EQ.0) GO TO 435
      IF (A.EQ.1) GO TO 420
      T=0.0
      DO 410 J=1,NY
  410 T=T+Z2(I,J)
  420 IT=ROUND(T/PTX)
      CALL DPITOA(IT,BUF(LOC+1),NCHR,-6,10)
      LOC=LOC+6
  435 IF(MW.GT.2) GO TO 480
C
C SINCE WE ARE SCATTER PLOTTING, PRINT OUT THE SYMBOL VALUES
      IF(I.EQ.1) GO TO 436
      IF (I.LE.JTEMP) GO TO 440
      IF(I.GT.JTEMP+1) GO TO 480
      BUF(LOC+5)=L1E
      CALL DPITOA(IPZ,BUF(LOC+6),NCHR,-3,10)
      LOC=LOC+8
      GO TO 480
  436 DO 437 M=1,8
  437 BUF(LOC+M)=SYMZLO(M)
      LOC=LOC+8
      GO TO 480
C
  440 IF (I.EQ.2.AND.MS.NE.1) GO TO 450
      IF(ILOG(1).NE.0) GO TO 445
      M=(MOD(I-II-1,MB-1)+1)*MB**((I-II)/(MB))
      IF(MW.EQ.2.AND.I.EQ.JTEMP) M=M*MB
      S0=IABS(MS*MAX0(1,M))
      CALL DPITOA(M,BUF(LOC+4-MW),NCHR,-MW,MB)
      GO TO 460
  445 M=I-1
      CALL DPITOA(M,BUF(LOC+4-MW),NCHR,-MW,10)
      S0=FMIN*SLTMP**(M-1)/PZ + .5
      GO TO 460
C
  450 BUF(LOC+3)=L1ZRO
      S0=1
  460 LOC=LOC+3
      BUF(LOC+1)=L1EQAL
      CALL DPITOA(S0,BUF(LOC+2),NCHR,-4,10)
      LOC=LOC+6
C
C      WRITE THE LINE FOR THIS X BIN
C
  480 IF(OVPRT.NE.0) WRITE(LPUNIT,470) L1BLNK,(BUF(M),M=1,LOC)
  470 FORMAT(A1,255A1,A1)
      NL=NL+1
      IF(OVPRT.EQ.0) GO TO 490
      IF(I.EQ.ITITLL) WRITE(LPUNIT,481)
  481 FORMAT('+|')
C
  490 IF (KC.LE.0) GO TO 1000
C
C        OVER-PRINT CONTOUR CURVE
C
      IF(NX.LE.2 .OR. NY.LE.2) GO TO 1000
      YP2=Y2(A)
      IF(I.EQ.1) XP2=X*PX
      XP1=XP2
      IF(I.LT.NX) XP2=X2(I+1)
      IF(I.EQ.NX) XP2=2.*XP2-X2(I-1)
      U2=FC(XP1,YP2,1)/PZ
      U4=FC(XP2,YP2,1)/PZ
C
      IF(OVPRT.EQ.0) GO TO 521
      DO 520 K=1,17
  520 DBUF(K)=DBLANK
  521 MOH=0
C
      DO 600 J=A,C
      YP1=YP2
      IF(J.LT.NY) YP2=Y2(J+1)
      IF(J.EQ.NY) YP2=YP2+DY
      DY=(YP2-YP1)/MC
      YP2=YP1+DY
      M=(J-A)*MC + 13
C
      DO 550 K=1,MC
      U1=U2
      U3=U4
      U2=FC(XP1,YP2,1)/PZ
      U4=FC(XP2,YP2,1)/PZ
      IF(U1*U2.GT.0.0.AND.U1*U3.GT.0.0.AND.U1*U4.GT.0.0) GO TO 530
      BUF(M+K)=OH
      MOH=1
  530 IF(K.EQ.MC) GO TO 600
      YP1=YP2
      YP2=YP2+DY
  550 CONTINUE
  600 CONTINUE
C NOW OVER-WRITE THE FUNCTION
      IF(MOH.EQ.0.OR.OVPRT.EQ.0) GO TO 1000
      WRITE(LPUNIT,470) PLUS,(BUF(M),M=1,LOC)
C
 1000 IF(OVPRT.EQ.0) WRITE(LPUNIT,470) L1BLNK,(BUF(M),M=1,LOC)
C
C PRINT BOTTOM LINE OF BOX
C
      IF(NY.GT.B) GO TO 1020
      NCBOX2=NCBOX1
      IF(NX.GT.JTEMP.OR.MW.GT.2) GO TO 1020
      DO 1010 K=1,12
 1010 BUF2(NCBOX2+K)=L1BLNK
      IF(L2SUMS.NE.0) NCBOX2=NCBOX2+6
 1015 BUF2(NCBOX2+5)=L1E
      CALL DPITOA(IPZ,BUF2(NCBOX2+6),NCHR,-3,10)
      NCBOX2=NCBOX2+8
 1020 WRITE(LPUNIT,1030) IPX,(BUF2(K),K=1,NCBOX2)
 1030 FORMAT(9X,'E',I3,' +',242A1)
      NL=NL+1
      IF(L2SUMS.EQ.0) GO TO 1140
C
C PRINT OUT TOTALS AT BOTTOM
C
      IJTOT=ROUND(ZIJTOT/PTX)
      IF(MC.LT.4) GO TO 1040
C
C Y=SUM(Z(I,J)),I=1,NX
C
 1110 DO 1100 J=A,C
      T=0.0
      DO 1120 I=1,NX
 1120 T=T+Z2(I,J)
 1100 Y(J-A+1)=T/PTY
      IF(NY.GT.B) WRITE(LPUNIT,XTOT1) XTOTE,IPTY,(Y(K),K=1,D)
      IF(NY.LE.B) WRITE(LPUNIT,XTOT1) XTOTE,IPTY,(Y(K),K=1,D),IJTOT
      NL=NL+1
      GO TO 1140
 1040 ASSIGN 2300 TO GETSP
      ASSIGN 1050 TO DONE
      GO TO 2000
C DONE WITH TOTALS ALONG X
 1050 IF(NY.GT.B) WRITE(LPUNIT,XTOT) XTOTE,IPTY,(P(K,4),K=1,NCBOX)
      IF(NY.LE.B) WRITE(LPUNIT,XTOT) XTOTE,IPTY,(P(K,4),K=1,NCBOX),IJTOT
      NL=NL+1
C
C UPDATE NUMBER OF LINES PRINTED ON PAGE
C
 1140 A=A+NPL
      ML=ML+NL
      IF (NY.LT.A) GO TO 5000
      IF (ML+NL.GT.L2PGE) GO TO 1150
      C1TMP=ZERO
      NL=2
      GO TO 1160
 1150 CALL DWRHDR(LPUNIT,EJT)
      NL=1
      ML=0
      C1TMP=BLANK
 1160 WRITE(LPUNIT,1165) C1TMP,IDA,TITLE(1:MT1)
      NL=NL+1
 1165 FORMAT(A1,10X,'CONTINUATION OF ID=',A4,1X,A)
      GO TO 141
C
C LOCAL SUBROUTINE THAT WRITES THE NUMBERS PASSED VIA GETSP
C VERTICALLY. THIS IS USED TO LABEL THE Y-AXIS AND TO PRINT
C THE TOTALS FOR SCATTERPLOTS.
C
C FILL THE BUFFER WITH BLANKS
C
 2000 DO 2001 J=1,MCMAX
      DO 2001 I=1,4
 2001 P(J,I)=L1BLNK
      IUO=0
      DO 2450 J=A,C
      GO TO GETSP,(2200,2300)
C
C GET AND NORMALISE Y VALUES FOR Y-AXIS LABELS
C
 2200 TEMP=Y2(J)/PY
      S=TEMP+SIGN(.1,TEMP)
      IF(NWCALL.EQ.1) IUO=1
      GO TO 2400
C
C CALCULATE AND NORMALISE THE SUMS OF Z VALUES ALONG THE X-AXIS
C
 2300 T=0.0
      DO 2350 I=1,NX
 2350 T=T+Z2(I,J)
      ST=ST+T
      S=T/PTY
C
C FILL THE BUFFER ARRAY P WITH THE VALUE TO BE PRINTED.
C
 2400 C0=BBBZRO
      IF(S.NE.0) CALL DPITOA(S,C0,NCHR,-4,10)
      IF(IUO.NE.0.AND.J.EQ.1) C0=UND
      IF(IUO.NE.0.AND.J.EQ.NY) C0=OVR
      DO 2440 I=1,4
 2440 P((J-A+1)*MC,I)=SP(I)
 2450 CONTINUE
C
C THE BUFFER IS NOW FULL.
C
C PRINT THE BUFFER OUT OMMITING ALL LEADING, BLANK LINES.
C
      S=4
      M4=MIN0(25,(NCBOX+3)/4)
      DO 2500 I=1,4
      DO 2500 J=1,M4
      IF (P4(J,I).EQ.BLANK) GO TO 2500
      S=I
      GO TO 2600
 2500 CONTINUE
 2600 IF(S.GE.4) GO TO 2606
      DO 2601 I=S,3
      WRITE(LPUNIT,2605) (P(K,I),K=1,NCBOX)
 2601 NL=NL+1
 2605 FORMAT(15X,242A1)
 2606 GO TO DONE,(155,1050)
C
C       SSR, SSRN
C
 5000 IF(ERRS.EQ.0.OR.KF.LE.0) GO TO 5500
      WRITE(LPUNIT,5010) SSR,SSRN
 5010 FORMAT(/' CHI SQUARE, ENTRIES =',G12.3,F8.0)
C
C       NUMBER OF CALLS AND UNDER/OVER FLOWS
 5500 IF(ICALLS.LE.0.OR.NWCALL.LE.0) GO TO 6000
      NW=MIN0(9,NWCALL)
      IF(NW.GT.1) GO TO 5510
      WRITE(LPUNIT,5505) DCALL(2),NCALLS(1)
 5505 FORMAT(/A8,I9)
      GO TO 6000
 5510 DO 5530 I=1,3
      WRITE(LPUNIT,5520) DCALL(I),(NCALLS(3*I-3+J),J=1,3)
 5520 FORMAT(A8,I9,2(' |',I8))
      IF(I.LT.3) WRITE(LPUNIT,5525) CC,(CCALLS,J=1,28)
 5525 FORMAT(A1,8X,28A1)
 5530 CONTINUE
C
C       OUTPUT STATISTICS, IF FLAG SAYS SO
 6000 IF(MOD(ISTATS,2).EQ.0) RETURN
      ISUM=SUM1
      IF(IPLOT.EQ.0) WRITE(LPUNIT,6020) IDA,STATYP,ISUM,SUMW,BLANK,
     >               TITLE(1:NTITLE)
 6020 FORMAT(/,1X,A4,' STATS FROM ',A4,', #CALLS=',I9,', WTS=',G12.5,
     >       A3,A70/(62X,A70))
      IF(IPLOT.NE.0) WRITE(LPUNIT,6020) BLANK,STATYP,ISUM,SUMW
CCCC      IF(SUMW.NE.0.) GO TO 6050
CCCC      WRITE(LPUNIT,6040)
CCCC 6040 FORMAT(6X,'WTS=0.0, NO FURTHER STATISTICS')
CCCC      RETURN
 6050 WRITE(LPUNIT,6060) A1X,XAVG,XDAVG,XSIG,XDSIG,XLIMIT(1),
     >       A1X,XLIMIT(2),A1X,XMNX
 6060 FORMAT(6X,'<',A1,'>=',G12.5,'+-',G9.3,', SD=',G11.5,'+-',G9.3,
     > '  FOR',G10.3,'< ',A1,' <',G10.3,'  (EXTREME',A2,'=',2G10.3,')')
      WRITE(LPUNIT,6060) A1Y,YAVG,YDAVG,YSIG,YDSIG,YLIMIT(1),
     >       A1Y,YLIMIT(2),A1Y,YMNX
      IF(SUMW.NE.0.) WRITE(LPUNIT,6070) CORREL,ELIPSE
 6070 FORMAT(6X,'COR.COEF=',
     1               G11.4,/,
     2               6X,'COVARIANCE ELLIPSE : SEMI AXES=',G12.4,
     3               ' AND ',G11.4,',  ANGLE=',
     4               G11.4,' RAD')
      RETURN
C
      END
