      SUBROUTINE DPRTOA(R,A,NCHR,MAXA,NDECI)
C
C
C  CONVERTS THE REAL NUMBER STORED IN R TO A CHARACTER STRING IN A.
C  LEADING ZEROS ARE SUPPRESSED, AND THE RESULT CAN BE EITHER LEFT
C  OR RIGHT JUSTIFIED IN THE A ARRAY.
C
C  WHERE:
C    R     (R*4)  IS THE REAL NUMBER TO BE CONVERTED
C    A     (L*1)  RETURNS THE CHARACTER RESULT
C    NCHR  (I*4)  RETURNS THE NUMBER OF CHARACTERS PUT INTO A
C                   (LEADING ZEROS ARE SUPPRESSED AND NOT COUNTED)
C    MAXA  (I*4)  ABSOLUTE VALUE GIVES THE MAXIMUM NUMBER OF CHARACTERS
C                 THAT MAY BE PUT INTO A.  IF MAXA IS POSITIVE(NEGATIVE)
C                 THEN THE CHARACTERS ARE LEFT(RIGHT) JUSTIFIED IN A.
C    NDECI (I*4)  IS THE NUMBER OF DECIMAL PLACES AFTER THE DECIMAL,
C                 (INCLUDING THE DOT) AND THE RANGE MAY BE FROM 0 TO 7)
C                 (IF 0, THEN NO DECIMAL POINT IS PLOTTED)
C                 IF NDECI IS NEGATIVE, THEN TRAILING (INSIGNIFICANT)
C                 ZEROS FOLLOWING THE DECIMAL POINT ARE SUPRESSED.
C
C
      INCLUDE 'dcomfp.INC'
C
      CHARACTER*1 A(*)
      CHARACTER*1 BLNK, STAR, MINUS, DIGIT(10), DOT
      DATA DIGIT/'0','1','2','3','4','5','6','7','8','9'/
      DATA BLNK/' '/, STAR/'*'/, MINUS/'-'/, DOT/'.'/
C      FPTMAX IS THE MAX FLOATING POINT EXPONENT FOR THIS MACHINE
      DATA REM0/.0001/
C
C
      NMX=IABS(MAXA)
      NDA=-NDECI
      ND=MAX0(0,MIN0(7,IABS(NDA)))
      NDOT=0
      IF(ND.GE.1) NDOT=1
      IF(NMX.GT.0) GO TO 10
      A(1)=STAR
      GO TO 320
C
C       CLEAR THE A ARRAY
   10 DO 15 J=1,NMX
   15 A(J)=BLNK
C
C       GET MAXIMUM DIGITS POSSIBLE
   50 M2=NMX
      IF(R.LT.0.) M2=M2-1
      M1=MAX0(1,ND)
      I=R*10.**MAX0(0,ND-1) + SIGN(.5,R)
      IAB=IABS(I)
C       SEARCH FOR NUMBER OF SIGNIFICANT DIGITS IN I
C       SET IZRO TO 1 IF LEADING ZERO IS TO BE SUPRESSED
      IZRO=0
C0    IF(M1.GT.1.AND.IAB.LT.10**(M1-1)) IZRO=1
      DO 100 M=M1,M2
      IF(IAB.LT.10**M) GO TO 200
  100 CONTINUE
      GO TO 500
C
  200 J0=0
      IF(MAXA.LT.0) J0=NMX-M-NDOT+IZRO
      IF(J0.LT.0) GO TO 500
C
      N=0
      IF(R.GE.0.) GO TO 220
C       IF I IS NEGATIVE, ALLOW ONE MORE SPACE FOR '-'
      IF(M+1-IZRO.GT.NMX) GO TO 500
      IF(J0.GT.0) J0=J0-1
      A(J0+1)=MINUS
      J0=J0+1
      N=1
C
C       FILL UP A WITH THE DIGITS, DECADE BY DECADE
  220 IZRO2=0
      DO 300 J=1,M
      N=N+1
C       TEST FOR LEADING ZERO
      IF(IZRO.NE.0) GO TO 250
C       TEST FOR TRAILING ZEROS (OMIT THEM)
      IF(NDA.LT.2) GO TO 230
      IF(J.LT.M-ND+2) GO TO 230
      IF(IZRO2.EQ.1) GO TO 300
      REM=AMOD(ABS(R)*10.**(J+ND-M-1),10.0)
      IF(REM.LT.REM0 .OR. (10.-REM).LT.REM0) IZRO2=1
      IF(IZRO2.EQ.1.AND.IAB.NE.0) GO TO 300
  230 IDEC=MOD(IAB/10**(M-J),10)
      A(J+J0)=DIGIT(IDEC+1)
      IF(M-J.NE.ND-1) GO TO 300
C       PUT IN THE DECIMAL POINT
      J0=J0+1
      N=N+1
  250 A(J+J0)=DOT
  300 IZRO=0
  320 NCHR=N
      RETURN
C
C       I OVERFLOWS THE SPECIFIED SIZE, SO FILL A WITH NMX STARS
  500 N=NMX
      DO 510 J=1,NMX
  510 A(J)=STAR
      GO TO 320
C
CTEST      END
CTESTC
CTESTC  THIS IS A TEST PROGRAM FOR DPRTOA
CTEST      REAL*8 A,AR,B,BR,R0(2)
CTEST      DATA R0/1.0,1.23456/
CTEST      DO 10 J=1,2
CTEST      DO 10 K=1,6
CTEST      DO 10 I=1,10
CTEST      R=R0(J)*10.**(I-5)
CTEST      CALL DPRTOA(R,A,NA,8,K-1)
CTEST      CALL DPRTOA(R,AR,NAR,-8,K-1)
CTEST      CALL DPRTOA(-R,B,NB,8,K-1)
CTEST      CALL DPRTOA(-R,BR,NBR,-8,K-1)
CTEST      WRITE(6,5) R,A,NA,AR,NAR,B,NB,BR,NBR
CTEST   5  FORMAT( 1X,F10.4,4(2X,'"',A8,'",',I2))
CTEST   10 CONTINUE
CTEST      STOP
      END
