      SUBROUTINE DPSLCT(DEV,INTDEV)
      INTEGER DEV(2)
C
C   **MEMBER** DPSLCT
C
C   SELECTS THE GRAPHIC DEVICE SPECIFIED BY DEV AND SETS IDEV IN
C   THE /DPMODE/ COMMON BLOCK TO THIS DEVICE INDEX.
C   THE SCALING LIMITS AND SCISSORING LIMITS ARE ALSO SET ACCORDING
C   TO THE VALUES IN GSIZE AND GOFSET IN /DPMODE/
C
C   THE ARGUMENT DEV MAY BE EITHER AN INTEGER DEVICE INDEX (1-20),
C   OR A DEVICE NAME (8-CHARACTER).
C
C   IF DEV IS VALID, DPSLCT RETURNS .TRUE., OTHERWISE .FALSE.
C
C   INTDEV (OPTIONAL) SUPPLIES THE VALUE FOR INTER.  IF NOT SUPPLIED
C   THEN INTER REMAINS UNCHANGED.
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomwn.INC'
C
      INCLUDE 'hretcd.INC'
C
C  RETURN CODES:
C     IRETCD = 0  - SUCCESSFUL OPERATION
C              1  - DEV IS NOT A VALID DEVICE NAME
C              2  - DEV IS NOT A VALID DEVICE NUMBER
C
      INTEGER DPAK
C
      REAL*8 DDEV,BLANK
      INTEGER PRIN4
      CHARACTER*8 CDEV
C    VARIABLES FOR MANIPULATING THE SCALING LIMITS
CC..#IFDEF GKSYS
C      REAL RWINDO(4),CWINDO(4),RVIEWP(4),CVIEWP(4)
C      INTEGER TUS
C..#ENDIF
C
C..#IFDEF DGSYS
C      VALUES FOR PROCESSING UGOPEN
      INTEGER IOPEN(9)
      CHARACTER*8 OPT(15)
      CHARACTER*3 CTEK
      CHARACTER*120 CHOPT
      EQUIVALENCE (OPT(1),CHOPT)
      CHARACTER SDUM
      CHARACTER*8 STRING
      INTEGER IARRAY(12)
      REAL XARRAY(12)
      CHARACTER*1 AT,COMMA
C..#ENDIF
      CHARACTER*1 L1BLNK
C
      DATA DPAK/4HDPAK/
      DATA PRIN4/4HPRIN/, BLANK/8H        /
C..#IFDEF DGSYS
      DATA OPT/' ',',DDNAME=',13*' '/
      DATA AT/'@'/, COMMA/','/
C..#ENDIF
      DATA L1BLNK/' '/
C
      NARG=NARGS()
      IF(DPNEW.NE.DPAK) CALL DPINIT(50000)
C
      NEWDEV=0
C
C       SET INTER IF SECOND ARG IS THERE
      IF(NARG.GE.2) INTER=INTDEV
C
C       ACCEPT AN INTEGER DEVICE INDEX
      I=DEV(1)
      IF(I.LE.0.OR.I.GT.20) GO TO 12
C       CHECK FOR ACCEPTABLE INDEX
      IF(DEVTYP(I).NE.BLANK) GO TO 20
      WRITE(ERUNIT,10) I
   10 FORMAT('0DPSLCT -- DEVICE #',I3,'  INVALID - NO DEVTYP NAME')
      IRETCD=2
      RETURN
C
C      ACCEPT 'PRIN' AS A SHORT FORM FOR 'PRINTER' IN DEV ARGUMENT
   12 I=2
      IF(DEV(1).EQ.PRIN4) GO TO 20
C
C       SEARCH TABLE OF DEVTYP'S FOR THIS DEVICE
      WRITE(CDEV,'(2A4)') DEV(1),DEV(2)
      CALL DPUPPR(CDEV)
C..#IFDEF DGSYS
      MOROPT=0
      IF(CDEV(8:8).EQ.COMMA) MOROPT=1
C..#ENDIF
      CDEV(8:8)=L1BLNK
      READ(CDEV,'(A8)') DDEV
      DO 15 I=1,20
      IF(DDEV.EQ.DEVTYP(I)) GO TO 20
   15 CONTINUE
C        DEV IS NOT A RECOGNIZED DEVICE
      WRITE(ERUNIT,18) CDEV,DEVTYP
   18 FORMAT(/,' DPSLCT -- ',A,' IS AN UNKNOWN DEVICE',
     > ' - KNOWN ONES ARE:',/(5X,5A10))
      IRETCD=1
      RETURN
C
   20 IDEV=I
      WRITE(CDEV,'(A8)') DEVTYP(I)
      IF(IDEV.LE.2) GO TO 90
C
C
CC..#IFDEF GKSYS
CC     GO CHECK WHETHER THIS GKS WORKSTATION IS TO BE OPENED
CC
CC       IS THERE SUCH A WORKSTATION CATEGORY?
C      CALL GQEWK(1,IERR,NUMBER,ITYP)
C      DO 25 ITYP=1,NUMBER
C      CALL GQWKCA(ITYP,IERR,ICAT)
C      IF(ICAT.EQ.WKCATS(IDEV)) GO TO 30
C   25 CONTINUE
C      WRITE(ERUNIT,'(/,'' DPSLCT - WORKSTATION UNAVAILABLE'',/,
C     > '' FOR "'',A8,''" (IDEV='',I3,'') GKS WKCAT='',I4)')
C     > CDEV, IDEV, WKCATS(IDEV)
C      IRETCD=1
C      RETURN
CC
CC       IS THE WORKSTATION ALREADY OPEN?
CCC 30 IF(NDEVS.LE.0) GO TO 37
C   30 CALL GQOPWK(0,IERR,NUMOPEN,IWKID)
C      DO 35 J=1,NUMOPEN
C         CALL GQOPWK(J,IERR,NUMOPN,IWKID)
C         IF(IWKID.EQ.IDEV) GO TO 40
C   35 CONTINUE
CC
CC       OPEN WORKSTATION
CC
C   37 CALL GOPWK(IDEV,3,ITYP)
C      WRITE(6,58) DEVTYP(IDEV),IDEV
C   58 FORMAT(/,' GKS DEVICE=',A10,' OPENED WITH WKID=',I6)
C      NEWDEV=2
C      NDEVS=NDEVS+1
CC
CC       ACTIVATE WORKSTATION IF NOT ALREADY ACTIVE
CC
C   40 CALL GQWKS(IDEV,IERR,ISTATE)
C      IF(ISTATE.EQ.0) CALL GACWK(IDEV)
CC
CC ALIGN CHARACTERS AT MID HEIGHT, LEFT
C      CALL GSTXAL(1,3)
CC
CC          SET WINDOWS FOR THIS NEWLY SELECTED DEVICE.
C   60    IF(FULSCR.NE.0) THEN
CC             SET RECTANGLE VIEWPORT, LONGEST DIMENSION SET TO 1.0
C            CALL GQWKT(IDEV,IERR,TUS,RWINDO,CWINDO,RVIEWP,CVIEWP)
C            TEMP=AMAX1(RVIEWP(2),RVIEWP(4))
C            IF(TEMP.GT.0.0) THEN
C               XSIZE=RVIEWP(2)/TEMP
C               YSIZE=RVIEWP(4)/TEMP
C            ELSE
C               XSIZE=1.0
C               YSIZE=1.0
C            ENDIF
C         ELSE
C            XSIZE=1.0
C            YSIZE=1.0
C         ENDIF
CC
C         CALL GSWKWN(IDEV,0.,XSIZE,0.,YSIZE)
C..#ELIF DGSYS
C       CHECK WHETHER THIS UG DEVICE IS TO BE OPENED
C
      CALL UGINFO('OPENDEV',SDUM,IOPEN,XARRAY)
      NOPEN=IOPEN(1)
      IF(NOPEN.LE.0) GO TO 55
      DO 50 J=1,NOPEN
   50 IF(IOPEN(J+1).EQ.IDEV) GO TO 65
C
C       THIS DEVICE HAS NOT BEEN OPENED BY UGOPEN, SO OPEN IT
C       AND GIVE IT AN IDENTITY NUMBER I.
C
   55 OPT(1)=CDEV
      OPT(3)=CDEV
      IOP=3
C      LINE DENSITY (FOR VERSATEC ONLY)
      IF(LINDEN.NE.0) THEN
         IOP=IOP+1
         OPT(IOP)=',GENIL'
      ENDIF
      NCHR=8*IOP
      IF(MOROPT.EQ.1) THEN
      CHOPT(NCHR:NCHR)=COMMA
C        SCAN FOR END OF DEV OPTIONS, UNTIL BLANK, @, OR 80 CHARACTERS
         IOP=IOP+1
         DO 56 I8=IOP,15
         IA=2*(I8-IOP)+3
         WRITE(CDEV,'(2A4)') DEV(IA),DEV(IA+1)
         OPT(I8)=CDEV
         DO 56 J=1,8
         IF(CDEV(J:J).EQ.L1BLNK.OR.CDEV(J:J).EQ.AT) GO TO 57
   56    CONTINUE
         I8=15
         J=9
   57    NCHR=(I8-1)*8+J-1
      ENDIF
C
      CALL UGOPEN(CHOPT(1:NCHR),IDEV)
C
      WRITE(CTEK,'(A3)') DEVTYP(I)
      IF(CTEK.EQ.'TEK') THEN
         CALL DGSCRN('TEXT')
      ENDIF
      WRITE(LPUNIT,58) CHOPT(1:NCHR)
   58 FORMAT(/,' HANDYPAK CALLED UGOPEN(',A)
C     For the first UG device, initialize the element buffer
      IF(NDEVS.LE.0) CALL DGINT(0)
      NDEVS=NDEVS+1
C
C       SELECT THE GRAPHIC DEVICE
      CALL UGSLCT(' ',IDEV)
      NEWDEV=2
C       SET WINDOWS FOR THIS NEWLY SELECTED DEVICE.
      XSIZE=1.0
      YSIZE=1.0
      IF(FULSCR.EQ.0) GO TO 63
C         SET RECTANGLE DRAWING SPACE, SHORTEST DIMENSION SET TO 1.0
         CALL UGDSPC('PUT',1.0,1.0,0.0)
         CALL UGINFO('DSPCSIZE',STRING,IARRAY,XARRAY)
         TEMP=AMIN1(XARRAY(1),XARRAY(2))
         XSIZE=XARRAY(1)/TEMP
         YSIZE=XARRAY(2)/TEMP
   63 IF(CDEV.EQ.'PDEVUGS ' .OR. CDEV.EQ.'PDEVLIN ') THEN
C         ASSUME A RECTANLE FOR DEVICE INDEPENDENT OUTPUT.
         XSIZE=1.34
         YSIZE=1.0
      ENDIF
      CALL UGDSPC('PUT',XSIZE,YSIZE,1.0)
      GO TO 67
C
C       SELECT AN ALREADY OPEN GRAPHIC DEVICE
   65 CALL UGINFO('ACTDEV',STRING,IARRAY,XARRAY)
      IF(IDEV.NE.IARRAY(1)) NEWDEV=1
      IF(IDEV.NE.IARRAY(1)) CALL UGSLCT(' ',IDEV)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
   67 IF(NEWDEV.EQ.0) GO TO 80
C
C       INITIALIZE ANY ON-GOING WINDOWING OR OVERPLOTTING
C
      IF(WINDOW.LE.0) GO TO 70
      WINDOW=-NEWDEV
      CALL DPICT(0)
      WINDOW=1
   70 IF(OVRPLT.LE.0) GO TO 80
      OVRPLT=-1
      CALL DPICT(0)
      OVRPLT=1
C
   80 CALL DPLIMS
C
   90 IRETCD=0
      RETURN
      END
