      SUBROUTINE DPTITL(TITLE,NTITLE,IFILL)
C
C   **MEMBER** DPTITL
C
C  DPTITL PARSES THE MAIN AND SUBTITLES FROM THE INPUT TITLE STRING.
C  DPSLCI MUST HAVE BEEN CALLED BEFORE THIS FUNCTION IS CALLED, IF A
C  SLICE OPERATION IS BEING DONE.
C  DPTITL UNPACKS THE STRING STORED IN TITLE INTO THE FOUR SUB-STRINGS IN
C  SUBTIT. THE SUB-STRINGS ARE DELINEATED IN TITLE BY ';' (COLAN)
C  CHARACTERS, AND THE TITLE END IS INDICATED BY THE '@' CHARACTER.
C  THE ORDER THAT THE SUBSTRINGS ARE STORED IN SUBTIT IS THE SAME
C  AS THE ORDER FOUND IN TITLE - UNLESS THE SLICE FLAG (SLFLAG) IS ON
C  IN WHICH CASE A RE-ORDERING IS DONE TO GIVE THE 1-D ORDER FOR
C  THE SLICE  I.E. MAIN HEADING, XORY TITLE, Z TITLE.
C  IF THE FIRST CHARACTER IN TITLE IS A '$' (DOLLAR), THEN DPTITL
C  EXPECTS CHARACTER PAIRS IN TITLE, AS PER UNIFIED GRAPHICS.
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomti.INC'
      INCLUDE 'dcomsl.INC'
C
      LOGICAL SKIP
      CHARACTER*(*) TITLE
      CHARACTER*1 AT,COLAN,CURLY,DOLLAR
      CHARACTER*1 A1XYZ(3),A1OP,A1CP,BLNK,TMP(12)
      CHARACTER*1 SL1(19,3),SL3(9)
C
      DATA AT/'@'/, COLAN/';'/, CURLY/'{'/, DOLLAR/'$'/
      DATA A1XYZ/'X','Y','Z'/, A1OP/'('/, A1CP/')'/, BLNK/' '/
      DATA SL1/'S','L','I','C','E',' ','-','-',' ',10*' ',
     > '$','S',' ','L',' ','I',' ','C',' ','E',3*' ','-',' ','-',3*' ',
     > '{',' ','S','L','I','C','E',' ','-','-',' ',8*' '/
      DATA SL3/' ','-','-',' ','O','V','E','R',' '/
C
      NTITLE=1
C      CLEAR ALL LENGTHS, SET DEFAULT TO SIMPLEX STRINGS
      DO 145 I=1,4
  145 LENTI(I)=0
      LTI=MIN0(256,LEN(TITLE))
C
      M=0
      SKIP=.FALSE.
      IF(SLFLAG.EQ.0) GO TO 150
      IF(SLDIR.EQ.0) M=1
      IF(SLDIR.NE.0) M=2
C
  150 IO=1
      LOCTI(1)=IO-1
      ISEG=1
      JSEG=1
      IF (SLFLAG.EQ.0) GO TO 160
C
C STUFF IN 'SLICE -- ' MESSAGE IN FRONT OF MAIN TITLE
      J=1
      IO=9
      IF(TITLE(1:1).NE.DOLLAR) GO TO 154
      IO=19
      NTITLE=2
      J=2
      GO TO 158
C
  154 IF(TITLE(1:1).NE.CURLY) GO TO 158
      IO=11
      J=3
C
  158 DO 159 I=1,IO
  159 SUBTIT(I)=SL1(I,J)
      IO=IO+1
C
  160 IF(TITLE(NTITLE:NTITLE).EQ.AT) GO TO 170
      IF(IO.GE.256) GO TO 400
      IF(TITLE(NTITLE:NTITLE).EQ.COLAN) GO TO 170
      IF(SKIP) GO TO 250
C       KEEP COPYING THIS SUBSTRING
      SUBTIT(IO)=TITLE(NTITLE:NTITLE)
      IO=IO+1
      GO TO 250
C      END OF A SUBSTRING, FINISH IT AND START NEXT ONE
  170 IF(SKIP) GO TO 200
      IF(IO.GT.LENTI(JSEG) .OR. ISEG.EQ.1
     >   .OR.(SLFLAG.EQ.0.AND.IFILL.EQ.0)) GO TO 180
C      PUT IN DEFAULT SUBTITLE IF USER DIDNT SUPPLY ONE
      IF(IO.GE.256) GO TO 180
      SUBTIT(IO)=A1XYZ(ISEG-1)
      IO=IO+1
C      FINISH OFF THIS SEGEMENT
  180 LENTI(JSEG)=IO-1-LOCTI(JSEG)
  200 IF(ISEG.GE.4) GO TO 300
      ISEG=ISEG+1
      IF(SKIP) GO TO 220
      JSEG=JSEG+1
      LOCTI(JSEG)=IO-1
  220 SKIP=(ISEG.EQ.2.AND.M.EQ.2).OR.(ISEG.EQ.3.AND.M.EQ.1)
      IF(TITLE(NTITLE:NTITLE).EQ.AT) GO TO 170
  250 IF(NTITLE.GE.LTI) GO TO 180
      NTITLE=NTITLE+1
      GO TO 160
C
  300 IF(SLFLAG.EQ.0) GO TO 500
      LENTI(4)=0
C
C PUT IN TRAILING SLICE MESSAGE WITH Y SUBTITLE
      NPAIR=1
      IF(SUBTIT(LOCTI(3)+1).NE.DOLLAR) GO TO 305
      NPAIR=2
      GO TO 308
  305 IF(SUBTIT(LOCTI(3)+1).NE.CURLY) GO TO 308
      IF(IO+2.GT.256) GO TO 500
      SUBTIT(IO)=CURLY
      SUBTIT(IO+1)=BLNK
      IO=IO+2
C
  308 IF(IO+11*NPAIR.GT.256) GO TO 500
      DO 310 I=1,9
      IF(IO.GE.256-NPAIR) GO TO 400
      SUBTIT(IO)=SL3(I)
      IF(NPAIR.EQ.2) SUBTIT(IO+1)=BLNK
      IO=IO+NPAIR
  310 CONTINUE
      TMP(1)=A1XYZ(3-M)
      TMP(2)=A1OP
      CALL DPITOA(K1,TMP(3),NCHR,4,10)
      CALL DPITOA(-K2,TMP(3+NCHR),NCHR1,4,10)
      NCHR=3+NCHR+NCHR1
      TMP(NCHR)=A1CP
      DO 330 I=1,NCHR
      IF(IO+NPAIR.GT.256) GO TO 400
      SUBTIT(IO)=TMP(I)
      IF(NPAIR.EQ.2) SUBTIT(IO+1)=BLNK
  330 IO=IO+NPAIR
  400 LENTI(3)=IO-1-LOCTI(3)
C
  500 CONTINUE
C
CCC     WRITE(6,510) TITLE(1:NTITLE+1)
CCC 510 FORMAT(1X,A)
CCC     WRITE(6,520) NTITLE,LENTI,LOCTI
CCC 520 FORMAT(' NTITLE=',I6,'   LENTI=',4I5,'   LOCTI=',4I6)
CCC     DO 550 I=1,4
CCC     J=LENTI(I)
CCC     L=LOCTI(I)
CCC     WRITE(6,530) (SUBTIT(L+K),K=1,J)
CCC 530 FORMAT(1X,80A1)
CCC 550 CONTINUE
C
      RETURN
C
      END
