      FUNCTION DSMTH1(X,FX,FY,FYE,N,SLCFLG)
      EXTERNAL FX,FY,FYE
      LOGICAL SLCFLG
C
C  **MEMBER** DSMTH1
C
C THIS FUNCTION RETURNS A VALUE AT THE COORDINATE X OF A SMOOTHED
C CURVE THROUGH THE N POINTS GIVEN IN FX(I), FY(I).
C XSMTH SUPPLIES THE SIGMA OF THE GUASSIAN TO BE USED IN THE SMOOTHING.
C
C IT IS ASSUMED THAT THE FX(I) VALUES ARE ORDERED IN INCREASING
C VALUES AS I INCREASES.  ALSO, THE VARIABLE ILAST SAVES THE
C BIN VALUE WHICH IS JUST BEYOND -5.000 SIGMA FROM X.
C THE NEXT TIME ENTRY STRARTS FROM THIS BIN RATHER THAN 1, TO
C ALLOW FOR SOME SPEED UP OF THE PROGRAM.
C
      INCLUDE 'dpmode.INC'
C
      DATA ILAST/0/
C
      DSMTH1=0.
      WTS=0.
      I1=1
      I2=N
      IF(IEDGE(1).EQ.0) GO TO 20
C       OMIT EDGE BINS FROM BEING USED IN SMOOTHING
      I1=2
      I2=N-1
   20 IF(I1.GT.I2) RETURN
      IF(XSMTH.LE.0.0) RETURN
C
C INITIALIZATION FOR LOOP BELOW.
C
      IF(ILAST.GT.N) ILAST=1
      IB=MAX0(ILAST,I1)
      W2=1.0
      Y=0.
   40 X1=(FX(IB,1)-X)/XSMTH
      W1=-1.0
      IF(X1.LT.-5.000 .OR. IB.EQ.I1) GO TO 50
      IB=I1
      GO TO 40
C
C LOOP OVER DATA POINTS WHICH ARE WITHIN 5.000 SIGMA FROM X,
C AND COMPUTE THE WEIGHT FOR EACH POINT BY USING THE AREA OF THE GAUSSIAN
C CURVE CENTERED AT X THAT RANGES OVER THE I'TH BIN.
C THIS AREA GIVES THE WEIGHT TO BE APPLIED TO THE Y VALUE AT THAT BIN.
C THE TOTAL WEIGHT IS ALSO ACCUMULATED, BIN BY BIN, AND IS
C DIVIDED OUT AFTER ALL POINTS HAVE BEEN DONE.
C
   50 DO 100 I=IB,I2
      X2=(FX(I+1,1)-X)/XSMTH
      IF(X1.GT.-5.000) GO TO 80
      IF(X2.LT.-5.000) GO TO 100
C      THIS IS THE LOWEST BIN VALUE WHICH SUBTENDS -5.000 SIGMA
C      SAVE BIN NUMBER FOR NEXT TIME ENTRY TO DSMTH1
      ILAST=I
C      USE AN APPROXIMATION FOR THE ERROR FUNCTION AS GIVEN
C      IN HANDBOOK OF MATHEMATICAL FUNCTIONS BY ABRAMOWITZ, PG 299.
   80 U=ABS(X2)
      W2=1.0
      IF(U.LT.10.)
     >W2=1.-1./(1.0+U*(.278393+U*(.230389+U*(.000972+U*.078108))))**4
      W2=SIGN(W2,X2)
      DW=W2-W1
      WTS=WTS+DW
      IF(SLCFLG) Y=FY(I,1)
      IF(.NOT.SLCFLG) Y=DPSLCF(FY,I)
      DSMTH1=DSMTH1+DW*Y
      IF(X2.GT. 5.000) GO TO 110
      X1=X2
      W1=W2
  100 CONTINUE
C
C COMPENSATE FOR UPPER EDGE (USE LAST Y IN EXTRAPOLATION)
  110 DSMTH1=(DSMTH1+(1.0-W2)*Y)/2.0
C
      RETURN
      END
