      SUBROUTINE DSTAT(IENTRY,FX,FY,FYE,FZ,FZE,NX,NY)
C
C  **MEMBER** DSTAT
C  **ALIAS** HSFILL
C
C  CALCULATES THE MEANS AND VARIANCES BY USING THE INPUT FUNCTIONS
C  FX,FY,FZ, AND FZE.  SUMMATIONS ARE MADE OVER THE NX BY NY BINS.
C  (OR A SMALLER REGION IF THE LIMITS ARE SET IN ISLIM1, ISLIM2,..).
C  THE RESULTS ARE PUT INTO /DPMODE/ (SEE HSFILL BELOW).
C
      EXTERNAL FX,FY,FYE,FZ,FZE
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomfp.INC'
C
      REAL SARRAY(12)
      EQUIVALENCE (SARRAY(1),XAVG)
C
      REAL*8 S(4),S1S4,XSIG2,YSIG2
      REAL*8 S1,SW,SWX,SWX2,SWY,SWY2,SWXY
C
cccc  REAL RIN(*)
cccc  REAL*8 DIN(*)
      EQUIVALENCE (TEMP,ITEMP)
C
C
         NI=NX
         NJ=NY
      IF(IENTRY.EQ.1) THEN
         NJ=1
      ELSEIF(IENTRY.NE.2) THEN
         WRITE(ERUNIT,'('' ILLEGAL IENTRY ARG IN DSTAT'',I8)') IENTRY
         RETURN
      ENDIF
C
C
C       CLEAR THE ACCUMULATORS
C
   10 S1=0.D0
      SW=0.D0
      SWX=0.D0
      SWX2=0.D0
      SWY=0.D0
      SWY2=0.D0
      SWXY=0.D0
C
C       SET LIMITS
C
      IF(IEDGE(1).NE.0) GO TO 11
C       USE EDGE POINTS IN X
      I1=1
      I2=NI
      GO TO 12
C       DONT USE EDGE POINTS IN X
   11 I1=2
      I2=NI-1
C       HOWEVER, IF LIMITS ARE SPECIFIED, THEN USE THEM INSTEAD
   12 IF(ISLIM1.GT.0) I1=ISLIM1
      IF(ISLIM2.GT.0) I2=MIN0(NI,ISLIM2)
      IF(LOWIN.NE.0) GO TO 13
      XLIMIT(2)=FX(I2)
      GO TO 14
   13 IF(I2.GE.NI) XLIMIT(2)=2.*FX(NI)-FX(NI-1)
      IF(I2.LT.NI) XLIMIT(2)=FX(I2+1)
   14 XLIMIT(1)=FX(I1)
      X0=0.5*(XLIMIT(1)+XLIMIT(2))
C
C      1-D OR 2-D,  IF 1-D SET UP LOOP FOR 1-PASS IN J LOOP.
      J1=1
      J2=1
      IF(IENTRY.EQ.1) GO TO 20
      IF(IEDGE(2).NE.0) GO TO 16
C
C       Y COORD IN 2-D
C       USE EDGE POINTS IN Y
      J1=1
      J2=NJ
      GO TO 17
C       DONT USE EDGE POINTS IN Y
   16 J1=2
      J2=NJ-1
C      HOWEVER, IF LIMITS ARE SPECIFIED, USE THEM INSTEAD
   17 IF(ISLIM3.GT.0) J1=ISLIM3
      IF(ISLIM4.GT.0) J2=MIN0(NJ,ISLIM4)
      IF(LOWIN.NE.0) GO TO 18
      YLIMIT(2)=FY(J2,1)
      GO TO 19
   18 IF(J2.GE.NJ) YLIMIT(2)=2.*FY(NJ,1)-FY(NJ-1,1)
      IF(J2.LT.NJ) YLIMIT(2)=FY(J2+1,1)
   19 YLIMIT(1)=FY(J1,1)
      Y0=0.5*(YLIMIT(1)+YLIMIT(2))
C
C       DO THE STATISTICAL SUMS (OMIT POINTS WITH NO ERROR)
C
   20 XMNX(1)=FPMAX
      XMNX(2)=-FPMAX
      YMNX(1)=FPMAX
      YMNX(2)=-FPMAX
      XNEXT=XLIMIT(1)
      IF(I1.GT.I2 .OR. J1.GT.J2) GO TO 200
      DO 50 I=I1,I2
      XT=XNEXT
      IF(I.LT.NI) XNEXT=FX(I+1)
      IF(I.GE.NI) XNEXT=XLIMIT(2)
      IF(LOWIN.NE.0) XT=XT+(XNEXT-XT)/2.0
      X=XT-X0
      YNEXT=YLIMIT(1)
      DO 40 J=J1,J2
      IF(IENTRY.EQ.2) GO TO 25
      IF(SLFLAG.EQ.0) GO TO 22
      W=DPSLCF(FY,I)
      GO TO 30
   22 W=FY(I,J)
      GO TO 30
   25 W=FZ(I,J)
      Y=YNEXT
      IF(J.LT.NJ) YNEXT=FY(J+1,1)
      IF(J.GE.NJ) YNEXT=YLIMIT(2)
      IF(LOWIN.NE.0) Y=Y+(YNEXT-Y)/2.0
   30 IF(W.EQ.0.0) GO TO 40
      IF(XT.LT.XMNX(1)) XMNX(1)=XT
      IF(XT.GT.XMNX(2)) XMNX(2)=XT
      S1=S1+1.D0
      SW=SW+W
      SWX=SWX+W*X
      SWX2=SWX2+W*X*X
      IF(IENTRY.EQ.1) GO TO 40
      IF(Y.LT.YMNX(1)) YMNX(1)=Y
      IF(Y.GT.YMNX(2)) YMNX(2)=Y
      Y=Y-Y0
      SWY=SWY+W*Y
      SWY2=SWY2+W*Y*Y
      SWXY=SWXY+W*X*Y
   40 CONTINUE
   50 CONTINUE
      GO TO 200
C
C
C NOTE -- following code is also duplicated in HSFILL.
C
C       CALCULATE MEANS AND VARIANCES, AND FILL /DPMODE/.
C
  200 SUM1=S1
      SUMW=SW
      DO 205 I=1,12
  205 SARRAY(I)=0.
      IF(SUMW.LE.0.0) RETURN
      XAVG=SWX/SW + X0
      XSIG2=DABS(SWX2/SW-(SWX/SW)**2)
      XSIG=DSQRT(XSIG2)
      XDAVG=XSIG/DSQRT(DABS(SW))
      XDSIG=XDAVG/1.4142
C   FROM  SQRT(SIG2+-SQRT(2*SIG4/N)) APPROX= SIG +- SIG/SQRT(2N)
      IF(IENTRY.EQ.1) RETURN
      IF(IENTRY.EQ.0.AND.ND.NE.2) RETURN
C
C       NOW ADD 2-D STATISTICS
      YAVG=SWY/SW + Y0
      YSIG2=DABS(SWY2/SW-(SWY/SW)**2)
      YSIG=DSQRT(YSIG2)
      YDAVG=YSIG/DSQRT(DABS(SW))
      YDSIG=YDAVG/1.4142
      S(1)=XSIG2
      S(2)=SWXY/SW - (SWX*SWY)/(SW*SW)
      S(3)=S(2)
      S(4)=YSIG2
      S1S4 =DSQRT(DABS(S(1)*S(4)))
      RHO  =0.0
      IF (S1S4.NE.0.0) RHO=S(2)/S1S4
CCCC      DRHO =DSQRT(DABS((1.0-RHO*RHO)**2/SW))
      ALPHA=SIGN(1.57079D0,S(1)-S(2))
      IF (ABS(S(1)-S(4)).LE.1.E-10*ABS(RHO*S1S4)) GO TO 250
      ALPHA=ATAN(2.*RHO*S1S4/(S(1)-S(4)))
      IF(ALPHA.LT.0.0) ALPHA=ALPHA+6.283186
      ALPHA=ALPHA/2.0
  250 SINA =SIN(ALPHA)
      COSA =COS(ALPHA)
      SINA2=SINA*SINA
      COSA2=COSA*COSA
      TOPP =S(1)*S(4)*(1.-RHO**2)
      DIMOM=2.0*RHO*S1S4*SINA*COSA
      P1   =(S(4)*COSA2-DIMOM+S(1)*SINA2)
      P2   =(S(4)*SINA2+DIMOM+S(1)*COSA2)
      IF(P1.NE.0.0) P1=SQRT(ABS(TOPP/P1))
      IF(P2.NE.0.0) P2=SQRT(ABS(TOPP/P2))
      CORREL=RHO
      ELIPSE(1)=P1
      ELIPSE(2)=P2
      ELIPSE(3)=ALPHA
      RETURN
      END
