      SUBROUTINE DUT1(FX,FY,FYE,N,TITLE,SMAN,F,NF)
C
C   **MEMBER** DUT1
C
      EXTERNAL FX,FY,FYE
C     LOGICAL*1 TITLE(256)
      CHARACTER*1 TITLE(256)
      REAL SMAN(8)
C
C THIS IS A GENERAL DISPLAY UTILITY PROGRAM FOR PLOTTING DATA
C WHICH CAN BE REPRESENTED BY FUNCTIONS OF ONE INDEPENDANT VARIABLE
C (INDEX) I, WHICH RUNS OVER THE RANGE I=1 TO N.  THE PLOT OF FY(I)
C VS FX(I) IS MADE, WITH THE OPTION OF ALSO PLOTTING ERROR BARS
C ALONG THE FY DIRECTION, AS GIVEN BY FYE(I).  THE TITLE STORED IN
C TITLE IS ALSO PLOTTED.  IF THE MANUAL SCALES FLAG IS SET, THEN
C THE SCALE FACTORS STORED IN SMAN ARE USED, OTHERWISE AUTO SCALING
C IS DONE.  THE FUNCTIONS FX,FY, AND FYE MAY ALSO BE DOUBLY INDEXED
C TO PROVIDE MULTIPLE SUPERIMPOSED PLOTS.  IN THIS CASE N SHOULD BE
C AN INTEGER*2 ARRAY OF TWO WORDS, WITH THE FIRST WORD SPECIFYING
C THE NUMBER OF FUNCTIONS TO BE OVERPLOTTED AND THE SECOND WORD
C GIVING THE NUMBER OF POINTS PER FUNCTION TO BE PLOTTED.
C
C THE VARIABLE IDEV IN /DPMODE/ DETERMINES WHERE THE PLOT IS TO
C BE SENT (LINE PRINTER, VERSATIC PLOTTER, CALCOMP, ETC.).
C     TITLE     CONTAINS A STRING OF UP TO 80 CHARACTERS
C               TERMINATING WITH AN '@'. IF NO '@' IS
C               PROVIDED, THEN 80 CHARACTERS ARE PRINTED.
C
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomtc.INC'
C
      INTEGER DPAK
      REAL S(8)
      DATA DPAK/4HDPAK/
C
      NARG=NARGS()
      IF(NARG.LT.0) NARG=5
C
C       MAKE SURE GRAPHIC DEVICES HAVE BEEN OPENED
      IF(DPNEW.NE.DPAK) CALL DPINIT(50000)
      XSMTH1=XSMTH
C
C       SET UP VALUES FOR MISSING ARGUMENTS
      NP=MOD(N,IMULT)
      NJ=N/IMULT
      IF(N.LE.0.AND.NARG.LT.7) RETURN
      DO 5 I=1,8
      IF(NARG.GE.6) S(I)=SMAN(I)
    5 IF(NARG.LT.6) S(I)=ASCALE(I,1)
C      COPY TITLE INTO CHARACTER STRING
      CALL DPTH2C(TITLE,CTITLE,NTIT)
      KF=0
      IF(NARG.LT.7) GO TO 10
      KF=1
      IF(NARG.GE.8) KF=NF
C..#IFDEF VAX_VMS
      JF=%LOC(F)
      IF(JF.EQ.0) KF=0
CC..#ELSE
C     IF(F.EQ.0.) KF=0
C..#ENDIF
      IF(NP.GT.0) GO TO 10
      IAUT1=IAUTO(1)
      IAUT2=IAUTO(2)
      IAUTO(1)=0
      IAUTO(2)=0
      GO TO 20
C
C      CHECK IF STATISTICS IS TO BE DONE
   10 IF(ISTATS.GE.2) CALL DSTAT(1,FX,FY,FYE,FY,FYE,NP,NJ)
C      AND SET SIGMA FOR SMOOTHER, IF SMOOTHING IS TO BE DONE
      IF(SMOOTH.NE.0.AND.XSMTH.LE.0.) XSMTH=WSMTH*(FX(2,1)-FX(1,1))
C
C CHECK IF GRAPHICS PLOT IS DESIRED
   20 IF (IDEV.LE.2) GO TO 100
      CALL DPICT(0)
C     CALL NARGSET(9)
      IF(NARG.LT.7) THEN
         CALL DPGR1(FX,FY,FYE,NP,NJ,CTITLE(1:NTIT),S,0.,0)
      ELSE
         CALL DPGR1(FX,FY,FYE,NP,NJ,CTITLE(1:NTIT),S,F,KF)
      ENDIF
      CALL DPICT(1)
      GO TO 1000
C
C CHECK IF LINEPRINTER PLOT IS TO BE DONE
  100 IF (IDEV.NE.2) GO TO 200
C     CALL NARGSET(9)
      IF(NARG.LT.7) THEN
         CALL DPLP1(FX,FY,FYE,NP,NJ,CTITLE(1:NTIT),S,0.,0)
      ELSE
         CALL DPLP1(FX,FY,FYE,NP,NJ,CTITLE(1:NTIT),S,F,KF)
      ENDIF
      GO TO 1000
C
C OTHER OPTIONS CAN BE ADDED HERE
C
  200 CONTINUE
C
 1000 SLFLAG=0
      XSMTH=XSMTH1
      IF(NP.GT.0) RETURN
      IAUTO(1)=IAUT1
      IAUTO(2)=IAUT2
      RETURN
      END
