C********************************************************
C                       ftime                           *
C                                                       *
C purpose: return the number of seconds since midnight  *
C                                                       *
C usage:                                                *
C          integer*4 secs                               *
C          ...                                          *
C          call ftime(secs)                             *
C                                                       *
C                                                       *
C notes:                                                *
C       routine is set up for eastern standard time     *
C       for another time zone, change the parameter     *
C       TIMEZONE to reflect the number of hours ahead   *
C       or behind GMT                                   *
C********************************************************
 
        subroutine ftime(secs)
        entry ftime_(secs)
        integer*4 secs,SECS_IN_DAY,SECS_IN_HOUR,TIMEZONE
        parameter (SECS_IN_DAY=86400)
        parameter (SECS_IN_HOUR=3600)
c five hours ahead of GMT
        parameter (TIMEZONE=5)
c C routine
 
        call time(secs)
c Adjust for time zone
        secs = secs - TIMEZONE*SECS_IN_HOUR
        secs = MOD(secs,SECS_IN_DAY)
        return
        end
