      SUBROUTINE HCLR(ID)
C
C   **MEMBER** HCLR
C
C  CLEAR (ZERO) THE BINS AND STATISTICS FOR THE ID'TH NODE.
C  ALSO CLEARS A BLOCK IF IT WAS DEFINED BY HBLOCK WITH 'DEF0'.
C
      INCLUDE 'hcom.INC'
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomfp.INC'
C
      INTEGER HPNTR,ALL,NWDS(2),HPAK
      DATA ALL/4HALL /, NWDS/14,12/
      DATA HPAK/4HHPAK/
C
      CALL NARGSET(-1)
      IF(HPNEW.NE.HPAK) CALL HINIT(2000)
      IF(NNODES.LE.0) RETURN
      IF(ID.EQ.ALL) THEN
         NODE=NODE1
         IF(SCTTOT.LE.0.OR.SCTUNI.EQ.0) GO TO 45
         REWIND SCTUNI
         ENDFILE SCTUNI
         REWIND SCTUNI
   45    SCTUSE=0
         SCTREC=0
         M(SCTLOC+1)=1
         SCTTOT=0
      ELSE
         IF(HPNTR(ID).LE.0) RETURN
      ENDIF
C
C      Top of loop for ALL hists.
C
   50 ND=M(NODE+5)
      IF(ND.EQ.0) GO TO 350
      IF(ND.LT.1.OR.ND.GT.2) GO TO 400
C
C       THIS IS A 1-D OR 2-D HISTOGRAM
      MPARM=NODE+M(NODE+10)
      NBINS=M(MPARM+2)
      MBIN=NODE+M(NODE+12)
C
C       REDEFINE SCATTERPLOT ID
C
      IF(SCTUNI.EQ.0) GO TO 100
      IF(M(NODE+5).NE.2) GO TO 100
      IF(M(MPARM+13).EQ.0) GO TO 100
C       IF NCALLS IS ZERO, DONT NEED TO CHANGE SCAT NUM
      LMBIN=MBIN+NBINS
      IF(ID.NE.ALL.AND.M(LMBIN).LE.0.AND.M(MPARM+13).GT.0) GO TO 100
C
C       BUMP SCATTERPLOT ID TO A NEW ONE
C
      IF(SCTTOT.GE.SCTMAX) THEN
         WRITE(ERUNIT,65) M(NODE+6)
   65    FORMAT(/,' HCLR can''t renew scatpointer for ID=',A4,/,
     >          ' Do HCLR(''ALL '') to resume scat accumulation'/)
         M(MPARM+13)=-1
      ELSE
         SCTTOT=SCTTOT+1
         M(MPARM+13)=SCTTOT
      ENDIF
C
C       ZERO BINS
C
  100 IF(M(NODE+12).LE.0) GO TO 200
      IF(NBINS.LE.0) GO TO 200
      DO 180 I=1,NBINS
  180 M(MBIN+I)=0
C
C       ZERO STATISTICS
C
  200 IF(M(NODE+11).LE.0) GO TO 400
      DO 260 K=1,ND
      MP=NODE+M(NODE+11)+14*(K-1)
      R(MP+4)=FPMAX
      R(MP+5)=-FPMAX
C       LEAVE R(MP+6) UNALTERED - X0
      NWD=NWDS(K)
      DO 250 I=7,NWD
  250 R(MP+I)=0.
  260 CONTINUE
      GO TO 400
C
C       THIS IS A BLOCK
C       (CLEAR IT ONLY IF DEFINED AS DEF0 BY HBLOCK, M(NODE+9)=1)
  350 IF(M(NODE+9).EQ.0) GO TO 400
      NWD=M(NODE+8)
      IF(NWD.LE.0) GO TO 400
      MBIN=NODE+30
      DO 352 I=1,NWD
  352 M(MBIN+I)=0
C
  400 IF(ID.NE.ALL) GO TO 500
C       DO THE NEXT NODE
      NODE=M(NODE+3)
      IF(NODE.GT.NODE1) GO TO 50
C
  500 CONTINUE
C
      RETURN
C
      END
