      SUBROUTINE HCOMB(W1,ID1,OPE,W2,ID2,ID3,TITLE)
C
C  **MEMBER** HCOMB
C
C  COMBINES (ADDS, SUBTRACTS, MULTIPLIES OR DIVIDES) TWO INPUT
C  HISTOGRAMS, ELEMENT BY ELEMENT, INTO ONE OUTPUT HISTOGRAM.
C
C  ID1 AND ID2 ARE THE IDENTIFIERS OF THE INPUT HISTOGRAMS,
C  W1 AND W2 ARE THE WEIGHTS OF THE INPUT HISTOGRAMS.
C    THESE CAN BE SUPPLIED AS INTEGER, IF LESS THAN ABS 255.
C  ID3 IS THE RESULTANT (OUTPUT) HISTOGRAM.
C  OPE IS THE OPERATOR TO BE USED ('PLUS','MINU','MULT',DIVI')
C  TITLE IS THE TITLE OF THE OUTPUT HISTOGRAM.
C
C  THE RESULTANT HISTOGRAM IS, SYMBOLLICALLY
C
C   ID3 = W1*ID1 OPE W2*ID2
C
C  THE DIMENSIONS OF ALL THE HISTOGRAMS MUST AGREE.  IF ID3 DOES
C  NOT ALREADY EXIST, IT IS DEFINED IN HCOMB.
C
      INCLUDE 'hcom.INC'
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomfp.INC'
      INCLUDE 'hretcd.INC'
C
      LOGICAL*1 TITLE(256)
      INTEGER OPE
      CHARACTER*4 OPER(4),COPE
      INTEGER ND(2),YALT(2),NOD(2)
      CHARACTER*4 MS(2)
      REAL WCOMB(2),RNORM(2),RALT(2)
      DIMENSION NBI(2,2),BIM(2,2),BIW(2,2)
      INTEGER ID(2),A4ID(2),HPNTR
      DIMENSION FZ(2),DFZ(2)
      EQUIVALENCE (WW1,IW1),(WW2,IW2),(YALT(1),RALT(1))
C
      DATA OPER/'PLUS','MINU','MULT','DIVI'/
C
      CALL NARGSET(-1)
      WRITE(COPE,'(A4)') OPE
      CALL DPUPPR(COPE)
C
C ALLOW INTEGER ARGS W1 AND W2, IF POSSIBLE
      WW1=W1
      WW2=W2
      IF(IABS(IW1).LE.255) WW1=FLOAT(IW1)
      IF(IABS(IW2).LE.255) WW2=FLOAT(IW2)
      IF(ABS(WW1).LT.FPSML.OR.ABS(WW1).GT.FPBIG.OR.ABS(WW2).LT.FPSML.OR.
     >   ABS(WW2).GT.FPBIG) WRITE(ERUNIT,1) W1,W2
    1 FORMAT(/,' HCOMB WARNING - W1 AND W2 ARE STRANGE, =(',2G13.4,')')
C
      ID(1)=ID1
      ID(2)=ID2
      DO 2 I=1,2
      CALL HID2A4(ID(I),A4ID(I))
      CALL NARGSET(7)
      CALL HGET(ID(I),4HGET ,ND(I),NBI(1,I),MS(I),BIM(1,I),BIW(1,I))
      IF(IRETCD.NE.0) GO TO 991
      NOD(I)=NODE
      CALL HOPTN(9HGET,HNORM,RNORM(I),ID(I))
      CALL HOPTN(8HGET,YALT,RALT(I),ID(I))
    2 CONTINUE
C
C  TEST IF SPECIFICATIONS OF THE 2 HISTOGRAMS ARE IDENTICAL.
C
      IT=ND(1)
      IF(ND(1).EQ.ND(2)) GO TO 4
      WRITE(LPUNIT,3) (A4ID(I),ID(I),I=1,2)
    3 FORMAT(/,' HCOMB ABORT - DIM. NOT SAME,',2('  ID/ND=',A5,I2))
      IF(ITRACE.EQ.1) CALL ERRTRA
      RETURN
C
    4 DO 6 I=1,IT
      IF(NBI(I,1).NE.NBI(I,2)) GO TO 993
      IF(BIM(I,1).NE.BIM(I,2)) GO TO 993
      IF(BIW(I,1).NE.BIW(I,2)) GO TO 993
    6 CONTINUE
      NX=NBI(1,1)
      NY=1
      IF(IT.EQ.2) NY=NBI(2,1)
C
C  WHICH OPERATOR ?
C
      DO 20 I=1,4
      IOP=I
      IF(COPE.EQ.OPER(I)) GO TO 25
   20 CONTINUE
      WRITE(LPUNIT,21) OPE
   21 FORMAT(/,' HCOMB ABORT - CALLED WITH ILLEGAL OPER, =',A5)
      IF(ITRACE.EQ.1) CALL ERRTRA
      RETURN
C
   25 CALL HID2A4(ID3,ID3A)
      CALL NARGSET(1)
      IF(HPNTR(ID3).EQ.0) GO TO 28
      WRITE(LPUNIT,27) ID3A
   27 FORMAT(/,' HCOMB ABORT - ID3=',A5,' ALREADY EXISTS')
      IF(ITRACE.EQ.1) CALL ERRTRA
      RETURN
C
   28 WRITE(LPUNIT,30) ID3A,WW1,A4ID(1),MS(1),RNORM(1),YALT(1),OPE,
     >                      WW2,A4ID(2),MS(2),RNORM(2),YALT(2)
   30 FORMAT(/,' HCOMB DEFINING ID =',A5,' FROM',
     >   '     W       ID   MS     HNORM    YALT=',/
     > 30X,G12.4,2A5,G12.4,1X,I2,/26X,A4,G12.4,2A5,G12.4,1X,I2)
C
C  DEFINE THE NEW HISTOGRAM ID3.  STORAGE MODE E*4
C
      IF(IT.EQ.1) CALL HDEF1(ID3,4HE*4 ,NX,BIM(1,1),BIW(1,1),TITLE)
      IF(IT.EQ.2) CALL HDEF2(ID3,4HE*4 ,NX,NY,BIM(1,1),BIM(2,1),
     >                        BIW(1,1),BIW(2,1),TITLE)
C
C  FILL UP THE BINS IN ID3
C
      DO 90 J=1,NY
      DO 90 I=1,NX
C
C   FIND BIN CONTENT IN HISTOGRAMS ID1 AND ID2.
C   PUT RESULT IN FZ(1) AND FZ(2)
C   CORRESPONDING ERROR IN DFZ(1) AND DFZ(2)
C
      DO 60 K=1,2
      NODE=NOD(K)
      IF(IT.EQ.2) GO TO 55
      FZ(K)=HY(I)
      DFZ(K)=HYE(I,1)
      GO TO 60
   55 FZ(K)=HZ(I,J)
      DFZ(K)=HZE(I,J,1)
   60 CONTINUE
C
C  CALCULATE WW1*FZ(1) OPER WW2*FZ(2).
C  PUT RESULT IN WCOMB(1)
C  SQUARE OF THE ERROR IN WCOMB(2)
C
      XCOMB=BIM(1,1)+((I-1)+0.5)*BIW(1,1)
      IF(IT.EQ.2) YCOMB=BIM(2,1)+((J-1)+0.5)*BIW(2,1)
      GO TO(61,62,63,64),IOP
   61 WCOMB(1)=WW1*FZ(1)+WW2*FZ(2)
      GO TO 66
   62 WCOMB(1)=WW1*FZ(1)-WW2*FZ(2)
      GO TO 66
   63 WCOMB(1)=WW1*FZ(1)*WW2*FZ(2)
      WCOMB(2)=(WW1*WW2)**2*((FZ(1)*DFZ(2))**2+(FZ(2)*DFZ(1))**2)
      GO TO 67
   64 WCOMB(1)=0.
      WCOMB(2)=0.
      IF(WW2*FZ(2).EQ.0.) GO TO 67
      WCOMB(1)=WW1*FZ(1)/(WW2*FZ(2))
      WCOMB(2)=(WW1/WW2)**2*
     >         ((FZ(1)*DFZ(2))**2+(FZ(2)*DFZ(1))**2)/FZ(2)**4
      GO TO 67
   66 WCOMB(2)=(WW1*DFZ(1))**2+(WW2*DFZ(2))**2
C
C  ACCUMULATION IN HISTOGRAM ID3.
C
   67 IF(IT.EQ.1) CALL HCUM1(ID3,XCOMB,WCOMB)
      IF(IT.EQ.2) CALL HCUM2(ID3,XCOMB,YCOMB,WCOMB)
   90 CONTINUE
      RETURN
C
C  ERRORS
C
  991 WRITE(LPUNIT,1001) A4ID(I)
 1001 FORMAT(/,' HCOMB ABORT - HIST ',A4,' DOESNT EXIST')
      IF(ITRACE.EQ.1) CALL ERRTRA
      RETURN
  993 WRITE(LPUNIT,1003) A4ID
 1003 FORMAT(/,' HCOMB ABORT - PARMS OF HISTS ',2A5,' DIFFER')
      RETURN
      END
