      SUBROUTINE HCUM2(ID,X,Y,W)
C
C
C  HCUM2 ACCUMMULATES THE VALUE(S) IN W INTO THE HISTOGRAM WITH
C  IDENTIFIER ID INTO A BIN WHICH IS DETERMINED FROM THE VALUE OF X,Y.
C  (THE HISTOGRAM MUST HAVE PREVIOUSLY BEEN DEFINED BY HDEF2).
C
C   A. BOYARSKI,  1978
C
C
      REAL W(*)
      INTEGER HPAK
C
      INCLUDE 'hcom.INC'
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomfp.INC'
      INCLUDE 'hretcd.INC'
C
      REAL*8 DTEMP,DTEMPX,DTEMPY
      EQUIVALENCE (RW,IW),(RW2,IW2)
      LOGICAL LTEMP
      EQUIVALENCE (ITEMP,LTEMP)
C
      DATA HPAK/4HHPAK/
C
C
      IF(HPNEW.NE.HPAK) CALL HINIT(2000)
      HASHID=MOD(IABS(ID),HSHLEN)
      NH=M(HSHCNT+HASHID)
      IRETCD=0
      IF(NH.GT.0) GO TO 720
C        The histogram does not exist
      IRETCD=1
      RETURN
C
  720 NODE=M(HSHLOC+HASHID)
      DO 740 I=1,NH
      IF(M(NODE+4).EQ.ID) GO TO 750
  740 NODE=M(NODE+1)
C       IF WE LAND HERE, THERE IS AN INCONSISTANCY IN HASH POINTERS
      IRETCD=2
      RETURN
C
  750 CONTINUE
C
C
C       MAKE SURE THIS IS A 2-D NODE
      ND=M(NODE+5)
      IF(ND.NE.2) GO TO 940
      MPARM=NODE + M(NODE+10)
      MSTATS=NODE + M(NODE+11)
      IOVER=0
      DX=R(MPARM+7)
      DY=R(MPARM+11)
      IF(DY.LE.0.0.OR.DX.LE.0.0) GO TO 950
      XMIN=R(MPARM+6)
      YMIN=R(MPARM+10)
      IF(X.LT.XMIN) GO TO 202
      IF(X.GE.R(MPARM+8)) GO TO 204
      IBIN=IFIX((X-XMIN)/DX) + 1
      IBIN=MIN0(IBIN,M(MPARM+5))
      GO TO 206
C
C       X UNDERFLOW (2-D)
C
  202 IBIN=1
      IOVER=1
      GO TO 206
C
C       X OVERFLOW (2-D)
C
  204 IBIN=M(MPARM+5)
      IOVER=2
  206 IF(Y.LT.YMIN) GO TO 250
      IF(Y.GE.R(MPARM+12)) GO TO 260
      JBIN1=(Y-YMIN)/DY
      JBIN1=MIN0(JBIN1,M(MPARM+9)-1)
      IBIN=IBIN + JBIN1*M(MPARM+5)
      IF(IOVER.NE.0.OR.M(MPARM+13).LE.0) GO TO 240
C
C       SCATTER PLOT (0 UNIT NUMBER MEANS DONT DO SCATTERPLOT)
C
      IF(SCTUNI.EQ.0) GO TO 240
C
C       SCTUSE TELLS STATUS AND USE OF SCATTERPLOT FILE
C        -1  VIRGIN FILE, NOT YET USED.
C         0  READ BACK MODE, FILE POSITION NOT AT ITS END
C         1  COLLECT MODE, FILE SITTING AT ITS END RECORD.
C
      IF(SCTUSE.GE.1) GO TO 225
      IF(SCTUSE.EQ.0) GO TO 218
      REWIND SCTUNI
      SCTREC=0
      GO TO 222
  218 READ(SCTUNI,END=220)
      GO TO 218
  220 BACKSPACE SCTUNI
  222 M(SCTLOC+1)=1
      SCTUSE=1
  225 IX=(X-XMIN)*R(MPARM+14)
      IY=(Y-YMIN)*R(MPARM+15)
      ISCAT=M(MPARM+13)
C       IF W IS NEGATIVE, MARK SIGN BUT OF SCATTERPOINT WORD
      IF(W(1).LT.0.) ISCAT=ISCAT+2048
      NXY=IOR(ISHFT(ISCAT,20),IOR(ISHFT(IX,10),IY))
      M(SCTLOC+1)=M(SCTLOC+1)+1
      M(SCTLOC+M(SCTLOC+1))=NXY
      IF(M(SCTLOC+1).LT.SCTLEN) GO TO 240
CW    WRITE(SCTUNI) (M(SCTLOC+I),I=1,SCTLEN)
      CALL HWSBUF
      M(SCTLOC+1)=1
      SCTREC=SCTREC+1
C
C       TEST WHETHER STATISTICS IS TO BE MADE
  240 IF(M(NODE+11).GT.0) GO TO 280
      GO TO 500
C
C       Y UNDERFLOW (2-D)
C
  250 CONTINUE
      IOVER=IOVER+3
      IF(M(NODE+11).EQ.0) GO TO 500
      GO TO 280
C
C       Y OVERFLOW (2-D)
C
  260 IBIN=IBIN + (M(MPARM+9)-1)*M(MPARM+5)
      IOVER=IOVER+6
      IF(M(NODE+11).EQ.0) GO TO 500
      GO TO 280
C
C       STATISTICS (2-D)
C
  280 R(MSTATS+18)=AMIN1(R(MSTATS+18),Y)
      R(MSTATS+19)=AMAX1(R(MSTATS+19),Y)
C
C
C------------------------------------------------------------------
C          COMMON CODE FOR HCUM1.FOR AND HCUM2.FOR
C
C        2-D STATS, 1-D STATS ALSO ENTER HERE
  290 R(MSTATS+4)=AMIN1(R(MSTATS+4),X)
      R(MSTATS+5)=AMAX1(R(MSTATS+5),X)
      IF(M(MSTATS+1).EQ.0) GO TO 292
C       OMIT STATS OUTSIDE OF LIMITS (SET BY SLIMIT IN HOPTN)
      IF(ND.EQ.1) GO TO 291
C       TEST Y
      IF(Y.LT.R(MSTATS+16).OR.Y.GT.R(MSTATS+17)) GO TO 500
C       TEST X
  291 IF(X.LT.R(MSTATS+2).OR.X.GT.R(MSTATS+3)) GO TO 500
  292 DTEMPX=X-R(MSTATS+6)
      MSTAT2=MSTATS/2
      RW=W(1)
      IF(IABS(IW).LT.128) RW=IW
      DTEMP=DTEMPX*RW
      D(MSTAT2+4)=D(MSTAT2+4) + 1.D0
      D(MSTAT2+5)=D(MSTAT2+5) + RW
      D(MSTAT2+6)=D(MSTAT2+6) + DTEMP
      DTEMP=DTEMP*DTEMPX
      D(MSTAT2+7)=D(MSTAT2+7) + DTEMP
      IF(ND.EQ.1) GO TO 500
C       2-D STATS CONTINUE
      DTEMPY=Y-R(MSTATS+20)
      DTEMP=DTEMPY*RW
      D(MSTAT2+11)=D(MSTAT2+11) + DTEMP
      DTEMP=DTEMP*DTEMPY
      D(MSTAT2+12)=D(MSTAT2+12) + DTEMP
      D(MSTAT2+13)=D(MSTAT2+13) + DTEMPX*DTEMPY*RW
C
C
C
C       ACCUMULATION  (1-D AND 2-D)
C
  500 IF(M(NODE+12).LE.0) RETURN
      MBINS=NODE + M(NODE+12)
C       CHECK IF OVERFLOWS OR ONLY TOTAL CALLS ARE TO BE KEPT
      IF(M(MPARM+3).EQ.0) IOVER=0
C       COUNT NUMBER OF CALLS (AND OVERFLOWS)
      K=M(MPARM+2)+MBINS-IOVER
      M(K)=M(K)+1
C
      MS=M(MPARM+1)
      IF(IOVER.NE.0.AND.MS.NE.15) RETURN
      RW=W(1)
      IF(IABS(IW).LT.128)
     >GO TO (512,522,532,540,550,560,570,580,590,600,
     >       610,590,600,610,620),MS
      GO TO (510,520,530,542,550,560,570,580,590,600,
     >       610,590,600,610,620),MS
      RETURN
C
C       L*1
C
  510 IW=RW+SIGN(.5,RW)
  512 K=4*MBINS+IBIN
      LTEMP=L(K)
      IF(ITEMP.GE.L1MAX) RETURN
      IF(L1MIN.LT.0.AND.ITEMP.LE.L1MIN) RETURN
      ITEMP=MIN0(L1MAX,MAX0(L1MIN,ITEMP+IW))
      L(K)=LTEMP
      RETURN
C
C       I*2
C
  520 IW=RW+SIGN(.5,RW)
  522 K=2*MBINS+IBIN
      ITEMP=H(K)
      IF(IABS(ITEMP).GE.I2MAX) RETURN
      H(K)=MIN0(I2MAX,MAX0(-I2MAX,ITEMP+IW))
      RETURN
C
C       I*4
C
  530 IW=RW+SIGN(.5,RW)
  532 K=MBINS+IBIN
      IF(IABS(M(K)).GE.I4MAX) RETURN
      M(K)=MIN0(I4MAX,MAX0(-I4MAX,M(K)+IW))
      RETURN
C
C       R*4
C
  540 RW=IW
  542 R(MBINS+IBIN)=R(MBINS+IBIN)+RW
      RETURN
C
C       E*4
C
  550 K=MBINS+2*IBIN
      R(K-1)=R(K-1)+W(1)
      R(K)=R(K)+W(2)
      RETURN
C
C       M*4
C
  560 K=MBINS+2*IBIN
      ERR=0.0
      IF(R(K).NE.0) ERR=1.0/R(K)
      T=0.0
      IF(W(2).NE.0.0) T=1.0/W(2)
      IF(T+ERR.NE.0.0) R(K)=1.0/(T+ERR)
      R(K-1)=(T*W(1)+R(K-1)*ERR)*R(K)
      RETURN
C
C       WEV
C
  570 K=MBINS+2*IBIN
      R(K-1)=R(K-1)+W(1)
      R(K)=R(K)+W(1)*W(1)
      RETURN
C
C       A*4
C
  580 K=MBINS+3*(IBIN-1)
      T=W(1)-R(K+1)
      T1=R(K+3)+1.0
      R(K+1)=R(K+1)+T/T1
      IF(R(K+3).GT.0.) R(K+2)=R(K+2)+(T*T/T1-R(K+2)/R(K+3))
      R(K+3)=T1
      RETURN
C
C       EFF  AND  ASM
C
  590 K=MBINS+2*IBIN
      R(K-1)=R(K-1)+RW
      R(K)=R(K)+1.0
      RETURN
C
C       EF2  AND  AS2
C
  600 K=2*MBINS+2*IBIN
      IF(H(K).GE.I2MAX) RETURN
      H(K-1)=H(K-1)+IFIX(W(1)+SIGN(.5,W(1)))
      H(K)=H(K)+1
      RETURN
C
C       EF1  AND  AS1
C
  610 K=4*MBINS+2*IBIN
      LTEMP=L(K)
      IF(ITEMP.GE.L1MAX) RETURN
      ITEMP=ITEMP+1
      L(K)=LTEMP
      LTEMP=L(K-1)
      ITEMP=ITEMP+IFIX(W(1)+SIGN(.5,W(1)))
      L(K-1)=LTEMP
      RETURN
C
C       LPT
C
  620 K=MBINS+2*IBIN
      R(K+1)=X
      R(K+2)=W(1)
      RETURN
C
C------------- END OF COMMON SECTION ---------------------------------
C    ERRORS
C
  940 WRITE(ERUNIT,942) M(NODE+6)
  942 FORMAT('0HCUM2 CALLED FOR NON-2-D HIST, ID=',A6)
      IRETCD=3
      RETURN
  950 WRITE(ERUNIT,952) M(NODE+6),DX,DY
  952 FORMAT('0HCUM2 FOR ID',A6,' HAS BAD DX,DY=',2E12.3)
      IRETCD=4
      RETURN
C
C
      END
