      SUBROUTINE HDEL(ID)
C
C  DELETE THE NODE IDENTIFIED BY ID FROM THE POOLED MEMORY /HCOM/.
C
C  RETURN CODES:
C    IRETCD = 0  - DELETION DONE SUCCESSFULLY
C             1  - THE SPECIFIED HISTOGRAM DOES NOT EXIST
C
C
      INCLUDE 'hcom.INC'
      INCLUDE 'hretcd.INC'
C
      INTEGER HPNTR,ALL
      DATA ALL/4HALL /
C
C
      CALL NARGSET(-1)
      IRETCD=0
      IF(ID.NE.ALL) GO TO 100
C
C       DELETE ALL NODES
C
   50 NNODES=0
      NODEND=NODE1
      DO 55 I=1,HSHLEN
      M(HSHLOC+I-1)=0
   55 M(HSHCNT+I-1)=0
      M(SCTLOC+1)=1
      SCTTOT=0
      SCTREC=0
      SCTUSE=-1
      IF(SCTUNI.EQ.0) RETURN
      REWIND SCTUNI
      ENDFILE SCTUNI
      REWIND SCTUNI
      RETURN
C
  100 IF(HPNTR(ID).LE.0) THEN
        IRETCD=1
        RETURN
      ENDIF
C
C       SAVE LOCATION FOR THIS NODE, AND ITS SIZE
C
      NODLOC=NODE
      NODSIZ=M(NODE+3)-NODE
      IF(M(NODE+3).EQ.NODE1) NODSIZ=NODEND-NODE
C
C       RID THIS NODE FROM THE HASH TABLES
C
      M(HSHCNT+HASHID)=M(HSHCNT+HASHID)-1
      M(HSHLOC+HASHID)=M(NODE+1)
      IF(M(HSHCNT+HASHID).LE.0) M(HSHLOC+HASHID)=0
      NNODES=NNODES-1
      IF(NNODES.LE.0) GO TO 50
C
C       LOOP OVER ALL REMAINING NODES AND FIX UP POINTERS
C
      NXTNOD=M(NODE+3)
      DO 200 INODE=1,NNODES
      NODE=NXTNOD
      NXTNOD=M(NODE+3)
C       FIX HASH POINTER WITHIN THE NODE POINTING TO DELETED NODE
      IF(M(NODE+1).EQ.NODLOC) M(NODE+1)=M(NODLOC+1)
      IF(M(NODE+1).GT.NODLOC) M(NODE+1)=M(NODE+1)-NODSIZ
  200 IF(M(NODE+3).GT.NODLOC) M(NODE+3)=M(NODE+3)-NODSIZ
C
      M(NODEND+1)=M(NODEND+1)-NODSIZ
C
C       IF DELETED NODE WAS LAST NODE IN SEQUENCE, FIX POINTER IN
C       PREVIOUS NODE TO WRAP AROUND TO NODE1.
C
      IF(M(NXTNOD+3).NE.NODE1) GO TO 250
      M(NODE+3)=NODE1
      M(NODEND+1)=NODE
C
  250 NODEND=NODEND-NODSIZ
C
C       COLLAPSE THE HOLE LEFT BY DELETED NODE
C
      DO 300 I=NODLOC,NODEND
  300 M(I+1)=M(I+1+NODSIZ)
C
C       FIX POINTERS IN HASH TABLE
C
      DO 400 I=1,HSHLEN
      J=I-1
  400 IF(M(HSHLOC+J).GT.NODLOC) M(HSHLOC+J)=M(HSHLOC+J)-NODSIZ
C
      RETURN
C
      END
