      SUBROUTINE HINIT(NWCOM,IHASH,NSCAT,IUNIT)
C
C  **MEMBER** HINIT
C
C  INITIALIZE THE COMMON BLOCK /HCOM/, AND /SCPBUF/.
C  NWCOM SPECIFIES THE SIZE THAT USER HAS DEFINED HCOM TO BE.
C  IHASH  (OPTIONAL) SPECIFIES THE SIZE OF THE HASH TABLE.
C  NSCAT  (OPTIONAL) SPECIFIES THE SIZE OF THE SCATTERPLOT BUFFER
C  IUNIT  (OPTIONAL) SPECIFIES UNIT NUM OF SCATTERPLOT (SCRATCH) FILE
C
      INCLUDE 'hcom.INC'
      INCLUDE 'dpmode.INC'
C
      INTEGER HPAK,DPAK
      LOGICAL HSCUNI
      DATA HPAK/4HHPAK/, DPAK/4HDPAK/
C
      NARG=NARGS()
      IF(NARG.LT.0) NARG=1
C
      ISIZE=NWCOM
C
      WRITE(ERUNIT,10) ISIZE
   10 FORMAT(/,' HANDYPAK  --  RELEASE 6.59 --  HCOM SIZE =',I8)
C
C       NUMBER OF DEFINED NODES
      NNODES=0
C
C       SAVE SIZE AS DEFINED BY USER
      NHCOM=ISIZE
C
      IHCOM(1)=0
      IHCOM(2)=0
C
C       DEFAULT SIZE OF HASH TABLE
      HSHLEN=137
      IF(NARG.GE.2) HSHLEN=IHASH
C
C       DEFAULT SIZE OF SCATTER PLOT BUFFER
      SCTLEN=100
      IF(NARG.GE.3) SCTLEN=NSCAT
C
C       HASH TABLE STARTS AFTER THE 17 WORD CONTROL AREA
C       HASH COUNT FOLLOWS, THEN SCATTERPLOT BUFFER FOLLOWS.
      HSHLOC=18
      HSHCNT=HSHLOC+HSHLEN
      SCTLOC=HSHCNT+HSHLEN
C
C       THE NODES FOLLOW THE ABOVE, WITH NODE1+1 POINTING TO FIRST
C       WORD OF THE NODE AREA.
C       NODE1 MUST ALSO BE ON AN EVEN WORD BOUNDARY.
      NODE1=SCTLOC+SCTLEN
      NODE1=NODE1+MOD(NODE1,2)
C
C       NODEND IS POINTER TO FREE SPACE AREA (SAME AS NODE1 INITIALLY)
      NODEND=NODE1
C
C       SAVE BACKWARD POINTER TO LAST NODE IN SEQUENCE
      M(NODEND+1)=NODE1
C
C       NEXT ITEMS DONT MATTER, BUT SET THEM TO 0 ANYWAY
      NODE=0
      HASHID=0
C
C       SET FLAG INDICATING HCOM HAS BEEN INITIALIZED
      HPNEW=HPAK
C
C       CLEAR HASH TABLES
      DO 50 I=1,HSHLEN
      M(HSHLOC+I-1)=0
   50 M(HSHCNT+I-1)=0
C
      IF(DPNEW.NE.DPAK) CALL DPINIT(50000)
C
C       UNIT NUMBER FOR WRITING OUT SCATTER POINTS TO A FILE
      JUNIT=19
      IF(NARG.GE.4) JUNIT=IUNIT
C       SET SCTUNI IF HSCUNI SAYS THERE IS A SCATTERPLOT FILE.
      SCTUNI=0
      IF(HSCUNI(JUNIT)) SCTUNI=JUNIT
C
C       INITIALIZE USAGE AND FILLED STATUS OF SCATTERPLOT BUFFER
      SCTUSE=-1
      M(SCTLOC+1)=1
      SCTMAX=2047
      SCTTOT=0
      SCTREC=0
C
      RETURN
      END
