      FUNCTION HN(I,J)
C
C   **MEMBER**  HN
C
C  THE FUNCTION RETURNS THE FOLLOWING VALUES:
C
C     HN(I,J)   (INTEGER) NUMBER OF CALLS MADE BY HCUM.
C               HN RETURNS THE NUMBER OF CALLS IN HIST OR IN OVERFLOWS
C         I = -1, 0, 1  SPECIFIES X-UNDER, INSIDE, OVERFLOWS (1- AND 2-D)
C         J = -1, 0, 1  SPECIFIES Y-UNDER, INSIDE, OVERFLOWS (2-D).
C
C         IF THE HIST DOES NOT HAVE THE REQUESTED ITEM, THEN -1
C         IS RETURNED TO FLAG THE ERROR TO THE USER.
C
      INCLUDE 'hcom.INC'
C
      INTEGER HN, IDX1(3),IDX2(9)
C       IDX1 AND IDX2 GIVE LOCATIONS IN NODE OF NUM. OF CALLS/OVFLOWS
C
      DATA IDX1/1,0,2/, IDX2/4,1,7,3,0,6,5,2,8/
C
C
      HN=-1
      NARG=NARGS()
      IF(NARG.LT.0) NARG=2
      IF(IABS(I).GT.1) RETURN
C       MAKE SURE THIS HIST HAS BINNED DATA
      IF(M(NODE+12).LE.0) RETURN
C       MAKE SURE THIS IS A 1-D OR 2-D HIST
      ND=M(NODE+5)
      IF(ND.LT.1.OR.ND.GT.2) RETURN
      MPARM=NODE+M(NODE+10)
      LMBIN=NODE+M(NODE+12)+M(MPARM+2)
C       CHECK IF THIS HIST HAS OVERFLOWS STORED IN THE NUM OF CALLS
      IF(M(MPARM+3).EQ.0) GO TO 840
C       YES, IT HAS OVERFLOW INFORMATION
      IF(ND.EQ.2) GO TO 820
C       THIS IS A 1-D HIST
      HN=M(LMBIN-IDX1(I+2))
      RETURN
C
C       THIS IS A 2-D HIST
  820 IF(NARG.LT.2) RETURN
      IF(IABS(J).GT.1) RETURN
      K=3*(J+1)+I+2
      HN=M(LMBIN-IDX2(K))
      RETURN
C
C       THIS HIST HAS ONLY THE TOTAL NUM OF CALLS (NO UNDER/OVER INFO).
  840 IF(I.NE.0) RETURN
      IF(NARG.GE.2.AND.J.NE.0) RETURN
      HN=M(LMBIN)
      RETURN
C
      END
