      SUBROUTINE HREAD(ID,LUN,IREC,ICTL,ID2)
C
C   **MEMBER** HREAD
C
C
C  READ HISTOGRAM(S) FROM A MASS STORAGE DEVICE INTO /HCOM/.
C
C  ID    = (INPUT OR OUTPUT) IDENTIFIER OF HISTOGRAM.
C          IF ICTL IS NOT 'GET ', THEN ID IS INPUT AS FOLLOWS:
C          IF ID='ALL ', THEN ALL HISTOGRAMS ARE READ.
C          IF ID=0, ALL THE HISTOGRAMS AND HCOM CONTROL AREAS
C                   ARE READ (I.E. /HCOM/ IS READ IN ONE BLOCK)
C          IF ID IS NOT SUPPLIED, THE DEFAULT IS 0.
C          IF ICTL IS 'GET ', THEN ID RETURNS THE ID OF THE NEXT
C          RECORD ON THE INPUT FILE, AND THE FILE IS LEFT AT THE
C          BEGINNING OF THAT RECORD.
C  LUN   = FORTRAN LOGICAL UNIT NUMBER OF INPUT FILE, DEFAULT=21
C  IREC  = (INPUT OR OUTPUT) RECORD NUMBER.
C          IF ICTL IS NOT 'GET ', THEN IREC IS AN INPUT AS FOLLOWS:
C          IREC SPECIFIES THE RECORD NUMBER TO BE SEARCHED FOR.
C          IREC = 0 MEANS REWIND AND THEN USE ANY RECORD THAT MATCHES
C          THE ID (IF RECORD WAS WRITTEN
C          WITH AN ID=0, THEN IT CAN ONLY BE READ WITH AN ID=0).
C          IF IREC IS NOT SUPPLIED, THE DEFAULT IS 0.
C          IF IREC=0 AND ID='ALL', THEN ALL HISTS ARE READ OFF ALL
C          RECORDS!
C          IF IREC IS 'NEXT', THEN SEARCH BEGINS AT THE NEXT REC NUM.
C  ICTL  = INPUT CONTROL WORD (4-CHAR HOLLERITH)
C          ICTL='ADD '  ADD CONTENTS OF HIST FROM DISK TO MEMORY
C               'REPL' REPLACE HIST IN MEMORY WITH THAT FROM DISK
C               'SKIP' SKIP OVER THIS HIST ON DISK
C               'GET ' RETURN ID AND IREC OF NEXT RECORD ON INPUT FILE.
C                      (THE FILE IS LEFT AT BEGINNING OF THIS RECORD)
C          IF ICTL IS NOT SUPPLIED, THE DEFAULT 'ADD '.
C  ID2   = IDENTIFIER THAT THE INPUT HIST IS TO HAVE WHEN IT IS
C          READ INTO MEMORY.  (I.E. ID ADDS TO OR REPLACES ID2).
C          IF ID2 IS NOT SUPPLIED, THE DEFAULT FOR ID2 IS ID.
C
C
      INCLUDE 'hcom.INC'
      INCLUDE 'dpmode.INC'
C
        SAVE /DPHEAD/
      COMMON / DPHEAD / IHDR(24)
      CHARACTER*4 IHDR
C
      INTEGER ALL,HPNTR
      INTEGER ICTL
      CHARACTER*4 JCTL,ADD,REPL,SKIP,GET
      INTEGER ICMPR(9),NCMPR(2),NCAL(2),ZMASK
      CHARACTER*4 ACMPR(9),AWHO(2)
        INTEGER*2 INDX(256)
      LOGICAL LW4,LTEMP
      EQUIVALENCE (LW4,IW),(LTEMP,ITEMP)
C
      DATA ALL/4HALL /, ADD,REPL,SKIP/'ADD ','REPL','SKIP'/,NEXT/4HNEXT/
      DATA GET/'GET '/
      DATA ICMPR/1,2,3,5,6,7,9,10,11/
      DATA ACMPR/' IMS','NWDS','HOMT','  NX','XLOW',' XWD',
     >           '  NY','YLOW',' YWD'/
      DATA AWHO/'MEM ','DISK'/
      DATA NCMPR/6,9/, NCAL/3,9/
CC..#IFDEF VM_CMS
C     DATA ZMASK/Z800FFFFF/
C..#ELIF VAX_VMS
C     DATA ZMASK/'800FFFFF'X/
CC..#ELSE
      DATA ZMASK/Z'800FFFFF'/
C..#ENDIF
C
      NARG=NARGS()
      IF(NARG.LT.0) NARG=2
      JD=0
      IF(NARG.GE.1) JD=ID
      CALL HID2A4(JD,JDA4)
      IUNIT=21
      IF(NARG.GE.2) IUNIT=LUN
      JREC=0
      IF(NARG.GE.3) JREC=IREC
      JCTL=ADD
      IF(NARG.GE.4) WRITE(JCTL,'(A4)') ICTL
      CALL DPUPPR(JCTL)
      KREC1=999999
      KREC2=0
      NHIST=0
C       CLEAR SCAT NUMBERS IN TEMP ARRAY
        DO 80 I=1,256
   80   INDX(I)=0
C
      ISCAT=SCTUNI
      LSCAT=SCTLEN
      IFOUND=0
C
C       open input file for input mode
C..#IFDEF VAX_VMS
C     OPEN(IUNIT,STATUS='OLD',READONLY,FORM='UNFORMATTED',
C    >     ERR=230,IOSTAT=ISTAT)
CC..#ELIF VM_CMS
C     OPEN(IUNIT,STATUS='OLD',ERR=230,IOSTAT=ISTAT)
CC..#ELIF unix ?
      INQUIRE(IUNIT,OPENED=LTEMP)
      IF (.NOT.LTEMP)
     >OPEN(IUNIT,STATUS='OLD',FORM='UNFORMATTED',
     >     ERR=230,IOSTAT=ISTAT)
CC..#ELSE
C     INQUIRE(IUNIT,OPENED=LTEMP)
C     IF(.NOT.LTEMP) THEN
C        WRITE(ERUNIT,'('' You must open a file for HREAD, like'',
C    >   /,''      OPEN('',I3,'',FILE=...'')') IUNIT
C        RETURN
C     ENDIF
C..#ENDIF
C
      IF(JREC.EQ.NEXT.OR.JCTL.EQ.GET) GO TO 105
      IF(JCTL.EQ.ADD.OR.JCTL.EQ.REPL.OR.JCTL.EQ.SKIP) GO TO 100
      WRITE(LPUNIT,95) JCTL
   95 FORMAT(/,' HREAD ARG ERR - ',A4,' NOT VALID FOR ICTL')
      RETURN
C
  100 REWIND IUNIT
C
C       READ IN CONTROL HEADER FOR NEXT BLOCK ON INPUT FILE
  105 READ (IUNIT,END=250,ERR=240) KD,KREC,NWDS,KBLK,NBLK,KMORE
      CALL HID2A4(KD,KDA4)
CDBUG      WRITE(6,9933) KD,KREC,NWDS,KBLK,NBLK,KMORE
CDBUG 9933 FORMAT(' HREAD KD..=',7I6)
C
      IF(JCTL.EQ.GET ) GO TO 600
C
C       CHECK IF THIS RECORD NUMBER IS TO BE USED
      IF(JREC.EQ.NEXT) GO TO 106
      IF(JREC.NE.0.AND.JREC.GT.KREC) GO TO 107
  106 IF(JD.NE.0.AND.KD.EQ.0) GO TO 107
C
      IF(JD.NE.0) GO TO 300
C
C
C --------------------------------------------------------------
C
C READ IN HCOM IN ONE BLOCK
C AND ALSO DPHEAD AND SCATTERPLOT FILE (IF THERE)
C
C --------------------------------------------------------------
C
      IF(KD.EQ.0.AND.
     >   (JREC.EQ.0.OR.JREC.EQ.KREC.OR.JREC.EQ.NEXT)) GO TO 110
C
  107 READ (IUNIT)
C SKIP OVER REMAINING SCATTERPOINT BLOCKS, IF ANY
      IF(KMORE.EQ.0) GO TO 105
  108 READ (IUNIT) KD,KREC,KLEN,KBLK,NBLK,ILAST
      READ (IUNIT)
      IF(ILAST.EQ.0) GO TO 108
      GO TO 105
C
  110 IF(JCTL.EQ.SKIP) GO TO 107
      IF(NWDS.LE.NHCOM) GO TO 118
C      FILE SIZE TOO LARGE, CANT READ IT INTO HCOM
      WRITE(LPUNIT,117) NWDS,NHCOM
  117 FORMAT(/,' HREAD ABORTED, NEED',I6,' WORDS IN HCOM, BUT ONLY',I5,
     >   ' AVAIL')
      BACKSPACE IUNIT
      RETURN
C
  118 IF(SCTUNI.EQ.0) GO TO 120
C
      REWIND SCTUNI
      SCTUSE=0
      SCTREC=0
C
  120 READ (IUNIT,END=250,ERR=240) (M(I),I=1,NWDS),IHDR
C
C      WIPE OUT NFUNC AND NCONTOUR SINCE EXTERNAL ADDRESS UNKNOWN
      IF(NNODES.LE.0) GO TO 125
      NODE=NODE1
      DO 122 J=1,NNODES
      IF(M(NODE+5).LE.0 .OR. M(NODE+5).GT.2) GO TO 121
      IF(M(NODE+14).GT.0) M(NODE+M(NODE+14)+4)=0
      IF(M(NODE+5).EQ.2) M(NODE+M(NODE+10)+17)=0
  121 NODE=M(NODE+3)
  122 CONTINUE
C
  125 SCTUNI=ISCAT
      IF(SCTUNI.NE.0.AND.KMORE.GT.0) GO TO 160
C
C       SINCE CURRENT JOB HAS NO SCATTERPLOT FILE, WIPE OUT ANY
C       POINTERS TO SCATTERPLOTS THAT WERE BROUGHT FROM INPUT FILE
  130 IF(NNODES.LE.0) GO TO 190
      NODE=NODE1
      DO 140 J=1,NNODES
      IF(M(NODE+5).NE.2) GO TO 138
      MPARM=NODE+M(NODE+10)
      M(MPARM+13)=0
  138 NODE=M(NODE+3)
  140 CONTINUE
C      AND POSITION OVER THE SCATTERPLOT BLOCKS ON INPUT FILE
      IF(SCTREC.LE.0) GO TO 190
  150 SCTREC=0
      IF(ISCAT.EQ.0) GO TO 190
      READ (IUNIT) KD,KREC,KLEN,KBLK,NBLK,ILAST
      READ (IUNIT)
      IF(ILAST.EQ.0) GO TO 150
      GO TO 190
C
C      COPY SCATTERPLOT POINTS FROM INPUT FILE TO SCATTERPLOT FILE
C
C
  160 IF(ISCAT.EQ.0) GO TO 190
      READ (IUNIT) KD,KREC,KLEN,KBLK,NBLK,ILAST
      IF(SCTLEN.EQ.LSCAT) GO TO 170
      WRITE(LPUNIT,161) SCTLEN,LSCAT
  161 FORMAT(/,' HREAD DIDNT COPY SCATTERPLOTS CAUSE BUFFER TOO SMALL',
     >  I6,' NEEDED, ONLY',I6,' AVAIL')
      GO TO 130
  170 CONTINUE
      READ (IUNIT,END=250,ERR=240) (M(SCTLOC+I),I=1,SCTLEN)
      CALL HWSBUF
  180 CONTINUE
      IF(ILAST.EQ.0) GO TO 160
CDBUG      WRITE(LPUNIT,185) SCTREC,KREC
CDBUG  185 FORMAT(/,' HREAD COPIED ',I5,' SCATTERPNT BLKS FROM REC',I5)
      GO TO 190
C
C       DONE COPYING SCATERPLOT FILE FROM DISK
C
  190 WRITE (LPUNIT,195) IUNIT,KREC
  195 FORMAT(/,' HREAD FILLED ALL OF HCOM FROM UNIT',I5,
     > ' FROM REC NUM',I5)
      M(SCTLOC+1)=1
C      LEAVE STATUS OF SCATTERPLOT FILE IN COLLECT MODE
      SCTUSE=1
C
      RETURN
C
C
C      ERROR OPENING INPUT FILE
  230 WRITE(ERUNIT,235) IUNIT,ISTAT
  235 FORMAT(/,' HREAD ERROR OPENING UNIT',I4,' IOSTAT=',I5)
      RETURN
C
C      ERROR ON INPUT FILE
  240 WRITE(ERUNIT,245) IUNIT
  245 FORMAT(/,' HREAD ERROR WHILE READING FROM UNIT',I5)
      GO TO 260
C
C      END OF FILE REACHED
  250 BACKSPACE IUNIT
C
  260 IF(JD.NE.0) GO TO 480
      WRITE(ERUNIT,265) IUNIT
  265 FORMAT(/' HREAD CANT FIND AN HCOM RECORD (ID=0) ON UNIT',I4)
      RETURN
C
C
C --------------------------------------------------------------
C
C       INPUT ONE OR ALL HISTOGRAMS (BUT NOT CONTROL AREA)
C
C --------------------------------------------------------------
C
  300 CONTINUE
      IF(JCTL.EQ.SKIP) GO TO 305
      IF(JD.EQ.ALL) GO TO 310
      IF(JD.EQ.KD) GO TO 310
C
C       SKIP THIS NODE AND GO TO NEXT ONE ON INPUT FILE
  305 READ (IUNIT)
      GO TO 400
C
C       PROCESS THE HIST
  310 JD2=KD
      IF(NARG.GE.5) JD2=ID2
      CALL HID2A4(JD2,JD2A4)
      IF(JCTL.EQ.REPL) CALL HDEL(JD2)
      IFOUND=1
      IPNTR=HPNTR(JD2)
      LNODE=M(NODEND+1)
      NAVAIL=NHCOM-NODEND
      IF(NAVAIL.GT.NWDS) GO TO 320
      WRITE(LPUNIT,315) KDA4,NWDS,NAVAIL
  315 FORMAT(/,' HREAD ABORTED HIST ',A4,', NEEDS',I6,
     > 'WORDS, ONLY',I6,' AVAIL')
      GO TO 400
C
C      READ HIST INTO HCOM AT THE END OF HCOM.
  320 READ(IUNIT,END=250,ERR=240) (M(NODEND+I),I=1,NWDS)
      IF(JCTL.EQ.ADD.AND.IPNTR.NE.0) GO TO 340
C
C --------------------------------------------------------------
C       REPLACE THE HIST
C       CONSTRUCT NEW NODE
C       LINK IT TO HCOM NODES
C --------------------------------------------------------------
C
      NNODES=NNODES+1
      M(LNODE+3)=NODEND
      NODE=NODEND
      IF(M(HSHCNT+HASHID).GT.0) GO TO 325
C
C       FIRST ENTRY FOR THIS HASHID -- NODE POINTS TO ITSELF
      M(NODE+1)=NODE
      GO TO 330
C
C       LINK THIS NODE INTO EXISTING HASH CHAIN (BREAK CHAIN TO DO IT)
  325 NODBRK=M(HSHLOC+HASHID)
      M(NODE+1)=M(NODBRK+1)
      M(NODBRK+1)=NODE
C
  330 M(HSHLOC+HASHID)=NODE
      M(HSHCNT+HASHID)=M(HSHCNT+HASHID)+1
      NODEND=NODEND+NWDS
C      NEXT NODE MUST BEGIN ON EVEN WORD BOUNDARY
      NODEND=NODEND+MOD(NODEND,2)
      M(NODEND+1)=NODE
C
C      THIS NEW LAST NODE SHOULD POINT TO NODE1
      M(NODE+3)=NODE1
C      INSERT NEW ID FOR THIS NODE
      M(NODE+4)=JD2
      M(NODE+6)=JD2A4
C
CDBUG      WRITE(LPUNIT,333) M(NODE+6),KDA4,IUNIT,KREC
CDBUG  333 FORMAT(/,' HREAD REPLACED HIST',A6,', WITH',A5,'  FROM UNIT',
CDBUG     > I5,' FROM REC NUM',I5)
C
      NHIST=NHIST+1
C
C      WIPE OUT NFUNC AND NCONTOUR, AND
C      CONSTRUCT NEW SCATTERPLOT NUMBER, IF THIS HIST HAS SCATTERPOINTS
C
      IF(M(NODE+5).LE.0 .OR. M(NODE+5).GT.2) GO TO 400
      MDISP=NODE+M(NODE+14)
      IF(MDISP.GT.0) M(MDISP+4)=0
      IF(M(NODE+5).NE.2) GO TO 400
      MPARM=NODE+M(NODE+10)
      M(MPARM+17)=0
      IF(SCTUNI.EQ.0) M(MPARM+13)=0
      KPLT=ISHFT(M(MPARM+13),20)
      MPLT=0
      IF(KPLT.EQ.0) GO TO 400
      IF(SCTTOT.GE.SCTMAX) GO TO 335
      SCTTOT=SCTTOT+1
C        SAVE NEW SCAT NUM IN SLOT FOR OLD SCAT NUM.
        MTMP=M(MPARM+13)
        IF(MTMP.LE.256.AND.SCTTOT.LE.256) INDX(MTMP)=SCTTOT
      M(MPARM+13)=SCTTOT
      MPLT=ISHFT(SCTTOT,20)
      GO TO 400
C
  335 WRITE(ERUNIT,336) JD
  336 FORMAT(/,' HREAD ABORTED READING SCATTERPLOT FOR ID=',A5,
     > ' -- TOO MANY SCATTERPLOTS')
      GO TO 400
C
C ----------------------------------------------------------------
C       ADD HIST TO EXISTING ONE
C
C ----------------------------------------------------------------
  340 M(NODEND+1)=LNODE
C      MAKE SURE THIS IS A 1-D OR 2-D HIST BEING ADDED
      IF(M(NODEND+5).LT.1.OR.M(NODEND+5).GT.2) GO TO 400
      MPARM=NODE+M(NODE+10)
      KPARM=NODEND+M(NODEND+10)
      MPLT=ISHFT(M(MPARM+13),20)
      KPLT=ISHFT(M(KPARM+13),20)
C       MAKE SURE DIMENSIONS AGREE
      IF(M(NODE+5).EQ.M(NODEND+5)) GO TO 344
      WRITE(LPUNIT,342) M(NODE+6),M(NODE+5),M(NODEND+5)
  342 FORMAT(/,' HREAD CANT ADD HIST ',A4,' - DIM. DIFFER, MEM = ',I1,
     >       '-D, DISK = ',I1,'-D')
      GO TO 400
  344 ND=M(NODE+5)
      NC=NCMPR(ND)
      DO 345 I=1,NC
      IF(M(MPARM+ICMPR(I)).NE.M(KPARM+ICMPR(I))) GO TO 390
  345 CONTINUE
C
C        SAVE NEW SCAT NUM IN SLOT FOR OLD SCAT NUM
      IF(ND.NE.2) GO TO 346
        MTMP=M(MPARM+13)
        KTMP=M(KPARM+13)
        IF(KTMP.GT.0.AND.KTMP.LE.256.AND.MTMP.LE.256) INDX(KTMP)=MTMP
C
C      ADD STATISTICS, IF THERE
  346 IF(M(NODE+11).EQ.0.OR.M(NODEND+11).EQ.0) GO TO 350
      MSTATS=NODE+M(NODE+11)
      KSTATS=NODEND+M(NODEND+11)
      IF(ND.EQ.1) GO TO 348
C       STATISTICS (2-D)
C
      R(MSTATS+18)=AMIN1(R(MSTATS+18),R(KSTATS+18))
      R(MSTATS+19)=AMAX1(R(MSTATS+19),R(KSTATS+19))
C
C        1-D STATS ENTER HERE
  348 R(MSTATS+4)=AMIN1(R(MSTATS+4),R(KSTATS+4))
      R(MSTATS+5)=AMAX1(R(MSTATS+5),R(KSTATS+5))
      MSTAT2=MSTATS/2
      KSTAT2=KSTATS/2
      D(MSTAT2+4)=D(MSTAT2+4) + D(KSTAT2+4)
      D(MSTAT2+5)=D(MSTAT2+5) + D(KSTAT2+5)
      D(MSTAT2+6)=D(MSTAT2+6) + D(KSTAT2+6)
      D(MSTAT2+7)=D(MSTAT2+7) + D(KSTAT2+7)
      IF(ND.EQ.1) GO TO 350
C       2-D STATS CONTINUE
      D(MSTAT2+11)=D(MSTAT2+11) + D(KSTAT2+11)
      D(MSTAT2+12)=D(MSTAT2+12) + D(KSTAT2+12)
      D(MSTAT2+13)=D(MSTAT2+13) + D(KSTAT2+13)
C
C
  350 MS=M(MPARM+1)
      KBINS=NODEND+M(NODEND+12)
      MBINS=NODE+M(NODE+12)
C      COMBINE THE #CALLS FROM THE TWO HISTS
      NC=1
      IF(M(MPARM+3).NE.0) NC=NCAL(ND)
      DO 352 I=1,NC
      K=M(MPARM+2)+MBINS-I+1
  352 M(K)=M(K)+M(M(KPARM+2)+KBINS-I+1)
C
      N=M(MPARM+5)
      IF(ND.EQ.2) N=N*M(MPARM+9)
      IF(MS.EQ.15) N=M(KBINS+2)
      IF(N.LE.0) GO TO 386
      DO 385 IBIN=1,N
      GO TO (354,356,358,360,362,364,366,368,362,370,
     >       372,362,370,372,374),MS
      GO TO 400
C
C       L*1
C
  354 LW4=L(4*KBINS+IBIN)
      K=4*MBINS+IBIN
      LTEMP=L(K)
C..#IFDEF VAX_VMS
      ITEMP=MIN0(127,MAX0(-127,ITEMP+IW))
CC..#ELSE
C     ITEMP=MIN0(255,MAX0(-255,ITEMP+IW))
C..#ENDIF
      L(K)=LTEMP
      GO TO 385
C
C       I*2
C
  356 IW=H(2*KBINS+IBIN)
      K=2*MBINS+IBIN
      H(K)=MIN0(32767,H(K)+IW)
      GO TO 385
C
C       I*4
C
  358 IW=M(KBINS+IBIN)
      K=MBINS+IBIN
      M(K)=M(K)+IW
      GO TO 385
C
C       R*4
C
  360 RW=R(KBINS+IBIN)
      R(MBINS+IBIN)=R(MBINS+IBIN)+RW
      GO TO 385
C
C       E*4
C
  362 K=MBINS+2*IBIN
      KK=KBINS+2*IBIN
      R(K-1)=R(K-1)+R(KK-1)
      R(K)=R(K)+R(KK)
      GO TO 385
C
C       M*4
C
  364 K=MBINS+2*IBIN
      KK=KBINS+2*IBIN
      ERR=0.0
      IF(R(K).NE.0) ERR=1.0/R(K)
      T=0.0
      IF(R(KK).NE.0.0) T=1.0/R(KK)
      IF(T+ERR.NE.0.0) R(K)=1.0/(T+ERR)
      R(K-1)=(T*R(KK-1)+R(K-1)*ERR)*R(K)
      GO TO 385
C
C       W*4
C
  366 K=MBINS+2*IBIN
      KK=KBINS+2*IBIN
      R(K-1)=R(K-1)+R(KK-1)
      R(K)=R(K)+R(KK)
      GO TO 385
C
C       A*4
C
  368 K=MBINS+3*(IBIN-1)
      KK=KBINS+3*(IBIN-1)
      T1=R(K+3)+R(KK+3)
      AVG=0.
      VAR=0.
      IF(T1.LE.0.) GO TO 369
      AVG=(R(K+3)*R(K+1)+R(KK+3)*R(KK+1))/T1
      IF(T1.LE.1.) GO TO 369
      VAR=((R(K+3)-1.)*R(K+2)+(R(KK+3)-1.)*R(KK+2)
     >     +R(K+3)*R(KK+3)*(R(K+1)-R(KK+1))**2/T1)/(T1-1.)
  369 R(K+1)=AVG
      R(K+2)=VAR
      R(K+3)=T1
      GO TO 385
C
C       EF2, OR AS2
C
  370 K=2*MBINS+2*IBIN
      KK=2*KBINS+2*IBIN
      DO 371 I=1,2
      ITEMP=H(K+I-2)+H(KK+I-2)
  371 H(K+I-2)=MIN0(32767,ITEMP)
      GO TO 385
C
C       EF1, OR AS1
C
  372 K=4*MBINS+2*IBIN
      KK=4*KBINS+2*IBIN
      DO 373 I=1,2
      LTEMP=L(K+I-2)
      LW4=L(KK+I-2)
C..#IFDEF VAX_VMS
      ITEMP=MIN0(127,MAX0(-127,ITEMP+IW))
CC..#ELSE
C     ITEMP=MIN0(255,MAX0(-255,ITEMP+IW))
C..#ENDIF
  373 H(K+I-2)=ITEMP
      GO TO 385
C
C      LPT
C
  374 KK=KBINS+2*IBIN
      K=M(MBINS+1)+1
      IF(K.GT.M(MPARM+5)) K=1
      M(MBINS+1)=K
      M(MBINS+2)=MIN0(M(MPARM+5),M(MBINS+2)+1)
      R(MBINS+1+2*K)=R(KK+1)
      R(MBINS+2+2*K)=R(KK+2)
      GO TO 385
C
  385 CONTINUE
  386 CONTINUE
C
CDBUG      WRITE(LPUNIT,387) M(NODE+6),IUNIT,KREC
CDBUG  387 FORMAT(/,' HREAD ADDED TO HIST',A5,' FROM UNIT',I5,
CDBUG     > ' FROM REC NUM',I5)
C
      NHIST=NHIST+1
      GO TO 400
C
C       SIZES DONT AGREE BETWEEN HIST IN MEMORY AND THAT ON FILE
  390 WRITE(LPUNIT,392) M(NODE+6),(ACMPR(I),I=1,NC)
  392 FORMAT(/,' HREAD CANT ADD HIST ',A4,' - PARAMETERS DONT MATCH'/
     > 7X,4A6,A7,A11,4X,A6,A7,A11)
      DO 398 J=1,2
      IF(J.EQ.1) JJ=MPARM
      IF(J.EQ.2) JJ=KPARM
      WRITE(LPUNIT,393) AWHO(J),(M(JJ+ICMPR(I)),I=1,3),
     >    (M(JJ+ICMPR(3*JJJ+1)),(R(JJ+ICMPR(3*JJJ+I)),I=2,3),JJJ=1,ND)
  393 FORMAT(A5,' =',4I6,2G11.3,I6,2G11.3)
  398 CONTINUE
      GO TO 400
C
  400 IF(KBLK.LT.NBLK) GO TO 105
C
C       NOW READ SCATTERPLOT BLOCKS, IF ANY
      IF(KMORE.EQ.0) GO TO 470
      NRD=0
      IF(SCTUNI.EQ.0.OR.KD.EQ.0.OR.JCTL.EQ.SKIP) GO TO 450
C
      READ (IUNIT) KD,KREC,KLEN,KBLK,NBLK,ILAST
      BACKSPACE IUNIT
401   CONTINUE
      NSHY=NODEND+1+KLEN-NHCOM
      IF(NSHY.GE.0) GO TO 500
C
C       SCTUSE TELLS STATUS AND USE OF SCATTERPLOT FILE
C        -1  VIRGIN FILE, NOT YET USED.
C         0  READ BACK MODE, FILE POSITION NOT AT ITS END
C         1  COLLECT MODE, FILE SITTING AT ITS END RECORD.
C
      IF(SCTUSE.GE.1) GO TO 425
      IF(SCTUSE.EQ.0) GO TO 418
      REWIND SCTUNI
      SCTREC=0
      GO TO 422
  418 READ(SCTUNI,END=420)
      GO TO 418
  420 BACKSPACE SCTUNI
  422 M(SCTLOC+1)=1
      SCTUSE=1
C
  425 MEND=NODEND+1
C
C      READ SCATTER BLOCKS ONE BY ONE AND ADD POINTS
  426 READ (IUNIT) KD,KREC,KLEN,KBLK,NBLK,ILAST
      READ (IUNIT,END=250,ERR=240) (M(MEND+J),J=1,KLEN)
      NRD=NRD+1
      IF(JD.NE.ALL.AND.(MPLT.EQ.0.OR.KPLT.EQ.0)) GO TO 440
      NPTS=M(MEND+1)
      IF(NPTS.LE.1) GO TO 440
      DO 430 J=2,NPTS
      ITEMP=M(MEND+J)
C        GET SCAT NUM OF INPUT POINT, CONVERT TO NEW SCAT NUM.
        KTMP=ISHFT(ITEMP,-20)
        IF(KTMP.LE.0.OR.KTMP.GT.256) GO TO 430
        KTMP=INDX(KTMP)
        IF(KTMP.EQ.0) GO TO 430
        ITEMP=IOR(ISHFT(KTMP,20),IAND(ITEMP,ZMASK))
  428 M(SCTLOC+1)=M(SCTLOC+1)+1
      M(SCTLOC+M(SCTLOC+1))=ITEMP
      IF(M(SCTLOC+1).LT.SCTLEN) GO TO 430
      CALL HWSBUF
      M(SCTLOC+1)=1
      SCTREC=SCTREC+1
  430 CONTINUE
  440 IF(ILAST.EQ.0) GO TO 426
CDBUG      WRITE(LPUNIT,445) NRD,IUNIT,KREC
CDBUG  445 FORMAT(/,' HREAD PROCESSED',I5,' SCATTERPNT BLKS FROM UNIT',I5,
CDBUG     > ' FROM REC NUM',I5)
      GO TO 470
C
C       POSITION INPUT FILE OVER ANY SCATTERPLOT BLOCKS
  450 READ (IUNIT) KD,KREC,KLEN,KBLK,NBLK,ILAST
      READ (IUNIT)
      NRD=NRD+1
      IF(ILAST.EQ.0) GO TO 450
CDBUG      WRITE(LPUNIT,455) NRD,IUNIT,KREC
CDBUG  455 FORMAT(/,' HREAD SKIPPED',I5,' SCATTERPNT BLKS FROM UNIT',I5,
CDBUG     > ' FROM REC NUM',I5)
      GO TO 470
C
C       DONE WITH THIS RECORD - CHECK IF MORE TO BE DONE
  470 KREC1=MIN0(KREC1,KREC)
      KREC2=MAX0(KREC2,KREC)
      IF(JREC.NE.0) GO TO 480
      IF(IFOUND.EQ.0.OR.JD.EQ.ALL) GO TO 105
C
  480 IF(JD.EQ.ALL) WRITE(LPUNIT,485) JCTL,NHIST,IUNIT,KREC1,KREC2
  485 FORMAT(/' HREAD',A6,I5,' HISTS FROM UNIT',I4,' REC',I5,' THRU',I5)
      IF(JD.NE.ALL.AND.IFOUND.EQ.0) WRITE(LPUNIT,490) JDA4,IUNIT
  490 FORMAT(/' HREAD CANT FIND HIST',A6,' ON UNIT',I4)
      RETURN
C
C       NOT ENOUGH ROOM TO READ SCATTERPOINTS
  500 WRITE(LPUNIT,501) NSHY
  501 FORMAT(/,' HREAD CANT READ IN SCATTER POINTS - HCOM TOO SMALL BY',
     >  I5,' WORDS')
C
      RETURN
C
C      'GET ' CONTROL OPERATION, RETURN ID AND IREC TO CALLER
  600 ID=KD
      IREC=KREC
      BACKSPACE IUNIT
      RETURN
C
      END
