      SUBROUTINE HSCPLT(TITLE)
C
      CHARACTER*(*) TITLE
C
C  GENERATES A SCATTER PLOT FROM DATA THAT IS STORED ON A
C  SCATTERPLOT SCRATCH FILE.  TITLE HOLDS THE TITLE STRING.
C
C POINT STORAGE....
C   IX,IY ARE 10-BIT NUMBERS (0 TO  1023).  THE SCATTER PLOTS NUMBER
C   IS A 7-BIT FIELD, AND HIGHEST ORDER BIT IS THE SIGN BIT.
C
      INCLUDE 'hcom.INC2'   ! for use of g77
      INCLUDE 'dpmode.INC'
      INCLUDE 'dabort.INC'
C
      REAL SMIN(2),SMAX(2),DSDI(2)
      REAL TIMARG(4)
C..#IFDEF DGSYS
      REAL PLIMIT(2,2)
      CHARACTER*8 DEVNAM
      LOGICAL L4010
CC..#ELIF GKSYS
C      REAL WINDOW(2,2),VIEWPT(4)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
#if   defined(__OSF1)
      INTEGER*8 OFFSET
      PARAMETER (OFFSET='100000000'X)	! may not work on other systems...
#else
      INTEGER*4 OFFSET
      PARAMETER (OFFSET=0)
#endif
C
      DATA PXBINS/1024./
CC..#IFDEF VM_CMS
C     DATA IMASK/Z3FF00000/,JMASK/Z000003FF/
C..#ELIF VAX_VMS
C     DATA IMASK/Z3FF00000/,JMASK/Z000003FF/
CC..#ELSE
      DATA IMASK/Z'3FF00000'/,JMASK/Z'000003FF'/
C..#ENDIF
      DATA TIMARG/.040,.027,-.005,-.013/
C
C
      IF(SCTUNI.EQ.0) RETURN
      IABORT=0
C
      CALL DPICT(0)
C..#IFDEF DGSYS
      CALL DGGET('PLIM',PLIMIT)
CC..#ELIF GKSYS
C      CALL GQCNTN(IGERR,NTRN)
C      CALL GQNT(NTRN,IGERR,WINDOW,VIEWPT)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
      MPARM=NODE+M(NODE+10)
C
C       FILL SCALING VARIABLES
      TISTEP=AMAX1(0.,TITLSZ-1.)
      DO 8 I=1,2
C..#IFDEF DGSYS
      SMIN(I)=PLIMIT(I,1) + G1MARG(I)
      SMAX(I)=PLIMIT(I,2) + G1MARG(I+2)
CC..#ELIF GKSYS
C      SMIN(I)=WINDOW(1,I) + G1MARG(I)
C      SMAX(I)=WINDOW(2,I) + G1MARG(I+2)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      IF(G1MARG(I).NE.0.0) SMIN(I)=SMIN(I)+TIMARG(I)*TISTEP
      IF(G1MARG(I+2).NE.0.0) SMAX(I)=SMAX(I)+TIMARG(I+2)*TISTEP
      DSDI(I)=(SMAX(I)-SMIN(I))/PXBINS
      AMIN=R(MPARM+4*I+2)
      AMAX=R(MPARM+4*I+4)
      SBINS=G2TIC(1,I)
C      USE DEFAULT NUMBER OF TICS, IF SPECIFIED
      IF(SBINS.LT.1.0) SBINS=8.0
C      GO FIND SCALE FACTORS (INTO ISCALE ARG)
      CALL DKSCAL(AMIN,AMAX,SBINS,0,ISCALE(1,I))
      ASCALE(1,I)=AMIN
      ASCALE(2,I)=ISCALE(2,I)*10.**ISCALE(3,I)
      ASCALE(3,I)=(AMAX-AMIN)/ASCALE(2,I)
      ASCALE(4,I)=G2TIC(2,I)
C      PACK NDECI AND IEXP INTO ISCALE(3,I)
      K=ASCALE(3,I)+.0001
      IMX=MAX0(IABS(ISCALE(1,I)),IABS(ISCALE(1,I)+K*ISCALE(2,I)))
      CALL DPDGIT(IMX,ISCALE(3,I),IPWR,NDECI)
      IF(IPWR.GE.ISCALE(3,I)) GO TO 6
      K=10**(ISCALE(3,I)-IPWR)
      ISCALE(1,I)=ISCALE(1,I)*K
      ISCALE(2,I)=ISCALE(2,I)*K
    6 ISCALE(3,I)=IPWR + 1000*NDECI
C      USE DEFAULT NUMBER OF SUB-TICS, IF SPECIFIED
      IF(G2TIC(2,I).GT.0) GO TO 8
      ASCALE(4,I)=5.0
      IF(MOD(ISCALE(2,I),2).EQ.0) ASCALE(4,I)=4.0
    8 CONTINUE
C
C       GO DRAW THE AXES, AND CURVE (IF THERE)
      MPARM=NODE+M(NODE+10)
C..#IFDEF VAX_VMS
      CALL DPGRS(TITLE,%VAL(M(MPARM+16)+OFFSET),M(MPARM+17))
CC..#ELSE
C      CALL DPGRS(TITLE,M(MPARM+16),M(MPARM+17))
C..#ENDIF
C
C IF SCATTERPLOT FILE NOT FILLED, THEN EXIT
      IF(SCTUSE.LT.0) RETURN
C
C       SET UP OPTIONS FOR MARKER SYMBOLS, IF NEEDED LATER.
C..#IFDEF DGSYS
      WRITE(DEVNAM,'(A8)') DEVTYP(IDEV)
      L4010=DEVNAM(4:7).EQ.'4010'
      IDEN=3
      IF(L4010) IDEN=1
      IF(PNTDEN.GE.1) IDEN=MIN0(4,PNTDEN)
      CALL DGGET('BRIT',IDENSV)
      CALL DGSET('BRIT',IDEN)
      SIZ=.008
      IF(L4010) SIZ=.012
      CALL DGGET('XSPA',SIZMK)
      CALL DGSET('XSPA',SIZ)
      CALL DGGET('COLO',ICOLSV)
      CALL DGSET('COLO',COLOR)
CC..#ELIF GKSYS
C      CALL GQMKSC(IGERR,SIZMK)
C      CALL GSMKSC(0.5)
C      CALL GSMK(PNTSYM+1)
C      CALL GQPMCI(IGERR,ICOLSV)
C      CALL GSPMCI(COLOR)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
C
      IF(SCTUSE.EQ.0) GO TO 5
C
C WRITE OUT REMAINING SCATTER POINTS, IF ANY, AND PUT EOF.
C
      IF(M(SCTLOC+1).GT.1) THEN
CW       WRITE(SCTUNI) (M(SCTLOC+I),I=1,SCTLEN)
         CALL HWSBUF
         M(SCTLOC+1)=1
         SCTREC=SCTREC+1
      ENDIF
      ENDFILE SCTUNI
      SCTUSE=0
C
C NEW PLOT, ALWAYS START AT BEGINNING OF SCATTERPOINT FILE
C
    5 REWIND SCTUNI
      NPTS = 0
      NPTOT=0
      MREC=0
      NPLTHI = ISHFT(M(MPARM+13),20)
C
C READ NEXT BLOCK FROM SCATTERPLOT FILE
C
   10 NREAD = 1
      NPTOT=NPTOT+NPTS
      NPTS=0
      IF(MREC.GE.SCTREC) GO TO 500
      IF(IABORT.NE.0) GO TO 70
      READ (SCTUNI,END=50,ERR=40) (M(SCTLOC+I),I=1,SCTLEN)
      MREC=MREC+1
      NWD=M(SCTLOC+1)
      IF(NWD.GT.1.AND.NWD.LE.SCTLEN) GO TO 120
C
C ERROR CONDITIONS
C
      WRITE(ERUNIT,35) NWD,SCTLEN,MREC,SCTREC,NREAD,NPTS
   35 FORMAT(/,' HSCPLT BUG - PLEASE REPORT IT: ',8I5)
      GO TO 57
C
   40 WRITE(ERUNIT,45) NWD,SCTLEN,MREC,SCTREC,NREAD,NPTS
   45 FORMAT(/,' ERROR READING SCATTER PLOT SCRATCH FILE ',8I5)
      GO TO 57
C
   50 WRITE(ERUNIT,55)
   55 FORMAT(/,' UNEXPECTED EOF HIT IN SCATTER PLOT SCRATCH FILE')
C
C..#IFDEF DGSYS
   57 CALL DGTXT(SMIN(1)+.04,SMIN(2)+.04,' ERROR -- DATA TRUNCATED')
CC..#ELIF GKSYS
C   57 CALL GTX(SMIN(1)+.04,SMIN(2)+.04,' ERROR -- DATA TRUNCATED')
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      WRITE(ERUNIT,65) NPTOT,M(NODE+6)
   65 FORMAT(' -- DATA TRUNCATED AFTER ',I8,' POINTS FOR ID=',A4)
      GO TO 500
C
C ABORTING
C..#IFDEF DGSYS
   70 CALL DGTXT(SMIN(1)+.04,SMIN(2)+.04,'ABORTED')
CC..#ELIF GKSYS
C   70 CALL GTX(SMIN(1)+.04,SMIN(2)+.04,'ABORTED')
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      GO TO 500
C
C PICK OUT POINTS IN THIS BLOCK AND PUT THEM UP
C
  120 CONTINUE
C
CC..#IFDEF VM_CMS
CC CHECK IF ENOUGH MEMORY AVAILABLE FOR UG WHEN VERSATECING
CCCCC  ISTG=ISTGCT(0)
C      CALL MXMAIN(ISTG)
C      IF(ISTG.GT.50000) GO TO 130
C      WRITE(ERUNIT,125) NPTS
C  125 FORMAT(/,' RUNNING OUT OF MEMORY FOR UG POINTS'/
C     >       ' SO HANDYPAK IS QUITTING AFTER',I8,' POINTS PLOTTED')
C      GO TO 500
C..#ENDIF
  130 IF (NREAD.GE.NWD) GO TO 10
      NREAD = NREAD + 1
      IF (IAND(IMASK,M(SCTLOC+NREAD)) .EQ. NPLTHI) THEN
C          GOT A POINT.
         IXY = M(SCTLOC+NREAD)
         IX = IAND(JMASK,ISHFT(IXY,-10))
         IY = IAND(JMASK,IXY)
         XPT = SMIN(1) + DSDI(1)*FLOAT(IX)
         YPT = SMIN(2) + DSDI(2)*FLOAT(IY)
         IF(IXY.LT.0) THEN
C           POINT FLAGGED AS NEGATIVE IS OUTPUT AS '-' (MINUS SIGN)
C..#IFDEF DGSYS
            CALL DGTXT(XPT,YPT,'-')
CC..#ELIF GKSYS
C            CALL GTX(XPT,YPT,'-')
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
         ELSE
C           DRAW THE MARKER SYMBOL
C..#IFDEF DGSYS
            IF(PNTSYM.NE.0) THEN
               CALL DGSYM(XPT,YPT,PNTSYM)
            ELSE
               CALL DGPNT(XPT,YPT,1)
            ENDIF
CC..#ELIF GKSYS
C            CALL GPM(1,XPT,YPT)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
         ENDIF
         NPTS=NPTS+1
      ENDIF
      GO TO 130
C
C ALL DONE, REWIND SCRATCH FILE AND COMPLETE PICTURE.
C
CCC  500 M(SCTLOC+1)=1
CCC   REWIND SCTUNI
  500 CALL DPICT(1)
C..#IFDEF DGSYS
      CALL DGSET('XSPA',SIZMK)
      CALL DGSET('BRIT',IDENSV)
      CALL DGSET('COLO',ICOLSV)
CC..#ELIF GKSYS
C      CALL GSMKSC(SIZMK)
C      CALL GSPMCI(ICOLSV)
CC..#ELSE
CWarning from FPPIFY. Replace or delete this line as needed.
C..#ENDIF
      RETURN
      END
