      SUBROUTINE HSFILL(ND,RIN,DIN)
C
C Fill statistics in /DPMODE/ from this historgam.
C
C NOTE -- this code is duplicated considerably in DSTAT
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcomfp.INC'
C
      REAL SARRAY(12)
      EQUIVALENCE (SARRAY(1),XAVG)
C
      REAL*8 S(4),S1S4,XSIG2,YSIG2
      REAL*8 S1,SW,SWX,SWX2,SWY,SWY2,SWXY
C
      REAL RIN(*)
      REAL*8 DIN(*)
      EQUIVALENCE (TEMP,ITEMP)
C
C  THIS ENTRY USES THE STATISTICAL SUMMATIONS STORED IN RIN AND
C  DIN TO FILL THE MEANS AND VARIANCES IN /DPMODE/.
C  ND MUST BE EITHER 1 OR 2 FOR A 1 OR 2 PARAMETER CALCULATION.
C
C  THE ORDER OF ITEMS IN THE ARRAYS ARE :
C
C   RIN( 1)= UU      DIN( 1)= UU
C        2 = XLIM1
C        3 = XLIM2        2 = UU
C        4 =XMN
C        5 =XMX           3 = UU
C        6 =X0
C        7 = UU           4 =SUM 1
C        8 = UU
C        9 = UU           5 =SUM W
C       10 = UU
C       11 = UU           6 =SUM W*(X-X0)
C       12 = UU
C       13 = UU           7 =SUM W*(X-X0)**2
C       14 = UU
C       15 = UU           8 = UU
C       16 = YLIM1
C       17 = YLIM2        9 = UU
C       18 =YMN
C       19 =YMX          10 = UU
C       20 =Y0
C       21 = UU          11 =SUM W*(Y-Y0)
C       22 = UU
C       23 = UU          12 =SUM W*(Y-Y0)**2
C       24 = UU
C       25 = UU          13 =SUM W*(X-X0)*(Y-Y0)
C       26 = UU
C
C    WHERE UU MEANS UN-USED.
C
C
C
      IENTRY=0
C
      TEMP=RIN(1)
      XLIMIT(1)=RIN(2)
      XLIMIT(2)=RIN(3)
C      PUT IN INFINITIES IF SOMIT IS FALSE
      IF(ITEMP.NE.0) GO TO 120
      XLIMIT(1)=-FPMAX
      XLIMIT(2)=FPMAX
  120 XMNX(1) = RIN(4)
      XMNX(2)= RIN(5)
      X0   = RIN(6)
      S1   = DIN(4)
      SW   = DIN(5)
      SWX  = DIN(6)
      SWX2 = DIN(7)
      IF(ND.NE.2) GO TO 200
      YLIMIT(1)=RIN(16)
      YLIMIT(2)=RIN(17)
C       PUT IN INFINITIES IF SOMIT IS FALSE
      IF(ITEMP.NE.0) GO TO 140
      YLIMIT(1)=-FPMAX
      YLIMIT(2)=FPMAX
  140 YMNX(1) = RIN(18)
      YMNX(2)= RIN(19)
      Y0   = RIN(20)
      SWY  = DIN(11)
      SWY2 = DIN(12)
      SWXY = DIN(13)
C
C       CALCULATE MEANS AND VARIANCES, AND FILL /DPMODE/.
C
  200 SUM1=S1
      SUMW=SW
      DO 205 I=1,12
  205 SARRAY(I)=0.
      IF(SUMW.LE.0.0) RETURN
      XAVG=SWX/SW + X0
      XSIG2=DABS(SWX2/SW-(SWX/SW)**2)
      XSIG=DSQRT(XSIG2)
      XDAVG=XSIG/DSQRT(DABS(SW))
      XDSIG=XDAVG/1.4142
C   FROM  SQRT(SIG2+-SQRT(2*SIG4/N)) APPROX= SIG +- SIG/SQRT(2N)
      IF(IENTRY.EQ.1) RETURN
      IF(IENTRY.EQ.0.AND.ND.NE.2) RETURN
C
C       NOW ADD 2-D STATISTICS
      YAVG=SWY/SW + Y0
      YSIG2=DABS(SWY2/SW-(SWY/SW)**2)
      YSIG=DSQRT(YSIG2)
      YDAVG=YSIG/DSQRT(DABS(SW))
      YDSIG=YDAVG/1.4142
      S(1)=XSIG2
      S(2)=SWXY/SW - (SWX*SWY)/(SW*SW)
      S(3)=S(2)
      S(4)=YSIG2
      S1S4 =DSQRT(DABS(S(1)*S(4)))
      RHO  =0.0
      IF (S1S4.NE.0.0) RHO=S(2)/S1S4
CCCC      DRHO =DSQRT(DABS((1.0-RHO*RHO)**2/SW))
      ALPHA=SIGN(1.57079D0,S(1)-S(2))
      IF (ABS(S(1)-S(4)).LE.1.E-10*ABS(RHO*S1S4)) GO TO 250
      ALPHA=ATAN(2.*RHO*S1S4/(S(1)-S(4)))
      IF(ALPHA.LT.0.0) ALPHA=ALPHA+6.283186
      ALPHA=ALPHA/2.0
  250 SINA =SIN(ALPHA)
      COSA =COS(ALPHA)
      SINA2=SINA*SINA
      COSA2=COSA*COSA
      TOPP =S(1)*S(4)*(1.-RHO**2)
      DIMOM=2.0*RHO*S1S4*SINA*COSA
      P1   =(S(4)*COSA2-DIMOM+S(1)*SINA2)
      P2   =(S(4)*SINA2+DIMOM+S(1)*COSA2)
      IF(P1.NE.0.0) P1=SQRT(ABS(TOPP/P1))
      IF(P2.NE.0.0) P2=SQRT(ABS(TOPP/P2))
      CORREL=RHO
      ELIPSE(1)=P1
      ELIPSE(2)=P2
      ELIPSE(3)=ALPHA
      RETURN
      END
