      SUBROUTINE HSLICE(ID,IXORY,M1,NS,DUNIT)
C
C  **MEMBER** HSLICE
C
C    OUTPUTS A SLICE OF THE 2-D HISTOGRAM HAVING IDENTIFIER ID,
C  PROJECTED ONTO THE X(Y) AXES IF XORY IS 'X'('Y'). THE SLICE IS MADE
C  BY SUMMING BINS ALONG THE Y(X) DIRECTION BEGINNING WITH BIN M1 AND
C  GOING FOR NS BINS TOTAL.
C  M1, NS, AND UNIT ARE OPTIONAL, AND THE DEFAULTS ARE:
C     M1=1
C     NS=0 (I.E. ALL BINS ARE SUMMED)
C     UNIT=WHAT EVER UNIT WAS LAST USED ('PRINTER' INITIALLY)
C
      INCLUDE 'dpmode.INC'
      INCLUDE 'hcom.INC'
C
      INTEGER HPNTR
      REAL*8 DUNIT
      CHARACTER NOUNIT*6,UNIT*8
      CHARACTER*1 XORY,X,Y
      DATA X/'X'/, Y/'Y'/, NOUNIT/'NOUNIT'/
C
      WRITE(XORY,'(A1)') IXORY
C
C
    1 NARG=NARGS()
      CALL DPUPPR(XORY)
      IF(NARG.LT.0) NARG=4
      IF(HPNTR(ID).LE.0) GO TO 30
      IF(M(NODE+5).LT.1.OR.M(NODE+5).GT.2) GO TO 30
      SLICE=1
      SLDIR=0
      IF(XORY.EQ.Y) SLDIR=1
      IF(XORY.EQ.X.OR.XORY.EQ.Y) GO TO 6
C
C  ARG ERROR
      WRITE(LPUNIT,5) XORY
    5 FORMAT(' HSLICE XORY ARG ERR (NOT ''X'' OR ''Y'') =',A3)
    6 CONTINUE
C
      SLBEG=1
      IF(NARG.GE.3) SLBEG=M1
C
      SLWDTH=0
      IF(NARG.GE.4) SLWDTH=NS
C
      IF(NARG.LE.4) GO TO 10
      WRITE(UNIT,'(A8)') DUNIT
C
      IF(UNIT(1:6).EQ.NOUNIT) GO TO 20
      CALL NARGSET(1)
      CALL DPSLCT(DUNIT)
   10 CONTINUE
      CALL NARGSET(1)
      CALL HOUT(ID)
      SLICE=0
      SLFLAG=0
      RETURN
C
   20 MPARM=NODE+M(NODE+10)
      CALL DPSLCI(M(MPARM+5),M(MPARM+9))
   30 SLICE=0
      SLFLAG=0
      RETURN
      END
