      SUBROUTINE HSTAT(ID,JOPT,DAT,M1,M2,M3,M4)
C
C
      REAL DAT(23)
C
C THIS SUBROUTINE CALCULATES THE NUMBER OF CALLS MADE TO, THE
C SUM OF WEIGHTS IN, THE MEAN ,STANDARD DEVIATION, AND HIGH AND
C LOW VALUES OF THE PROJECTIONS (IF 2-D) FOR HIST ID. IF THE
C HISOGRAM IS TWO DIMENSIONAL, THE SUBROUTINE ALSO CALCULATES
C THE COVARIENCE MATRIX, THE CORRELATION COEFFICIENT, THE MAJOR
C AND MINOR AXES AND ANGLE OF THE COVARIENCE ELLIPSE.
C
C     IF  JOPT = 'PRINT'  THEN THE ABOVE STATISTICS ARE
C                         PRINTED OUT.
C     IF  JOPT =  'GET'   THEN THE STATISTICS ARE RETURNED
C                         IN THE ARRAY DAT.
C     IF 'PRINT' OR 'GET' IS PRECEDED BY AN 'X' OR 'Y', THEN A SLICE
C     IS MADE ONTO THE X OR Y AXIS RESPECTIVELY, AND THE SLICE IS
C     OUTPUT THE THE PRINTER OR THE DAT ARRAY. FOR EXAMPLE,
C
C     IF  JOPT = 'XGET'   THEN THE STATISTICS FOR THE SLICE ALONG THE
C                         X AXIS IS RETURNED INTO THE DAT ARRAY.
C
C THE MEANING OF THE ARGUMENTS M1, M2, M3, AND M4 DEPENDS ON OPT.
C   IF A SLICE IS BEING DONE, THEN
C     M1 IS THE FIRST BIN NUMBER TO BE INCLUDED IN THE SLICE
C     M2 IS THE NUMBER OF BINS IN THE WIDTH OF THE SLICE
C      (IF M1 AND M2 ARE NOT SUPPLIED, THEN 1 AND 0 ARE USED INSTEAD)
C     M3 AND M4 SPECIFY THE FIRST AND LAST BINS ALONG THE SLICE OVER
C     OVER WHICH THE STATS ARE TO BE CALCULATED.
C
C   IF NOT A SLICE, THEN
C     M1 AND M2 SPECIFY THE FIRST AND LAST I-BINS OVER WHICH THE
C     STATS ARE TO BE CALCULATED.
C     M3 AMD M4 SPECIFY THE FIRST AND LAST J-BINS OVER WHICH THE
C     STATS ARE TO BE CALCULATED (USED ONLY IF ID IS A 2-D HIST)
C      (IF NOT SUPPLIED, THEN THE FULL HIST LIMITS ARE USED)
C
C NOTE: THE ARRAY DAT NEED NOT BE SUPPLIED IF JOPT IS EQUAL TO
C       'PRINT', HOWEVER IT IS MANDATORY IF HSTAT IS CALLED
C       WITH JOPT EQUAL TO 'GET', 'XGET', OR 'YGET'.
C
C
C  RETURN CODES:
C    IRETCD = 0  - SUCCESSFUL OPERATION
C             1  - HISTOGRAM DOES NOT EXIST
C
C
C
C
C
      INCLUDE 'hcom.INC'
      INCLUDE 'dpmode.INC'
      INCLUDE 'hretcd.INC'
C
      INTEGER ALL,HPAK,HPNTR
      CHARACTER*4 IOPT,PRIN
C
      LOGICAL GET
      CHARACTER*1 LOPT(4)
      EQUIVALENCE (LOPT(1),IOPT)
      CHARACTER*1 X,Y,G
C
      DATA ALL/4HALL /, HPAK/4HHPAK/,PRIN/'PRIN'/
      DATA X,Y,G/'X','Y','G'/
C
C
      IRETCD=0
      NARG=NARGS()
      IF(NARG.LT.0) NARG=2
      IOPT=PRIN
      IF(NARG.GE.2) WRITE(IOPT,'(A4)') JOPT
      CALL DPUPPR(IOPT)
      GET=LOPT(1).EQ.G.OR.LOPT(2).EQ.G
C
C       SAVE SLICE VALUES, RESTORE LATER
      ISLICE=SLICE
      ISLBEG=SLBEG
      ISLWDT=SLWDTH
      ISLDIR=SLDIR
      SLICE=0
      IF(LOPT(1).NE.X.AND.LOPT(1).NE.Y) GO TO 2
C       ITS A SLICE REQUEST
      IF(LOPT(1).EQ.X) SLDIR=0
      IF(LOPT(1).EQ.Y) SLDIR=1
      SLICE=1
      SLBEG=1
      IF(NARG.GE.4) SLBEG=M1
      SLWDTH=0
      IF(NARG.GE.5) SLWDTH=M2
      IF(NARG.GE.6) ISLIM1=M3
      IF(NARG.GE.7) ISLIM2=M4
      GO TO 4
C      IT IS NOT A SLICE, CHECK IF BIN LIMITS ARE SUPPLIED
    2 IF(NARG.GE.4) ISLIM1=M1
      IF(NARG.GE.5) ISLIM2=M2
      IF(NARG.GE.6) ISLIM3=M3
      IF(NARG.GE.7) ISLIM4=M4
C
C
C
    4 IF(ID.EQ.ALL) GO TO 5
      IF(HPNTR(ID).LE.0) THEN
         IRETCD=1
         GO TO 200
      ENDIF
      NOUT=1
      GO TO 10
    5 IF(HPNEW.NE.HPAK) CALL HINIT(2000)
      IF(NNODES.LE.0) THEN
         IRETCD=1
         GO TO 200
      ENDIF
      CALL DWRHDR(LPUNIT,.TRUE.)
      NOUT=NNODES
      NODE=NODE1
C
C
C      BORROW VARIABLES IN /DPMODE/, RESTORE WHEN FINISHED
   10 JPLOT=IPLOT
      JSTATS=ISTATS
      JDEV=IDEV
      JDARG=IDARG
C
      IPLOT=0
      ISTATS=2
      IF(.NOT.GET) ISTATS=3
      IDEV=2
      IF(.NOT.GET) WRITE(LPUNIT,50)
   50 FORMAT(/,10X,'HISTOGRAM STATISTICS FROM HSTAT'/'  ID')
C
      DO 100 INOD=1,NOUT
      CALL NARGSET(1)
      CALL HEXEC(M(NODE+4))
      IF(ID.EQ.ALL) NODE=M(NODE+3)
  100 CONTINUE
C
C       RESTORE /DPMODE/
      IDARG=JDARG
      IDEV=JDEV
      IPLOT=JPLOT
      ISTATS=JSTATS
C
      IF(.NOT.GET) GO TO 200
C
C       RETURN STATISTICS INTO DAT (IF IT IS THERE)
      IF(NARG.LE.2) GO TO 200
C
      DAT(1)=SUM1
      DAT(2)=SUMW
      DAT(3)=XAVG
      DAT(4)=XSIG
      DAT(5)=XMNX(1)
      DAT(6)=XMNX(2)
      DAT(7)=0
      DAT(8)=0
      DAT(9)=0.
      DAT(10)=0.
      IF(M(NODE+5).NE.2.OR.SLICE.NE.0) GO TO 200
C
      DAT(9)=YAVG
      DAT(10)=YSIG
      DAT(11)=YMNX(1)
      DAT(12)=YMNX(2)
      DAT(13)=0.
      DAT(14)=0.
      DAT(15)=XSIG*XSIG
      DAT(16)=XSIG*YSIG*CORREL
      DAT(17)=DAT(16)
      DAT(18)=YSIG*YSIG
      DAT(19)=CORREL
      DAT(20)=0.
      DAT(21)=ELIPSE(1)
      DAT(22)=ELIPSE(2)
      DAT(23)=ELIPSE(3)
C
C       RESTORE SLICE VARIABLES BEFORE RETURNING
C
  200 SLICE=ISLICE
      SLBEG=ISLBEG
      SLWDTH=ISLWDT
      SLDIR=ISLDIR
      ISLIM1=0
      ISLIM2=0
      ISLIM3=0
      ISLIM4=0
      RETURN
C
      END
