      SUBROUTINE HSTLBL3(I,J,XEND,YEND,LBL,EXPFLAG)
C----------------------------------------------------------------------
C
C     PROGRAMMER: GREGORY JOHN
C     SUPERVISOR: RICHARD DUBOIS
C      REFERENCE: ADAM BOYARSKI
C           DATE: OCTOBER 5, 1988.
C
C----------------------------------------------------------------------
C
C     AFTER HOUTING A 3D HISTOGRAM THIS SUBROUTINE LABELS BIN I,J WITH
C       TEXT LABEL LBL AT 2D COORDINATES X,Y.
C     ALL PARAMETER TO THIS ROUTINE ARE INPUT ROUTINES.
C     THIS SUBROUTINE CALLS: HX, H2Y, HZ
C                            DP3LIN, DGLIN, DPTXT, DPICT
C     THIS SUBROUTINE DEFINES VARIABLES THAT ARE SIMILARLY DEFINED IN
C       DPGR2 AND IF A. BOYARSKI CHANGES THEM IT IS ADVISED THAT THEY
C       ALSO BE CHANGED HERE.  THEY ARE:
C                            FRAMSZ DEFINED AS 0.4
C                            CORNER DEFINED AS 0.55 - 0.5*FRAMESZ
C     IF EXPFLAG = 0 THEN THE ABOVE IS DONE,
C                = 1 THEN THE EXPONENT FOR THE Z TIC MARKS IS RETURNED
C                         IN EXPFLAG.
C     HANDYPAK COMMON BLOCKS USED ARE DCOM3D AND DPMODE.
C
C----------------------------------------------------------------------
 
 
      INCLUDE 'dpmode.INC'
      INCLUDE 'dcom3d.INC'
C
C------------------------------------------------------------------------
C     VARIABLES
C------------------------------------------------------------------------
      INTEGER I,J
      INTEGER EXPFLAG
      REAL    XEND,YEND
      CHARACTER*(*) LBL
      REAL    FRAMSZ(3),CORNER(2,1)
 
      REAL    HX,H2Y,HZ
 
      REAL    XTC,YTC,ZTC
      REAL    PDX,PDY,PDZ
      REAL    XOFS,YOFS
 
      DATA FRAMSZ/3*0.4/
 
C
C CHECK IF EXPFLAG = 1 CASE:
C
      IF (EXPFLAG.EQ.1) THEN
            EXPFLAG = MOD((ISCALE(3,3)+500),1000) - 500
            RETURN
      END IF
 
C
C DEFINE CORNERS
C
      CORNER(1,1) = 0.55 - 0.5*FRAMSZ(1)
      CORNER(2,1) = 0.55 - 0.5*FRAMSZ(2)
 
C
C CALCULATE SCALING FACTORS PDX, PDY, AND PDZ.
C
      PDX = FRAMSZ(1)/ASCALE(3,1)/ASCALE(2,1)
      PDY = FRAMSZ(2)/ASCALE(3,2)/ASCALE(2,2)
      PDZ = FRAMSZ(3)/ASCALE(3,3)/ASCALE(2,3)
 
C
C DEFINE OFFSETS
C
      XOFS = (HX(2) - HX(1)) * PDX / 2
      YOFS = (H2Y(2) - H2Y(1)) * PDY / 2
 
C
C CONVERT BIN NUMBERS TO 3D COORDINATES OF THE TOP CENTRE OF THE
C   HISTOGRAM BIN.
C
      XTC = (HX(I)  - ASCALE(1,1)) * PDX + CORNER(1,1) + XOFS
      YTC = (H2Y(J) - ASCALE(1,2)) * PDY + CORNER(2,1) + YOFS
      ZTC =  HZ(I,J)               * PDZ
 
C
C SET BEGINNING OF LINE TO (XTC,YTC,ZTC) THE TOP CENTRE,
C THEN DRAW THE LINE TO THE 2D END COORDINATES,
C FINALLY LABEL WITH LBL.
C
       CALL DP3LIN(0,XTC,YTC,ZTC)
       CALL DGLIN(XPRO,YPRO,0)
       CALL DGLIN(XEND,YEND,1)
       CALL DPTXT(LBL,XEND,YEND,4HSIZE,0.03)
 
       RETURN
       END
