      FUNCTION HYE(I,IER,IXYER)
C
C   **MEMBER**  HYE
C
C  THE FUNCTION RETURNS THE FOLLOWING VALUES:
C
C     HYE(I,IER) ERROR FOR BIN I FOR A 1-D HIST,
C                IER=1 FOR UPPER ERROR, IER=2 FOR LOWER (FOR EFF, ASM)
C
      INCLUDE 'hcom.INC'
      INCLUDE 'nargcom.INC'
C
      LOGICAL LW4
      EQUIVALENCE (LW4,IW)
C
      DATA MAXMS/15/
C
C
      IF(M(NODE+5).NE.1) GO TO 900
      IMS=MAXMS
      NARG=NARGS()-NARG0F
      IF(NARG.LT.0) NARG=1
      IF(NARG.LE.2) GO TO 6
      IF(IXYER.NE.2) GO TO 6
C  X ERROR REQUESTED
      MPARM=NODE+M(NODE+10)
      HYE=R(MPARM+7)/2.0
      RETURN
C
    6 MPARM=NODE+M(NODE+10)
      MBINS=NODE+M(NODE+12)
      HYE=0.
      IF(I.LT.1.OR.I.GT.M(MPARM+5)) RETURN
      IBIN=I
    8 IMS=M(MPARM+1)
      MDISP=NODE+M(NODE+14)
      RNORM=R(MDISP+1)
      IALT=M(MDISP+6)
      GO TO (210,220,230,240,250,260,270,280, 90,100,
     >       110, 90,100,110,350),IMS
      RETURN
C
C       L*1  ERROR
C
  210 LW4=L(4*MBINS+IBIN)
      HYE=IW
      GO TO 400
C
C       I*2  ERROR
C
  220 HYE=H(2*MBINS+IBIN)
      GO TO 400
C
C       I*4  ERROR
C
  230 HYE=M(MBINS+IBIN)
      GO TO 400
C
C       R*4  ERROR
C
  240 HYE=R(MBINS+IBIN)
      GO TO 400
C
C       E*4  ERROR
C
  250 HYE=R(MBINS+2*IBIN)
      GO TO 410
C
C       M*4  ERROR
C
  260 HYE=SQRT(AMAX1(0.,R(MBINS+2*IBIN)/RNORM))
      RETURN
C
C       WEV  ERROR
C
  270 HYE=R(MBINS+2*IBIN)
      GO TO 410
C
C       A*4 ERROR
C
  280 HYE=R(MBINS+3*IBIN-1)
      IF(IALT.EQ.1) HYE=HYE/AMAX1(1.0,R(MBINS+3*IBIN))
      IF(IALT.EQ.2) HYE=R(MBINS+3*IBIN)
      IF(IALT.EQ.3) HYE=2.*HYE**2/AMAX1(1.0,R(MBINS+3*IBIN))
      IF(IALT.EQ.4) THEN
         HY=R(MBINS+3*IBIN-1)
         HYE=2.*HYE**2/AMAX1(1.0,R(MBINS+3*IBIN))
         IF(IER.EQ.1) THEN
            HYE=SQRT(HY+HYE)-SQRT(HY)
         ELSE
            HYE=SQRT(HY)-SQRT(AMAX1(0.,(HY-HYE)))
         ENDIF
      ENDIF
      GO TO 410
C
C
C       EFF VALUE AND ASM VALUE
C
   90 K=MBINS+2*IBIN
      R1TEMP=R(K-1)
      R2TEMP=R(K)
      GO TO 120
C
  100 K=2*MBINS+2*IBIN
      R1TEMP=H(K-1)
      R2TEMP=H(K)
      GO TO 120
C
  110 K=4*MBINS+2*IBIN
      LW4=L(K-1)
      R1TEMP=IW
      LW4=L(K)
      R2TEMP=IW
C
  120 HYE=0.
      IF(IALT.GT.0) GO TO 140
      IF(R2TEMP.LE.0.) RETURN
      HYE=R1TEMP/R2TEMP
  130 CONTINUE
      JER=1
      IF(NARG.GE.2) JER=IER
      HYE=H95CL(R1TEMP,R2TEMP,JER)
  135 IF(IMS.GE.12) HYE=2.*HYE
      RETURN
C
C       RETURN HITS, MISSES, OR TOTAL TRIALS FOR EFF OR ASM
  140 IF(IALT.EQ.1) HYE=R1TEMP
      IF(IALT.EQ.2) HYE=R2TEMP-R1TEMP
      IF(IALT.EQ.3) HYE=R2TEMP
      GO TO 400
C
C        LPT ERROR (NOT ALLOWED)
C
  350 HYE=0.
      RETURN
C
C
  400 HYE=AMAX1(R(MDISP+5),HYE)
  410 HYE=SQRT(AMAX1(0.,HYE))
  500 HYE=HYE/RNORM
      RETURN
C
C       ERROR - THIS IS NOT A 1-D OR 2-D HIST
  900 HYE=9999.
      RETURN
C
      END
