      COMMON /HCOM/ HCOM(3000)

      REAL MASS2(3)
      DATA MASS2/0.02,0.25,0.88/

      REAL AX(25,2),AY(25,2),AYE(25,2),S(8),SF1(8)
      DATA S/4*0.,0.,10.,4.,5./
      DATA SF1/0.,.5,6.,5.,0.,10.,5.,2./

      REAL CX(20),CY(20),CE(20,2,2)

       DATA FOR BINARY PROPORTIONS
      INTEGER TRIALS(20),SUCCES(20)
      DATA TRIALS/2*4,3*15,8*60,7*400/
      DATA SUCCES/0,1,1,2,3,2,5,15,30,45,55,58,60,
     >           390,380,350,200,50,20,10/

      EXTERNAL FX,FY,FYE,VY,GX,GY,GZ,GZE,F1,F1A,F2

      GAUSS(X)=SQRT(-2.*ALOG(RAN(II,JJ)))*
     >         COS(2.*3.14159*RAN(II,JJ))
C  GUASS IS A NORMALLY DISTRIBUTED RANDOM VARIABLE WITH ZERO
C  MEAN AND UNIT VARIANCE, AND RAN1 IS A RANDOM NUMBER IN
C  RANGE 0. TO 1.0


C  SET DENSE OPTION FOR LASER PRINTER
      CALL DOPT('LINDEN',.TRUE.)

C  INITIIALIZE HISTOGRAM BUFFER
      CALL HINIT(3000)
      CALL DOPT('OVPRT',0)


C  FIGURE 1.1 AND 1.2
C  -------------------------
C
C  1-D HISTOGRAM PLOTS TO LINE PRINTER AND GRAPHIC DEVICES,
C  WITH DEFAULT SETTINGS OF OPTIONS

      CALL HDEF1(1,'I*2 ',32,-4.0,0.25,
     >          'EXPT-A;DEVIATION;FREQ@')
C  (ALSO GENERATE STATISTICAL SUMS, OUTPUTTED LATER)
      CALL HOPTN('STATS',.TRUE.,1)
      CALL HOPTN('SOUT',.FALSE.,1)
      DO 10 I=1,500
   10 CALL HCUM1(1,GAUSS(X),1.0)
      CALL HOUT(1)
C  MAKE AN LBP PLOT
      CALL HOUT(1,'TEK4010 ')

C  FIGURE 5.1 AND 5.2
C  ------------------
C
C  ADD ANALYTIC CURVE TO ABOVE 1-D HISTOGRAMS
      CALL HOPTN('FUNC',F1,1)
C  USE 5 TIC INTERVALS ALONG X AXIS
      CALL DOPT('XTIC',5)
      CALL HOUT(1,'TEK4010 ')
      CALL HOUT(1,%REF('TEK4010 '))
      CALL HOUT(1,'PRINTER')
      CALL HOUT(1,'LASER   ')


C  FIGURE 5.3 AND 5.4
C  ------------------
C
C  USE LOG SCALE FOR Y AXIS FOR ABOVE 1-D HISTOGRAM
      CALL DOPT('YLOG',.TRUE.)
C  (ALSO TURN ON THE NUMBER OF CALLS OUTPUT)
      CALL DOPT('NCALLS',.TRUE.)
C  AND USE FULL DATA SCALING FOR X AXIS
      CALL DOPT('XAUTO',2)
      CALL HOUT(1,'PRINTER ')
      CALL HOUT(1,'LASER   ')
      CALL HOUT(1,%REF('TEK4010 '))
      CALL HOUT(1,'TEK4010 ')
      CALL DOPT('YLOG',.FALSE.)


C  FIGURE 5.5 AND 5.6
C  ------------------
C
C  USE MANUAL SCALE FACTORS FOR ABOVE 1-D HISTOGRAM
C  (STORE THEM SO HOUT CAN GET THEM)

      CALL HOPTN('HMSCAL',S,1)
C  THEN SELECT THE MANUAL SCALES OPTION FOR Y
      CALL DOPT('YAUTO',0)
C  (ALSO TURN OFF THE 'ID=' FONT)
      CALL DOPT('IDFONT',.FALSE.)
      CALL HOUT(1,'PRINTER ')
      CALL HOUT(1,'LASER   ')
      CALL HOUT(1,%REF('TEK4010 '))
      CALL HOUT(1,'TEK4010 ')
      CALL DOPT('YAUTO',1)
      CALL DOPT('IDFONT',.TRUE.)


C  FIGURE 5.7 THROUGH 5.10
C  -----------------------
C
C  1-D UNDERFLOWS AND OVERFLOWS - TWO METHODS
C  GENERATE TWO 1-D HISTS, ONE WITH OVERFLOWS IN EDGE BINS,
C  AND ANOTHER WITH OVERFLOWS OMITTED FROM EDGE BINS

      CALL HDEF1('1A  ','R*4 ',32,-4.0,0.25,
     > '1-D, DEFAULT OVERFLOWS;DEVIATION;FREQ@')
      CALL HDEF1('1B  ','R*4 ',32,-4.0,0.25,
     > '1-D, NO OVERFLOWS IN EDGE BINS;DEVIATION;FREQ@')
      CALL HOPTN('HOMIT',.TRUE.,'1B  ')
C  ALSO TURN ON STATISTICS FOR ONE CASE
      CALL HOPTN('STAT',.TRUE.,'1A  ')
      CALL HOPTN('SOMIT',.TRUE.,'1A  ')
C  OTHER CASE WILL USE STATS FROM BINS
      CALL HOPTN('SOUT',.TRUE.,'1B  ')

C  GENERATE IDENTICAL GAUSSIAN DISTRIBUTIONS WITH
C  BACKGROUND IN EACH HISTOGRAM
      DO 20 I=1,500
      RX=GAUSS(X)
      BX=100.*(RAN(II,JJ)-.2)
      CALL HCUM1('1A  ',BX,0.5)
      CALL HCUM1('1B  ',BX,0.5)
      CALL HCUM1('1A  ',RX,1.0)
   20 CALL HCUM1('1B  ',RX,1.0)
C  TURN ON NUMBER OF CALLS
      CALL DOPT('NCALLS',.TRUE.)
C  OUTPUT THE DEFAULT CASE (OVERFLOWS IN EDGE BINS)
       CALL HOUT('1A  ','PRINTER ')
       CALL HOUT('1A  ','LASER   ')
       CALL HOUT(1,%REF('TEK4010 '))
       CALL HOUT(1,'TEK4010 ')
C  OUTPUT THE ALTERNATE CASE
      CALL DOPT('OMIT',.FALSE.)
      CALL HOUT('1B  ','PRINTER ')
      CALL HOUT('1B  ','LASER   ')
      CALL HOUT(1,%REF('TEK4010 '))
      CALL HOUT('1B  ','TEK4010 ')
      CALL DOPT('OMIT',.TRUE.)


C  FIGURE 5.11 AND 5.12
C  ------------------
C
C  DUT1 EXAMPLE, USING NORMAL AUTO SCALES
C  (ALSO TURN TICS INWARD IN 1-D GRAPHIC PLOTS)

      CALL DOPT('TICDIR',.TRUE.)

      CALL HOUT(1,%REF('TEK4010 '))
      CALL DPSLCT('TEK4010 ')
      CALL DUT1(FX,FY,FYE,30,'DUT1 WITH NORMAL AUTO SCALING@')

C  DUT1 EXAMPLE, USING A FORCED ZERO ON Y AXIS

      CALL DOPT('YZERO',.TRUE.)
      CALL DUT1(FX,FY,FYE,30,'DUT1, FORCED ZERO ON Y AXIS@')
      CALL DOPT('YZERO',.FALSE.)
      CALL DOPT('TICDIR',.FALSE.)


C  FIGURE 5.13 AND 5.14
C  --------------------------

C  2-D PLOTS TO LINE PRINTER AND GRAPHIC DEVICE,
C  WITH DEFAULT SETTINGS OF OPTIONS (EXCEPT FOR SCALING).
C
C  SET AUTO SCALING IN FULL DATA MODE FOR X AND Y
      CALL DOPT('XAUTO',2)
      CALL DOPT('Y2AUTO',2)
      CALL DPSLCT('PRINTER ')
      CALL DUT2(GX,GY,GZ,GZE,24,12,
     >        '2-D PLOT BY DUT2@')
      CALL DPSLCT('TEK4010')
      CALL DUT2(GX,GY,GZ,GZE,24,12,
     >       '2-D PLOT BY DUT2@')


C  FIGURE 5.15 AND 5.16
C  ---------------------------
C
C  2-D SCATTERPLOTS
C   1. DEFINE THEM

      CALL HDEF2('SCT1','I*2S',30,40,-.25,0.,0.05,0.05,
     > 'SCATTER PLOT;SQUARED MASS;MOMENTUM;COUNTS@')
      CALL HDEF2('SCT2','I*2S',1,1,0.,0.,1.2,1.2,
     > 'BETA VS P;MOMENTUM;BETA@')

C   2. FILL THEM UP

      DO 100 I=1,2500
      E=-ALOG(RAN(II,JJ))*.50
      R=RAN(II,JJ)
      M=1
      IF(R.GT.0.5) M=2
      IF(R.GT.0.8) M=3
      IF(E*E.LE.MASS2(M)) GO TO 100
      P=SQRT(E*E-MASS2(M))
      T=5.*E/P + .30*GAUSS(X)
      P=P + .01*P*SQRT(P*P+2.)*GAUSS(X)
      IF(P.LT.0.1) GO TO 100
      E=P*T/5.
      AM2=E*E-P*P
      CALL HCUM2('SCT1',AM2,P,1.0)
      BETA=P/E
      CALL HCUM2('SCT2',P,BETA,1.0)
  100 CONTINUE

C   3. OUTPUT THE 'SCT1' SCATTERPLOT ('SCT2' DONE LATER)
C  (ONE COLUMN WIDE PER BIN, 16 SYMBOLS IN Z, AND A CONTOUR)

      CALL DOPT('L2COL',1)
      CALL DOPT('L2SYM',16)
      CALL HOPTN('CONTOUR',F2,'SCT1')
      CALL HOUT('SCT1','PRINTER ')
      CALL DOPT('TICDIR',.TRUE.)
      CALL HOUT('SCT1','LASER   ')
      CALL HOUT('SCT1','TEK4010 ')
      CALL HOUT(1,%REF('TEK4010 '))


C  FIGURE 5.17
C  -----------
C
C  SAME SCATTER PLOT, BUT USING AUTO Z AND AUTOC SCALING

      CALL DOPT('L2ZAUT',.TRUE.)
      CALL DOPT('L2CAUT',.TRUE.)
      CALL DOPT('L2SYM',10)
      CALL HOUT(1,%REF('TEK4010 '))
      CALL HOUT('SCT1','TEK4010')


C  FIGURE 5.18
C  -----------
C
C  SAME SCATTER PLOT, BUT USING LOGSCALING FOR Z AXIS

      CALL DOPT('YLOG',.TRUE.)
      CALL DOPT('L2ZAUT',.FALSE.)
      CALL DOPT('L2CAUT',.FALSE.)
      CALL HOUT(1,%REF('TEK4010 '))
      CALL HOUT('SCT1','TEK4010 ')
      CALL DOPT('YLOG',.FALSE.)


C  FIGURE 5.19 AND 5.20
C  ---------------------------
C
C  2-D UNDERFLOWS AND OVERFLOWS - TWO METHODS
C  GENERATE TWO 2-D HISTS, ONE WITH OVERFLOWS IN EDGE BINS,
C  AND ANOTHER WITH OVERFLOWS OMITTED FROM EDGE BINS

      CALL HDEF2('2A  ','I*2 ',25,40,-5.0,-4.0,.4,.2,
     >                  '2-D HIST, DEFAULT OVERFLOWS@')
      CALL HDEF2('2B  ','I*2 ',25,40,-5.0,-4.0,.4,.2,
     >                  '2-D HIST, OVERFLOWS OMITTED@')
C  ALSO TURN ON STATS IN ONE CASE, USE BINS IN OTHER
      CALL HOPTN('SOUT',.TRUE.,'2A  ')
      CALL HOPTN('STAT',.TRUE.,'2B  ')
      CALL HOPTN('SOMIT',.TRUE.,'2B  ')
      CALL HOPTN('HOMIT',.TRUE.,'2B  ')
      DO 50 I=1,1000
      R1=GAUSS(X)
      R2=GAUSS(X)
      RX=R1+.5*R2
      RY=R2
C  ADD A FLAT BACKGROUND TO THE GAUSSIAN
      BX=100.*(RAN(II,JJ)-.5)
      BY=100.*(RAN(II,JJ)-.5)
      CALL HCUM2('2A  ',BX,BY,1.0)
      CALL HCUM2('2B  ',BX,BY,1.0)
      CALL HCUM2('2A  ',RX,RY,1.0)
   50 CALL HCUM2('2B  ',RX,RY,1.0)

C  2-D PRINTER PLOT WITH NUMBER OF CALLS
      CALL HOUT('2A  ',%REF('TEK4010 '))
      CALL HOUT('2A  ','TEK4010')
      CALL HOUT('2B  ')
      CALL DOPT('NCALLS',.FALSE.)


C  FIGURE 5.21 AND 5.22
C  ---------------------------
C
C  USE SLICES FROM SCT1 TO FILL AX,AY,AYE FOR MULTI-PLOT

      CALL HSLICE('SCT1','Y',5,5,'NOUNIT  ')
      DO 120 I=1,25
      AX(I,1)=H2Y(I)
      AY(I,1)=HFSLC(I)
  120 AYE(I,1)=HERSLC(I)
      CALL HSLICE('SCT1','Y',15,15,'NOUNIT  ')
      DO 130 I=1,25
      AX(I,2)=H2Y(I)
      AY(I,2)=HFSLC(I)
  130 AYE(I,2)=HERSLC(I)
      N2=2025
      CALL DOPT('LINE',1)
      CALL DPSLCT('PRINTER ')
      CALL DUT1A(AX,AY,AYE,N2,
     >'DUT1A MULTI-PLOT PLUS A FUNCTION;ENERGY;COUNTS@',S,F1A)
      CALL DPSLCT('TEK4010')
      CALL DUT1A(AX,AY,AYE,N2,
     >'DUT1A MULTI-PLOT PLUS A FUNCTION;ENERGY;COUNTS@',S,F1A)


C  FIGURE 5.23
C  -----------
C
C  USE DUT1 WITH ONLY A FUNCTION (NO DATA POINTS)

      CALL DUT1(0,0,0,0,
     >'DUT1 WITH FUNCTION ONLY, NO DATA POINTS@',SF1,F1)


C  FIGURE 5.24
C  -----------
C
C  SLICE A 2-D INTO A 1-D LINE PRINTER PLOT
C  (BAR GRAPH, NO ERROR BARS, AND 4 Y TIC INTERVALS)

      CALL DPSLCT('TEK4010 ')
      CALL DOPT('HIST',.TRUE.)
      CALL DOPT('ERROR',0)
      CALL DOPT('YTIC',4)
      CALL HSLICE('SCT1','X',10,9)


C  FIGURE 5.25a and FIGURE 5.25b
C  -----------------------------
C
C  OVERPLOT FOUR PLOTS (ONE PER QUADRANT)  ON GRAPHIC DEVICE
C      A) USING DEFAULT (FIXED) CHARACTER SIZE
C      B) SCALING CHARACTER SIZE WITH THE PLOT SIZE

      DO 350 I=1,2
      CALL DOPT('CHSCALE',I-1)
C   (TOP LEFT QUADRANT)

      CALL DPSLCT('TEK4010 ')
      CALL DOPT('QUAD','TL')
      CALL DOPT('RESCALE',.TRUE.)
      CALL DOPT('TICDIR',.TRUE.)
      CALL DOPT('OVER',.TRUE.)
      CALL DOPT('XTIC',4)
      CALL DOPT('YTIC',4)
      CALL DOPT('LINE',1)
      CALL HSLICE('SCT1','X',10,9)

C   (TOP RIGHT QUADRANT)
      CALL DOPT('QUAD','TR')
      CALL DOPT('LINE',2)
      CALL DOPT('CHAR','    ')
      CALL HSLICE('SCT1','X',10,9)

C   (BOTTOM LEFT QUADRANT)
      CALL DOPT('QUAD','BL')
      CALL HOUT('SCT2')

C   (BOTTOM RIGHT QUADRANT)
      CALL DOPT('QUAD','BR')
      CALL DOPT('XLOG',.TRUE.)
      CALL DOPT('YLOG',.TRUE.)
      CALL DOPT('LINE',0)
      CALL DOPT('CHAR','+   ')
      CALL DUT1(FX,VY,FYE,30,'DUT1 LOG-LOG PLOT@')
      CALL DOPT('OVER',.FALSE.)
      CALL DOPT('XLOG',.FALSE.)
      CALL DOPT('YLOG',.FALSE.)
  350 CONTINUE
      CALL DOPT('CHSCALE',0)


C  FIGURE 5.26
C  -----------
C
C  MAKE TWO BUTTING HALF FRAME PLOTS ONTO GRAPHIC DEVICE

      CALL DOPT('QUAD','T ')
      CALL DOPT('BMARG',0.)
      CALL DOPT('OVER',.TRUE.)
      CALL DOPT('LINE',2)
      CALL DOPT('ERROR',1)
      CALL DOPT('CHAR','    ')
      CALL DOPT('XTIC',8)
      CALL DOPT('YTIC',4)
      CALL HSLICE('SCT1','X',10,6)
      CALL DOPT('QUAD','B ')
      CALL DOPT('BMARG',.1)
      CALL DOPT('TMARG',0.)
      CALL HSLICE('SCT1','X',15,30)
      CALL DOPT('TMARG',-.1)
      CALL DOPT('OVER',.FALSE.)


C  FIGURE 5.27
C  -----------
C
C  MAKE TWO DISJOINT HALF FRAME PLOTS ONTO GRAPHIC DEVICE

      CALL DOPT('OVER',.TRUE.)
      CALL DOPT('ERROR',0)
      CALL DOPT('QUAD','L ')
      CALL DOPT('XTIC',4)
      CALL DOPT('YTIC',5)
      CALL HSLICE('SCT1','Y',5,5)
      CALL DOPT('QUAD','R ')
      CALL HSLICE('SCT1','Y',10,5)
      CALL DOPT('QUAD',0)
      CALL DOPT('OVER',.FALSE.)


C  FIGURE 5.28
C  -----------
C
C  GENERATE DIRECTORY OF ALL HISTOGRAMS

      CALL HGET('ALL ')


C  FIGURE 5.29
C  -----------
C
C  GENERATE A SMOOTH CURVE FOR THE DATA POINTS
C
C  FIRST, RESET ALL OPTIONS TO THEIR DEFAULTS
      CALL DOPT('RES,ALL ')
      CALL HOPTN('RES,NFUN',0,'SCT1')
C  SET THE SMOOTH OPTION, WITH A 1.1 BIN WIDTH SIGMA
      CALL DOPT('SMOOTH',.TRUE.)
      CALL DOPT('WSMOOTH',1.1)
C  USE EDGE BINS ALSO
      CALL DOPT('OMIT',.FALSE.)
      CALL DOPT('XTIC',4)
      CALL HSLICE('SCT1','X',11,15,%REF('TEK4010'))
      CALL DOPT('SMOOTH',.FALSE.)


C  FIGURE 5.30
C  -----------
C
C  GENERATE A PLOT OF PROPORTIONS (EFFECIENCIES)

      CALL HDEF1('PRP1','EFF ',20,1.0,1.0,
     >           'PROPORTIONS, WITH 95% CONFIDENCE LIMITS@')
      DO 400 I=1,20
      N=TRIALS(I)
      IF(N.LE.0) GO TO 400
      DO 390 J=1,N
      W=0.
      IF(SUCCES(I).GE.J) W=1.0
  390 CALL HCUM1('PRP1',I-1.0,W)
  400 CONTINUE
      CALL HOUT('PRP1',%REF('TEK4010'))


C  FIGURE 5.31
C  -----------
C
C  1-D PLOT WITH SYMMETRIC ERROS IN X, ASYMMETRIC IN Y

      CALL DOPT('ERROR',6)
      DO 500 I=1,20
C  USE DATA FROM HISTOGRAM IN FIGURE 5.30 AS INPUT
      CX(I)=HX(I)
      CY(I)=HY(I)
C  FILL Y ERRORS (UPPER AND LOWER)
      CE(I,1,1)=HYE(I,1)
      CE(I,2,1)=HYE(I,2)
C  FILL X ERRORS WITH NOMINAL VALUES
  500 CE(I,1,2)=.20
C  AND MAKE THE PLOT
      CALL DPSLCT('TEK4010')
      CALL DUT1A(CX,CY,CE,20,'ERRORS IN X AND Y@')

C  CLOSE ALL GRAPHIC DEVICES
      CALL DPCLOS
      STOP
      END

C  FUNCTIONS FOR THE EXAMPLES

      FUNCTION FX(I)
      FX=0.1*I
      RETURN

      ENTRY FY(I)
      FY=10. + AMOD(I*I/100.,1.0)
      RETURN

      ENTRY VY(I)
      VY=10.*EXP(-(I-15)**2/10.) + 1.0/((I-15.)**2+1.0)
      RETURN

      ENTRY FYE(I)
      FYE=0.1
      RETURN

      ENTRY GX(I)
      GX=(I-12.0)/5.0
      RETURN

      ENTRY GY(J)
      GY=(J-6.0)/2.
      RETURN

      ENTRY GZ(I,J)
      GZ=100.*EXP(-(I-12)**2/15. - (J-6)**2/5.
     >          -(I-12)*(J-6)/10.)
      RETURN

      ENTRY GZE(I,J)
      GZE=0.
      RETURN

      ENTRY F1(X,I)
      F1=500.*0.25*0.39894*EXP(-X*X/2.0)
      RETURN

      ENTRY F1A(X,I)
      F1A=125.*EXP(-(X+.025)/.50)
      RETURN

      ENTRY F2(X,Y,I)
      F2=((X-.88)/.25)**2 + ((Y-0.6)/.5)**2 - 1.0
      RETURN
      END
      FUNCTION RAN(II,JJ)
      RAN=RN()
      RETURN
      END
